-- $Source: /home/harp/1/proto/monoBANK/xbind/motif-cutpaste.ads,v $ 
-- $Revision: 1.4 $ $Date: 95/12/19 15:35:05 $ $Author: mg $ 

-- --------------------------------------------------------------------------
-- THIS FILE AND ANY ASSOCIATED DOCUMENTATION IS PROVIDED "AS IS" WITHOUT 
-- WARRANTY OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
-- TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A 
-- PARTICULAR PURPOSE.  The user assumes the entire risk as to the accuracy 
-- and the use of this file.  
--  
-- Ada version Copyright (c) Intermetrics, Inc. 1994 
-- Royalty-free, unlimited, worldwide, non-exclusive use, modification, 
-- reproduction and further distribution of this Ada file is permitted. 
--
-- C version contains additional copyrights, 
-- see the accompanying file CutPaste.h.
-- --------------------------------------------------------------------------

with Interfaces.C;
with X;
with Motif.Xm;
with X.Strings;
with X.Xlib;
with Xt.Intrinsic;

package Motif.CutPaste is

    XmClipboardFail                 : constant := 0;        -- CutPaste.h:27
    XmClipboardSuccess              : constant := 1;        -- CutPaste.h:28
    XmClipboardTruncate             : constant := 2;        -- CutPaste.h:29
    XmClipboardLocked               : constant := 4;        -- CutPaste.h:30
    XmClipboardBadFormat            : constant := 5;        -- CutPaste.h:31
    XmClipboardNoData               : constant := 6;        -- CutPaste.h:32
    ClipboardFail                   : constant := 0;        -- CutPaste.h:36
    ClipboardSuccess                : constant := 1;        -- CutPaste.h:37
    ClipboardTruncate               : constant := 2;        -- CutPaste.h:38
    ClipboardLocked                 : constant := 4;        -- CutPaste.h:39
    ClipboardBadFormat              : constant := 5;        -- CutPaste.h:40
    ClipboardNoData                 : constant := 6;        -- CutPaste.h:41

    type XmClipboardPendingRec;                             -- CutPaste.h:46

    type XmClipboardPendingList is access all XmClipboardPendingRec;
                                                            -- CutPaste.h:46

    type XmClipboardPendingRec is                           -- CutPaste.h:46
        record
            DataId   : X.long;                              -- CutPaste.h:44
            PrivateId: X.long;                              -- CutPaste.h:45
        end record;

    type XmCutPasteProc is access procedure (
                w         : Xt.Intrinsic.Widget;
                data_id   : access X.long;
                private_id: access X.long;
                reason    : access X.signed_int);           -- CutPaste.h:52


    type VoidProc is access procedure (
                w         : Xt.Intrinsic.Widget;
                data_id   : access X.signed_int;
                private_id: access X.signed_int;
                reason    : access X.signed_int);           -- CutPaste.h:54


    function XmClipboardBeginCopy(
                display : access X.Xlib.Display;
                window  : X.Window;
                label   : Motif.Xm.XmString;
                widget  : Xt.Intrinsic.Widget;
                callback: VoidProc;
                itemid  : access X.long)
               return X.signed_int;                         -- CutPaste.h:83

    function XmClipboardStartCopy(
                display  : access X.Xlib.Display;
                window   : X.Window;
                label    : Motif.Xm.XmString;
                timestamp: X.Time;
                widget   : Xt.Intrinsic.Widget;
                callback : XmCutPasteProc;
                itemid   : access X.long)
               return X.signed_int;                         -- CutPaste.h:90

    function XmClipboardCopy(
                display   : access X.Xlib.Display;
                window    : X.Window;
                itemid    : X.long;
                format    : X.Strings.const_charp;
                buffer    : Xt.Intrinsic.XtPointer;
                length    : X.unsigned_long;
                private_id: X.long;
                dataid    : access X.long)
               return X.signed_int;                         -- CutPaste.h:98

    pragma Import(C, XmClipboardCopy, "XmClipboardCopy");

    function XmClipboardCopy(
                display   : access X.Xlib.Display;
                window    : X.Window;
                itemid    : X.long;
                format    : Interfaces.C.Char_Array;
                buffer    : Xt.Intrinsic.XtPointer;
                length    : X.unsigned_long;
                private_id: X.long;
                dataid    : access X.long)
               return X.signed_int;                         -- CutPaste.h:98

    pragma Inline(XmClipboardCopy);

    function XmClipboardEndCopy(
                display: access X.Xlib.Display;
                window : X.Window;
                itemid : X.long)
               return X.signed_int;                         -- CutPaste.h:107

    function XmClipboardCancelCopy(
                display: access X.Xlib.Display;
                window : X.Window;
                itemid : X.long)
               return X.signed_int;                         -- CutPaste.h:111

    function XmClipboardWithdrawFormat(
                display: access X.Xlib.Display;
                window : X.Window;
                data   : X.long)
               return X.signed_int;                         -- CutPaste.h:115

    function XmClipboardCopyByName(
                display   : access X.Xlib.Display;
                window    : X.Window;
                data      : X.long;
                buffer    : Xt.Intrinsic.XtPointer;
                length    : X.unsigned_long;
                private_id: X.long)
               return X.signed_int;                         -- CutPaste.h:119

    function XmClipboardUndoCopy(
                display: access X.Xlib.Display;
                window : X.Window)
               return X.signed_int;                         -- CutPaste.h:126

    function XmClipboardLock(
                display: access X.Xlib.Display;
                window : X.Window)
               return X.signed_int;                         -- CutPaste.h:129

    function XmClipboardUnlock(
                display   : access X.Xlib.Display;
                window    : X.Window;
                all_levels: X.signed_int)
               return X.signed_int;                         -- CutPaste.h:132

    function XmClipboardStartRetrieve(
                display  : access X.Xlib.Display;
                window   : X.Window;
                timestamp: X.Time)
               return X.signed_int;                         -- CutPaste.h:140

    function XmClipboardEndRetrieve(
                display: access X.Xlib.Display;
                window : X.Window)
               return X.signed_int;                         -- CutPaste.h:144

    function XmClipboardRetrieve(
                display   : access X.Xlib.Display;
                window    : X.Window;
                format    : X.Strings.const_charp;
                buffer    : Xt.Intrinsic.XtPointer;
                length    : X.unsigned_long;
                outlength : access X.unsigned_long;
                private_id: access X.long)
               return X.signed_int;                         -- CutPaste.h:147

    pragma Import(C, XmClipboardRetrieve, "XmClipboardRetrieve");

    function XmClipboardRetrieve(
                display   : access X.Xlib.Display;
                window    : X.Window;
                format    : Interfaces.C.Char_Array;
                buffer    : Xt.Intrinsic.XtPointer;
                length    : X.unsigned_long;
                outlength : access X.unsigned_long;
                private_id: access X.long)
               return X.signed_int;                         -- CutPaste.h:147

    pragma Inline(XmClipboardRetrieve);

    function XmClipboardInquireCount(
                display  : access X.Xlib.Display;
                window   : X.Window;
                count    : access X.int;
                maxlength: access X.unsigned_long)
               return X.signed_int;                         -- CutPaste.h:155

    function XmClipboardInquireFormat(
                display     : access X.Xlib.Display;
                window      : X.Window;
                n           : X.signed_int;
                buffer      : Xt.Intrinsic.XtPointer;
                bufferlength: X.unsigned_long;
                outlength   : access X.unsigned_long)
               return X.signed_int;                         -- CutPaste.h:160

    function XmClipboardInquireLength(
                display: access X.Xlib.Display;
                window : X.Window;
                format : X.Strings.const_charp;
                length : access X.unsigned_long)
               return X.signed_int;                         -- CutPaste.h:167

    pragma Import(C, XmClipboardInquireLength, "XmClipboardInquireLength");

    function XmClipboardInquireLength(
                display: access X.Xlib.Display;
                window : X.Window;
                format : Interfaces.C.Char_Array;
                length : access X.unsigned_long)
               return X.signed_int;                         -- CutPaste.h:167

    pragma Inline(XmClipboardInquireLength);

    function XmClipboardInquirePendingItems(
                display: access X.Xlib.Display;
                window : X.Window;
                format : X.Strings.const_charp;
                list   : access XmClipboardPendingList;
                count  : access X.unsigned_long)
               return X.signed_int;                         -- CutPaste.h:172

    pragma Import(C, XmClipboardInquirePendingItems, 
                     "XmClipboardInquirePendingItems");

    function XmClipboardInquirePendingItems(
                display: access X.Xlib.Display;
                window : X.Window;
                format : Interfaces.C.Char_Array;
                list   : access XmClipboardPendingList;
                count  : access X.unsigned_long)
               return X.signed_int;                         -- CutPaste.h:172

    pragma Inline(XmClipboardInquirePendingItems);

    function XmClipboardRegisterFormat(
                display      : access X.Xlib.Display;
                format_name  : X.Strings.const_charp;
                format_length: X.signed_int)
               return X.signed_int;                         -- CutPaste.h:178

    pragma Import(C, XmClipboardRegisterFormat, "XmClipboardRegisterFormat");

    function XmClipboardRegisterFormat(
                display      : access X.Xlib.Display;
                format_name  : Interfaces.C.Char_Array;
                format_length: X.signed_int)
               return X.signed_int;                         -- CutPaste.h:178

    pragma Inline(XmClipboardRegisterFormat);

private

    pragma Import(C, XmClipboardBeginCopy, "XmClipboardBeginCopy");
                                                            -- CutPaste.h:83
    pragma Import(C, XmClipboardStartCopy, "XmClipboardStartCopy");
                                                            -- CutPaste.h:90
    pragma Import(C, XmClipboardEndCopy, "XmClipboardEndCopy");
                                                            -- CutPaste.h:107
    pragma Import(C, XmClipboardCancelCopy, "XmClipboardCancelCopy");
                                                            -- CutPaste.h:111
    pragma Import(C, XmClipboardWithdrawFormat, "XmClipboardWithdrawFormat");
                                                            -- CutPaste.h:115
    pragma Import(C, XmClipboardCopyByName, "XmClipboardCopyByName");
                                                            -- CutPaste.h:119
    pragma Import(C, XmClipboardUndoCopy, "XmClipboardUndoCopy");
                                                            -- CutPaste.h:126
    pragma Import(C, XmClipboardLock, "XmClipboardLock");   -- CutPaste.h:129
    pragma Import(C, XmClipboardUnlock, "XmClipboardUnlock");
                                                            -- CutPaste.h:132
    pragma Import(C, XmClipboardStartRetrieve, "XmClipboardStartRetrieve");
                                                            -- CutPaste.h:140
    pragma Import(C, XmClipboardEndRetrieve, "XmClipboardEndRetrieve");
                                                            -- CutPaste.h:144
    pragma Import(C, XmClipboardInquireCount, "XmClipboardInquireCount");
                                                            -- CutPaste.h:155
    pragma Import(C, XmClipboardInquireFormat, "XmClipboardInquireFormat");
                                                            -- CutPaste.h:160

    pragma Convention(C, XmCutPasteProc);
    pragma Convention(C, VoidProc);
    pragma Convention(C,  XmClipboardPendingRec);
end Motif.CutPaste;
