-- $Source: /home/harp/1/proto/monoBANK/xbind/motif-dragc.ads,v $ 
-- $Revision: 1.5 $ $Date: 95/12/08 15:38:37 $ $Author: mg $ 

-- --------------------------------------------------------------------------
-- THIS FILE AND ANY ASSOCIATED DOCUMENTATION IS PROVIDED "AS IS" WITHOUT 
-- WARRANTY OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
-- TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A 
-- PARTICULAR PURPOSE.  The user assumes the entire risk as to the accuracy 
-- and the use of this file.  
--  
-- Ada version Copyright (c) Intermetrics, Inc. 1994 
-- Royalty-free, unlimited, worldwide, non-exclusive use, modification, 
-- reproduction and further distribution of this Ada file is permitted. 
--
-- C version contains additional copyrights, 
-- see the accompanying file DragC.h.
-- --------------------------------------------------------------------------

with Interfaces.C;
with X;
with X.Xlib;
with Xt.Intrinsic;

package Motif.DragC is

    subtype Char_Array is Interfaces.C.Char_Array;
    Nul: Interfaces.C.Char renames Interfaces.C.Nul;
    function "&"(S: Interfaces.C.Char_Array; C: Interfaces.C.Char)
	return Interfaces.C.Char_Array renames Interfaces.C."&";

    XmHELP          : constant := 2;                        -- DragC.h:27
    XA_MOTIF_DROP   : constant Char_Array := "_MOTIF_DROP" & Nul;
                                                            -- DragC.h:45
    XA_DRAG_FAILURE : constant Char_Array := "_MOTIF_DRAG_FAILURE" & Nul;
                                                            -- DragC.h:46
    XA_DRAG_SUCCESS : constant Char_Array := "_MOTIF_DRAG_SUCCESS" & Nul;
                                                            -- DragC.h:47
    XmDROP_NOOP     : constant := 0;                        -- DragC.h:66
    XmDROP_MOVE     : constant := 1;                        -- DragC.h:67
    XmDROP_COPY     : constant := 2;                        -- DragC.h:68
    XmDROP_LINK     : constant := 4;                        -- DragC.h:69

    type XmID is new X.unsigned_int;                        -- DragC.h:32

    type enum_anonymous0_t is (                             -- DragC.h:58
        XmTOP_LEVEL_ENTER,                                  -- DragC.h:53
        XmTOP_LEVEL_LEAVE,                                  -- DragC.h:53
        XmDRAG_MOTION,                                      -- DragC.h:54
        XmDROP_SITE_ENTER,                                  -- DragC.h:54
        XmDROP_SITE_LEAVE,                                  -- DragC.h:55
        XmDROP_START,                                       -- DragC.h:55
        XmDROP_FINISH,                                      -- DragC.h:56
        XmDRAG_DROP_FINISH,                                 -- DragC.h:56
        XmOPERATION_CHANGED                                 -- DragC.h:58
    );
    for enum_anonymous0_t'Size use X.Int'Size;              -- DragC.h:58

    type enum_anonymous1_t is (                             -- DragC.h:63
        XmDROP,                                             -- DragC.h:61
        XmDROP_HELP,                                        -- DragC.h:61
        XmDROP_CANCEL,                                      -- DragC.h:62
        XmDROP_INTERRUPT                                    -- DragC.h:63
    );
    for enum_anonymous1_t'Size use X.Int'Size;              -- DragC.h:63

    type enum_anonymous2_t is (                             -- DragC.h:73
        XmBLEND_ALL,                                        -- DragC.h:71
        XmBLEND_STATE_SOURCE,                               -- DragC.h:71
        XmBLEND_JUST_SOURCE,                                -- DragC.h:72
        XmBLEND_NONE                                        -- DragC.h:73
    );
    for enum_anonymous2_t'Size use X.Int'Size;              -- DragC.h:73

    type enum_anonymous3_t is (                             -- DragC.h:76
        XmDROP_FAILURE,                                     -- DragC.h:75
        XmDROP_SUCCESS                                      -- DragC.h:76
    );
    for enum_anonymous3_t'Size use X.Int'Size;              -- DragC.h:76

    type enum_anonymous4_t is (                             -- DragC.h:88
        XmCR_TOP_LEVEL_ENTER,                               -- DragC.h:81
        XmCR_TOP_LEVEL_LEAVE,                               -- DragC.h:81
        XmCR_DRAG_MOTION,                                   -- DragC.h:82
        XmCR_DROP_SITE_ENTER,                               -- DragC.h:82
        XmCR_DROP_SITE_LEAVE,                               -- DragC.h:83
        XmCR_DROP_START,                                    -- DragC.h:83
        XmCR_DROP_FINISH,                                   -- DragC.h:84
        XmCR_DRAG_DROP_FINISH,                              -- DragC.h:84
        XmCR_OPERATION_CHANGED,                             -- DragC.h:85
        XmNUMBER_DND_CB_REASONS                             -- DragC.h:88
    );
    for enum_anonymous4_t'Size use X.Int'Size;              -- DragC.h:88

    type XmDragContextClassRec is private;                  -- DragC.h:92
    type XmDragContextRec is private;                       -- DragC.h:93

    type XmAnyICCCallbackStruct;                            -- DragC.h:96
    type XmTopLevelEnterCallbackStruct;                     -- DragC.h:102
    type XmTopLevelLeaveCallbackStruct;                     -- DragC.h:117
    type XmDropSiteEnterCallbackStruct;                     -- DragC.h:130
    type XmDropSiteLeaveCallbackStruct;                     -- DragC.h:145
    type XmDragMotionCallbackStruct;                        -- DragC.h:151
    type XmOperationChangedCallbackStruct;                  -- DragC.h:161
    type XmDropStartCallbackStruct;                         -- DragC.h:170
    type XmDropFinishCallbackStruct;                        -- DragC.h:183
    type XmDragDropFinishCallbackStruct;                    -- DragC.h:194

    type XmDragContextClass is access all XmDragContextClassRec;
                                                            -- DragC.h:92
    type XmDragContext is access all XmDragContextRec;      -- DragC.h:93
    type XmAnyICCCallback is access all XmAnyICCCallbackStruct;
                                                            -- DragC.h:100
    type XmTopLevelEnterCallback is access all XmTopLevelEnterCallbackStruct;
                                                            -- DragC.h:115
    type XmTopLevelLeaveCallback is access all XmTopLevelLeaveCallbackStruct;
                                                            -- DragC.h:123
    type XmDropSiteEnterCallback is access all XmDropSiteEnterCallbackStruct;
                                                            -- DragC.h:138
    type XmDropSiteLeaveCallback is access all XmDropSiteLeaveCallbackStruct;
                                                            -- DragC.h:149
    type XmDragMotionCallback is access all XmDragMotionCallbackStruct;
                                                            -- DragC.h:159
    type XmOperationChangedCallback is access all 
         XmOperationChangedCallbackStruct;                  -- DragC.h:168
    type XmDropStartCallback is access all XmDropStartCallbackStruct;
                                                            -- DragC.h:181
    type XmDropFinishCallback is access all XmDropFinishCallbackStruct;
                                                            -- DragC.h:192
    type XmDragDropFinishCallback is access all XmDragDropFinishCallbackStruct;
                                                            -- DragC.h:198

    type XmAnyICCCallbackStruct is                          -- DragC.h:96
        record
            reason   : X.signed_int;                        -- DragC.h:97
            event    : X.Xlib.XEvent_access;                -- DragC.h:98
            timeStamp: X.Time;                              -- DragC.h:99
        end record;

    type XmTopLevelEnterCallbackStruct is                   -- DragC.h:102
        record
            reason           : X.signed_int;                -- DragC.h:103
            event            : X.Xlib.XEvent_access;        -- DragC.h:104
            timeStamp        : X.Time;                      -- DragC.h:105
            screen           : X.Xlib.Screen_access;        -- DragC.h:106
            window           : X.Window;                    -- DragC.h:111
            xx               : Xt.Intrinsic.Position;       -- DragC.h:112
            y                : Xt.Intrinsic.Position;       -- DragC.h:112
            dragProtocolStyle: X.unsigned_char;             -- DragC.h:113
            iccHandle        : X.Atom;                      -- DragC.h:114
        end record;

    type XmTopLevelLeaveCallbackStruct is                   -- DragC.h:117
        record
            reason   : X.signed_int;                        -- DragC.h:118
            event    : X.Xlib.XEvent_access;                -- DragC.h:119
            timeStamp: X.Time;                              -- DragC.h:120
            screen   : X.Xlib.Screen_access;                -- DragC.h:121
            window   : X.Window;                            -- DragC.h:122
        end record;

    type XmDropSiteEnterCallbackStruct is                   -- DragC.h:130
        record
            reason        : X.signed_int;                   -- DragC.h:131
            event         : X.Xlib.XEvent_access;           -- DragC.h:132
            timeStamp     : X.Time;                         -- DragC.h:133
            operation     : X.unsigned_char;                -- DragC.h:134
            operations    : X.unsigned_char;                -- DragC.h:135
            dropSiteStatus: X.unsigned_char;                -- DragC.h:136
            xx            : Xt.Intrinsic.Position;          -- DragC.h:137
            y             : Xt.Intrinsic.Position;          -- DragC.h:137
        end record;

    type XmDropSiteLeaveCallbackStruct is                   -- DragC.h:145
        record
            reason   : X.signed_int;                        -- DragC.h:146
            event    : X.Xlib.XEvent_access;                -- DragC.h:147
            timeStamp: X.Time;                              -- DragC.h:148
        end record;

    type XmDragMotionCallbackStruct is                      -- DragC.h:151
        record
            reason        : X.signed_int;                   -- DragC.h:152
            event         : X.Xlib.XEvent_access;           -- DragC.h:153
            timeStamp     : X.Time;                         -- DragC.h:154
            operation     : X.unsigned_char;                -- DragC.h:155
            operations    : X.unsigned_char;                -- DragC.h:156
            dropSiteStatus: X.unsigned_char;                -- DragC.h:157
            xx            : Xt.Intrinsic.Position;          -- DragC.h:158
            y             : Xt.Intrinsic.Position;          -- DragC.h:158
        end record;

    type XmOperationChangedCallbackStruct is                -- DragC.h:161
        record
            reason        : X.signed_int;                   -- DragC.h:162
            event         : X.Xlib.XEvent_access;           -- DragC.h:163
            timeStamp     : X.Time;                         -- DragC.h:164
            operation     : X.unsigned_char;                -- DragC.h:165
            operations    : X.unsigned_char;                -- DragC.h:166
            dropSiteStatus: X.unsigned_char;                -- DragC.h:167
        end record;

    type XmDropStartCallbackStruct is                       -- DragC.h:170
        record
            reason        : X.signed_int;                   -- DragC.h:171
            event         : X.Xlib.XEvent_access;           -- DragC.h:172
            timeStamp     : X.Time;                         -- DragC.h:173
            operation     : X.unsigned_char;                -- DragC.h:174
            operations    : X.unsigned_char;                -- DragC.h:175
            dropSiteStatus: X.unsigned_char;                -- DragC.h:176
            dropAction    : X.unsigned_char;                -- DragC.h:177
            xx            : Xt.Intrinsic.Position;          -- DragC.h:178
            y             : Xt.Intrinsic.Position;          -- DragC.h:178
            window        : X.Window;                       -- DragC.h:179
            iccHandle     : X.Atom;                         -- DragC.h:180
        end record;

    type XmDropFinishCallbackStruct is                      -- DragC.h:183
        record
            reason          : X.signed_int;                 -- DragC.h:184
            event           : X.Xlib.XEvent_access;         -- DragC.h:185
            timeStamp       : X.Time;                       -- DragC.h:186
            operation       : X.unsigned_char;              -- DragC.h:187
            operations      : X.unsigned_char;              -- DragC.h:188
            dropSiteStatus  : X.unsigned_char;              -- DragC.h:189
            dropAction      : X.unsigned_char;              -- DragC.h:190
            completionStatus: X.unsigned_char;              -- DragC.h:191
        end record;

    type XmDragDropFinishCallbackStruct is                  -- DragC.h:194
        record
            reason   : X.signed_int;                        -- DragC.h:195
            event    : X.Xlib.XEvent_access;                -- DragC.h:196
            timeStamp: X.Time;                              -- DragC.h:197
        end record;

    xmDragContextClass_obj: Xt.Intrinsic.WidgetClass;       -- DragC.h:94

    function XmDragStart(
                w      : Xt.Intrinsic.Widget;
                event  : access X.Xlib.XEvent;
                args   : Xt.Intrinsic.ArgList;
                numArgs: Xt.Intrinsic.Cardinal)
               return Xt.Intrinsic.Widget;                  -- DragC.h:210

    procedure XmDragCancel(
                dragContext: Xt.Intrinsic.Widget);          -- DragC.h:215

    function XmTargetsAreCompatible(
                dpy             : access X.Xlib.Display;
                exportTargets   : access X.Atom;
                numExportTargets: Xt.Intrinsic.Cardinal;
                importTargets   : access X.Atom;
                numImportTargets: Xt.Intrinsic.Cardinal)
               return Xt.Intrinsic.Boolean;                 -- DragC.h:217

    -- **************
    -- DragC.h macros
    -- **************

    function XmIsDragContext (W: Xt.Intrinsic.Widget)
        return Xt.Intrinsic.Boolean;                        -- DragC.h:41

private

    type XmDragContextRec is null record;                   -- DragC.h:93
    type XmDragContextClassRec is null record;              -- DragC.h:92

    pragma Import(C, xmDragContextClass_obj, "xmDragContextClass");
                                                            -- DragC.h:94
    pragma Import(C, XmDragStart, "XmDragStart");           -- DragC.h:210
    pragma Import(C, XmDragCancel, "XmDragCancel");         -- DragC.h:215
    pragma Import(C, XmTargetsAreCompatible, "XmTargetsAreCompatible");
                                                            -- DragC.h:217

    pragma Convention(C, XmAnyICCCallbackStruct);
    pragma Convention(C, XmTopLevelEnterCallbackStruct);
    pragma Convention(C, XmTopLevelLeaveCallbackStruct);
    pragma Convention(C, XmDropSiteEnterCallbackStruct);
    pragma Convention(C, XmDropSiteLeaveCallbackStruct);
    pragma Convention(C, XmDragMotionCallbackStruct);
    pragma Convention(C, XmOperationChangedCallbackStruct);
    pragma Convention(C, XmDropStartCallbackStruct);
    pragma Convention(C, XmDropFinishCallbackStruct);
    pragma Convention(C, XmDragDropFinishCallbackStruct);

    pragma Inline(XmIsDragContext);

end Motif.DragC;
