-- $Source: /home/harp/1/proto/monoBANK/xbind/motif-dropsmgr.ads,v $ 
-- $Revision: 1.4 $ $Date: 95/12/05 08:53:05 $ $Author: mg $ 

-- --------------------------------------------------------------------------
-- THIS FILE AND ANY ASSOCIATED DOCUMENTATION IS PROVIDED "AS IS" WITHOUT 
-- WARRANTY OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
-- TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A 
-- PARTICULAR PURPOSE.  The user assumes the entire risk as to the accuracy 
-- and the use of this file.  
--  
-- Ada version Copyright (c) Intermetrics, Inc. 1994 
-- Royalty-free, unlimited, worldwide, non-exclusive use, modification, 
-- reproduction and further distribution of this Ada file is permitted. 
--
-- C version contains additional copyrights, 
-- see the accompanying file DropSMgr.h.
-- --------------------------------------------------------------------------

with X;
with X.Xlib;
with Xt.Intrinsic;

package Motif.DropSMgr is

    XmCR_DROP_SITE_LEAVE_MESSAGE    : constant := 1;        -- DropSMgr.h:25
    XmCR_DROP_SITE_ENTER_MESSAGE    : constant := 2;        -- DropSMgr.h:26
    XmCR_DROP_SITE_MOTION_MESSAGE   : constant := 3;        -- DropSMgr.h:27
    XmCR_DROP_MESSAGE               : constant := 4;        -- DropSMgr.h:28
    XmNO_DROP_SITE                  : constant := 1;        -- DropSMgr.h:30
    XmINVALID_DROP_SITE             : constant := 2;        -- DropSMgr.h:31
    XmVALID_DROP_SITE               : constant := 3;        -- DropSMgr.h:32


    type enum_anonymous0_t is (                             -- DropSMgr.h:36
        XmDRAG_UNDER_NONE,                                  -- DropSMgr.h:34
        XmDRAG_UNDER_PIXMAP,                                -- DropSMgr.h:34
        XmDRAG_UNDER_SHADOW_IN,                             -- DropSMgr.h:35
        XmDRAG_UNDER_SHADOW_OUT,                            -- DropSMgr.h:35
        XmDRAG_UNDER_HIGHLIGHT                              -- DropSMgr.h:36
    );
    for enum_anonymous0_t'Size use X.Int'Size;              -- DropSMgr.h:36

    type enum_anonymous1_t is (                             -- DropSMgr.h:40
        XmDROP_SITE_SIMPLE,                                 -- DropSMgr.h:38
        XmDROP_SITE_COMPOSITE,                              -- DropSMgr.h:38
        XmDROP_SITE_SIMPLE_CLIP_ONLY,                       -- DropSMgr.h:39
        XmDROP_SITE_COMPOSITE_CLIP_ONLY                     -- DropSMgr.h:40
    );
    for enum_anonymous1_t use (                             -- DropSMgr.h:40
        XmDROP_SITE_SIMPLE => 0,                            -- DropSMgr.h:38
        XmDROP_SITE_COMPOSITE => 1,                         -- DropSMgr.h:38
        XmDROP_SITE_SIMPLE_CLIP_ONLY => 128,                -- DropSMgr.h:39
        XmDROP_SITE_COMPOSITE_CLIP_ONLY => 129              -- DropSMgr.h:40
    );
    for enum_anonymous1_t'Size use X.Int'Size;              -- DropSMgr.h:40

    type enum_anonymous2_t is (                             -- DropSMgr.h:42
        XmABOVE,                                            -- DropSMgr.h:42
        XmBELOW                                             -- DropSMgr.h:42
    );
    for enum_anonymous2_t'Size use X.Int'Size;              -- DropSMgr.h:42

    type enum_anonymous3_t is (                             -- DropSMgr.h:44
        XmDROP_SITE_ACTIVE,                                 -- DropSMgr.h:44
        XmDROP_SITE_INACTIVE                                -- DropSMgr.h:44
    );
    for enum_anonymous3_t'Size use X.Int'Size;              -- DropSMgr.h:44

    type XmDropSiteManagerClassRec is private;              -- DropSMgr.h:90
    type XmDropSiteManagerRec is private;                   -- DropSMgr.h:91

    type XmDragProcCallbackStruct;                          -- DropSMgr.h:46
    type XmDropProcCallbackStruct;                          -- DropSMgr.h:58
    type XmDropSiteVisualsRec;                              -- DropSMgr.h:71

    type XmDragProcCallback is access all XmDragProcCallbackStruct;
                                                            -- DropSMgr.h:56
    type XmDropProcCallback is access all XmDropProcCallbackStruct;
                                                            -- DropSMgr.h:68
    type XmDropSiteVisuals is access all XmDropSiteVisualsRec;
                                                            -- DropSMgr.h:83
    type XmDropSiteManagerObjectClass is access all XmDropSiteManagerClassRec;
                                                            -- DropSMgr.h:90
    type XmDropSiteManagerObject is access all XmDropSiteManagerRec;
                                                            -- DropSMgr.h:91

    type XmDragProcCallbackStruct is                        -- DropSMgr.h:46
        record
            reason        : X.signed_int;                   -- DropSMgr.h:47
            event         : X.Xlib.XEvent_access;           -- DropSMgr.h:48
            timeStamp     : X.Time;                         -- DropSMgr.h:49
            dragContext   : Xt.Intrinsic.Widget;            -- DropSMgr.h:50
            xx            : Xt.Intrinsic.Position;          -- DropSMgr.h:51
            y             : Xt.Intrinsic.Position;          -- DropSMgr.h:51
            dropSiteStatus: X.unsigned_char;                -- DropSMgr.h:52
            operation     : X.unsigned_char;                -- DropSMgr.h:53
            operations    : X.unsigned_char;                -- DropSMgr.h:54
            animate       : Xt.Intrinsic.Boolean;           -- DropSMgr.h:55
        end record;

    type XmDropProcCallbackStruct is                        -- DropSMgr.h:58
        record
            reason        : X.signed_int;                   -- DropSMgr.h:59
            event         : X.Xlib.XEvent_access;           -- DropSMgr.h:60
            timeStamp     : X.Time;                         -- DropSMgr.h:61
            dragContext   : Xt.Intrinsic.Widget;            -- DropSMgr.h:62
            xx            : Xt.Intrinsic.Position;          -- DropSMgr.h:63
            y             : Xt.Intrinsic.Position;          -- DropSMgr.h:63
            dropSiteStatus: X.unsigned_char;                -- DropSMgr.h:64
            operation     : X.unsigned_char;                -- DropSMgr.h:65
            operations    : X.unsigned_char;                -- DropSMgr.h:66
            dropAction    : X.unsigned_char;                -- DropSMgr.h:67
        end record;

    type XmDropSiteVisualsRec is                            -- DropSMgr.h:71
        record
            background        : Xt.Intrinsic.Pixel;         -- DropSMgr.h:72
            foreground        : Xt.Intrinsic.Pixel;         -- DropSMgr.h:73
            topShadowColor    : Xt.Intrinsic.Pixel;         -- DropSMgr.h:74
            topShadowPixmap   : X.Pixmap;                   -- DropSMgr.h:75
            bottomShadowColor : Xt.Intrinsic.Pixel;         -- DropSMgr.h:76
            bottomShadowPixmap: X.Pixmap;                   -- DropSMgr.h:77
            shadowThickness   : Xt.Intrinsic.Dimension;     -- DropSMgr.h:78
            highlightColor    : Xt.Intrinsic.Pixel;         -- DropSMgr.h:79
            highlightPixmap   : X.Pixmap;                   -- DropSMgr.h:80
            highlightThickness: Xt.Intrinsic.Dimension;     -- DropSMgr.h:81
            borderWidth       : Xt.Intrinsic.Dimension;     -- DropSMgr.h:82
        end record;

    xmDropSiteManagerObjectClass_obj: Xt.Intrinsic.WidgetClass;
                                                            -- DropSMgr.h:88

    procedure XmDropSiteRegister(
                widget  : Xt.Intrinsic.Widget;
                args    : Xt.Intrinsic.ArgList;
                argCount: Xt.Intrinsic.Cardinal);           -- DropSMgr.h:112

    procedure XmDropSiteUnregister(
                widget: Xt.Intrinsic.Widget);               -- DropSMgr.h:116

    procedure XmDropSiteStartUpdate(
                refWidget: Xt.Intrinsic.Widget);            -- DropSMgr.h:118

    procedure XmDropSiteUpdate(
                enclosingWidget: Xt.Intrinsic.Widget;
                args           : Xt.Intrinsic.ArgList;
                argCount       : Xt.Intrinsic.Cardinal);    -- DropSMgr.h:120

    procedure XmDropSiteEndUpdate(
                refWidget: Xt.Intrinsic.Widget);            -- DropSMgr.h:124

    procedure XmDropSiteRetrieve(
                enclosingWidget: Xt.Intrinsic.Widget;
                args           : Xt.Intrinsic.ArgList;
                argCount       : Xt.Intrinsic.Cardinal);    -- DropSMgr.h:126

    function XmDropSiteQueryStackingOrder(
                widget          : Xt.Intrinsic.Widget;
                parent_rtn      : access Xt.Intrinsic.Widget;
                children_rtn    : access Xt.Intrinsic.WidgetList;
                num_children_rtn: access Xt.Intrinsic.Cardinal)
               return X.signed_int;                         -- DropSMgr.h:130

    procedure XmDropSiteConfigureStackingOrder(
                widget    : Xt.Intrinsic.Widget;
                sibling   : Xt.Intrinsic.Widget;
                stack_mode: Xt.Intrinsic.Cardinal);         -- DropSMgr.h:135

    function XmDropSiteGetActiveVisuals(
                widget: Xt.Intrinsic.Widget)
               return XmDropSiteVisuals;                    -- DropSMgr.h:139

    -- *****************
    -- DropSMgr.h macros
    -- *****************

    function XmIsDropSiteManager (W: Xt.Intrinsic.Widget)
        return Xt.Intrinsic.Boolean;                        -- DropSMgr.h:94

private

    type XmDropSiteManagerRec is null record;               -- DropSMgr.h:91
    type XmDropSiteManagerClassRec is null record;          -- DropSMgr.h:90

    pragma Import(C, xmDropSiteManagerObjectClass_obj, 
                     "xmDropSiteManagerObjectClass");       -- DropSMgr.h:88
    pragma Import(C, XmDropSiteRegister, "XmDropSiteRegister");
                                                            -- DropSMgr.h:112
    pragma Import(C, XmDropSiteUnregister, "XmDropSiteUnregister");
                                                            -- DropSMgr.h:116
    pragma Import(C, XmDropSiteStartUpdate, "XmDropSiteStartUpdate");
                                                            -- DropSMgr.h:118
    pragma Import(C, XmDropSiteUpdate, "XmDropSiteUpdate"); -- DropSMgr.h:120
    pragma Import(C, XmDropSiteEndUpdate, "XmDropSiteEndUpdate");
                                                            -- DropSMgr.h:124
    pragma Import(C, XmDropSiteRetrieve, "XmDropSiteRetrieve");
                                                            -- DropSMgr.h:126
    pragma Import(C, XmDropSiteQueryStackingOrder, 
                     "XmDropSiteQueryStackingOrder");       -- DropSMgr.h:130
    pragma Import(C, XmDropSiteConfigureStackingOrder, 
                     "XmDropSiteConfigureStackingOrder");   -- DropSMgr.h:135
    pragma Import(C, XmDropSiteGetActiveVisuals, "XmDropSiteGetActiveVisuals");
                                                            -- DropSMgr.h:139

    pragma Convention(C, XmDragProcCallbackStruct);
    pragma Convention(C, XmDropProcCallbackStruct);
    pragma Convention(C, XmDropSiteVisualsRec);

    pragma Inline(XmIsDropSiteManager);

end Motif.DropSMgr;
