-- $Source: /home/harp/1/proto/monoBANK/xbind/motif-droptrans.ads,v $ 
-- $Revision: 1.2 $ $Date: 95/12/05 08:53:06 $ $Author: mg $ 

-- --------------------------------------------------------------------------
-- THIS FILE AND ANY ASSOCIATED DOCUMENTATION IS PROVIDED "AS IS" WITHOUT 
-- WARRANTY OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
-- TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A 
-- PARTICULAR PURPOSE.  The user assumes the entire risk as to the accuracy 
-- and the use of this file.  
--  
-- Ada version Copyright (c) Intermetrics, Inc. 1994 
-- Royalty-free, unlimited, worldwide, non-exclusive use, modification, 
-- reproduction and further distribution of this Ada file is permitted. 
--
-- C version contains additional copyrights, 
-- see the accompanying file DropTrans.h.
-- --------------------------------------------------------------------------

with X;
with Xt.Intrinsic;

package Motif.DropTrans is

    XmTRANSFER_FAILURE    : constant := 0;                  -- DropTrans.h:24
    XmTRANSFER_SUCCESS    : constant := 1;                  -- DropTrans.h:25

    type XmDropTransferClassRec is private;                 -- DropTrans.h:29
    type XmDropTransferRec is private;                      -- DropTrans.h:30
    type XmDropTransferEntryRec;                            -- DropTrans.h:36

    type XmDropTransferObjectClass is access all XmDropTransferClassRec;
                                                            -- DropTrans.h:29
    type XmDropTransferObject is access all XmDropTransferRec;
                                                            -- DropTrans.h:30
    type XmDropTransferEntry is access all XmDropTransferEntryRec;
                                                            -- DropTrans.h:39

    type XmDropTransferEntryRec is                          -- DropTrans.h:36
        record
            client_data: Xt.Intrinsic.XtPointer;            -- DropTrans.h:37
            target     : X.Atom;                            -- DropTrans.h:38
        end record;

    xmDropTransferObjectClass_obj: Xt.Intrinsic.WidgetClass;
                                                            -- DropTrans.h:27

    function XmDropTransferStart(
                refWidget: Xt.Intrinsic.Widget;
                args     : Xt.Intrinsic.ArgList;
                argCount : Xt.Intrinsic.Cardinal)
               return Xt.Intrinsic.Widget;                  -- DropTrans.h:50

    procedure XmDropTransferAdd(
                widget       : Xt.Intrinsic.Widget;
                transfers    : XmDropTransferEntry;
                num_transfers: Xt.Intrinsic.Cardinal);      -- DropTrans.h:54

    -- ******************
    -- DropTrans.h macros
    -- ******************

    function XmIsDropTransfer (W: Xt.Intrinsic.Widget)
        return Xt.Intrinsic.Boolean;                        -- DropTrans.h:33

private

    type XmDropTransferRec is null record;                  -- DropTrans.h:30
    type XmDropTransferClassRec is null record;             -- DropTrans.h:29

    pragma Import(C, xmDropTransferObjectClass_obj, 
                     "xmDropTransferObjectClass");          -- DropTrans.h:27
    pragma Import(C, XmDropTransferStart, "XmDropTransferStart");
                                                            -- DropTrans.h:50
    pragma Import(C, XmDropTransferAdd, "XmDropTransferAdd");
                                                            -- DropTrans.h:54

    pragma Convention(C, XmDropTransferEntryRec);

    pragma Inline(XmIsDropTransfer);

end Motif.DropTrans;
