-- $Source: /home/harp/1/proto/monoBANK/xbind/motif-list.ads,v $ 
-- $Revision: 1.3 $ $Date: 95/12/05 08:53:09 $ $Author: mg $ 

-- --------------------------------------------------------------------------
-- THIS FILE AND ANY ASSOCIATED DOCUMENTATION IS PROVIDED "AS IS" WITHOUT 
-- WARRANTY OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
-- TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A 
-- PARTICULAR PURPOSE.  The user assumes the entire risk as to the accuracy 
-- and the use of this file.  
--  
-- Ada version Copyright (c) Intermetrics, Inc. 1994 
-- Royalty-free, unlimited, worldwide, non-exclusive use, modification, 
-- reproduction and further distribution of this Ada file is permitted. 
--
-- C version contains additional copyrights, 
-- see the accompanying file List.h.
-- --------------------------------------------------------------------------

with Interfaces.C;
with X;
with X.Strings;
with X.Xlib;
with Xt.Intrinsic;
with Motif.Xm;

package Motif.List is

    XmINITIAL             : constant := 0;                  -- List.h:25
    XmADDITION            : constant := 1;                  -- List.h:26
    XmMODIFICATION        : constant := 2;                  -- List.h:27

    type XmListClassRec is private;                         -- List.h:33
    type XmListRec is private;                              -- List.h:34

    type XmListWidgetClass is access all XmListClassRec;    -- List.h:33
    type XmListWidget is access all XmListRec;              -- List.h:34

    xmListWidgetClass_obj: Xt.Intrinsic.WidgetClass;        -- List.h:23

    procedure XmListAddItem(
                w   : Xt.Intrinsic.Widget;
                item: Motif.Xm.XmString;
                pos : X.signed_int);                        -- List.h:81

    procedure XmListAddItems(
                w         : Xt.Intrinsic.Widget;
                items     : access Motif.Xm.XmString;
                item_count: X.signed_int;
                pos       : X.signed_int);                  -- List.h:85

    procedure XmListAddItemsUnselected(
                w         : Xt.Intrinsic.Widget;
                items     : access Motif.Xm.XmString;
                item_count: X.signed_int;
                pos       : X.signed_int);                  -- List.h:90

    procedure XmListAddItemUnselected(
                w   : Xt.Intrinsic.Widget;
                item: Motif.Xm.XmString;
                pos : X.signed_int);                        -- List.h:95

    procedure XmListDeleteItem(
                w   : Xt.Intrinsic.Widget;
                item: Motif.Xm.XmString);                   -- List.h:99

    procedure XmListDeleteItems(
                w         : Xt.Intrinsic.Widget;
                items     : access Motif.Xm.XmString;
                item_count: X.signed_int);                  -- List.h:102

    procedure XmListDeletePositions(
                w             : Xt.Intrinsic.Widget;
                position_list : access X.int;
                position_count: X.signed_int);              -- List.h:106

    procedure XmListDeletePos(
                w  : Xt.Intrinsic.Widget;
                pos: X.signed_int);                         -- List.h:110

    procedure XmListDeleteItemsPos(
                w         : Xt.Intrinsic.Widget;
                item_count: X.signed_int;
                pos       : X.signed_int);                  -- List.h:113

    procedure XmListDeleteAllItems(
                w: Xt.Intrinsic.Widget);                    -- List.h:117

    procedure XmListReplaceItems(
                w         : Xt.Intrinsic.Widget;
                old_items : access Motif.Xm.XmString;
                item_count: X.signed_int;
                new_items : access Motif.Xm.XmString);      -- List.h:119

    procedure XmListReplaceItemsPos(
                w         : Xt.Intrinsic.Widget;
                new_items : access Motif.Xm.XmString;
                item_count: X.signed_int;
                position  : X.signed_int);                  -- List.h:124

    procedure XmListReplaceItemsUnselected(
                w         : Xt.Intrinsic.Widget;
                old_items : access Motif.Xm.XmString;
                item_count: X.signed_int;
                new_items : access Motif.Xm.XmString);      -- List.h:129

    procedure XmListReplaceItemsPosUnselected(
                w         : Xt.Intrinsic.Widget;
                new_items : access Motif.Xm.XmString;
                item_count: X.signed_int;
                position  : X.signed_int);                  -- List.h:134

    procedure XmListReplacePositions(
                w            : Xt.Intrinsic.Widget;
                position_list: access X.int;
                item_list    : access Motif.Xm.XmString;
                item_count   : X.signed_int);               -- List.h:139

    procedure XmListSelectItem(
                w     : Xt.Intrinsic.Widget;
                item  : Motif.Xm.XmString;
                notify: X.signed_int);                      -- List.h:144

    procedure XmListSelectPos(
                w     : Xt.Intrinsic.Widget;
                pos   : X.signed_int;
                notify: X.signed_int);                      -- List.h:152

    procedure XmListDeselectItem(
                w   : Xt.Intrinsic.Widget;
                item: Motif.Xm.XmString);                   -- List.h:160

    procedure XmListDeselectPos(
                w  : Xt.Intrinsic.Widget;
                pos: X.signed_int);                         -- List.h:163

    procedure XmListDeselectAllItems(
                w: Xt.Intrinsic.Widget);                    -- List.h:166

    procedure XmListSetPos(
                w  : Xt.Intrinsic.Widget;
                pos: X.signed_int);                         -- List.h:168

    procedure XmListSetBottomPos(
                w  : Xt.Intrinsic.Widget;
                pos: X.signed_int);                         -- List.h:171

    procedure XmListSetItem(
                w   : Xt.Intrinsic.Widget;
                item: Motif.Xm.XmString);                   -- List.h:174

    procedure XmListSetBottomItem(
                w   : Xt.Intrinsic.Widget;
                item: Motif.Xm.XmString);                   -- List.h:177

    procedure XmListSetAddMode(
                w       : Xt.Intrinsic.Widget;
                add_mode: X.signed_int);                    -- List.h:180

    function XmListItemExists(
                w   : Xt.Intrinsic.Widget;
                item: Motif.Xm.XmString)
               return Xt.Intrinsic.Boolean;                 -- List.h:187

    function XmListItemPos(
                w   : Xt.Intrinsic.Widget;
                item: Motif.Xm.XmString)
               return X.signed_int;                         -- List.h:190

    function XmListGetKbdItemPos(
                w: Xt.Intrinsic.Widget)
               return X.signed_int;                         -- List.h:193

    function XmListSetKbdItemPos(
                w  : Xt.Intrinsic.Widget;
                pos: X.signed_int)
               return Xt.Intrinsic.Boolean;                 -- List.h:195

    function XmListYToPos(
                w: Xt.Intrinsic.Widget;
                y: Xt.Intrinsic.Position)
               return X.signed_int;                         -- List.h:198

    function XmListPosToBounds(
                w       : Xt.Intrinsic.Widget;
                position: X.signed_int;
                xx      : access Xt.Intrinsic.Position;
                y       : access Xt.Intrinsic.Position;
                width   : access Xt.Intrinsic.Dimension;
                height  : access Xt.Intrinsic.Dimension)
               return Xt.Intrinsic.Boolean;                 -- List.h:201

    function XmListGetMatchPos(
                w        : Xt.Intrinsic.Widget;
                item     : Motif.Xm.XmString;
                pos_list : access X.Int_access;
                pos_count: access X.int)
               return Xt.Intrinsic.Boolean;                 -- List.h:208

    function XmListGetSelectedPos(
                w        : Xt.Intrinsic.Widget;
                pos_list : access X.Int_access;
                pos_count: access X.int)
               return Xt.Intrinsic.Boolean;                 -- List.h:213

    procedure XmListSetHorizPos(
                w       : Xt.Intrinsic.Widget;
                position: X.signed_int);                    -- List.h:217

    procedure XmListUpdateSelectedList(
                w: Xt.Intrinsic.Widget);                    -- List.h:220

    function XmListPosSelected(
                w  : Xt.Intrinsic.Widget;
                pos: X.signed_int)
               return Xt.Intrinsic.Boolean;                 -- List.h:222

    function XmCreateList(
                parent  : Xt.Intrinsic.Widget;
                name    : X.Strings.const_charp;
                args    : Xt.Intrinsic.ArgList;
                argCount: Xt.Intrinsic.Cardinal)
               return Xt.Intrinsic.Widget;                  -- List.h:225

    pragma Import(C, XmCreateList, "XmCreateList");

    function XmCreateList(
                parent  : Xt.Intrinsic.Widget;
                name    : Interfaces.C.Char_Array;
                args    : Xt.Intrinsic.ArgList;
                argCount: Xt.Intrinsic.Cardinal)
               return Xt.Intrinsic.Widget;                  -- List.h:225

    pragma Inline(XmCreateList);

    function XmCreateScrolledList(
                parent  : Xt.Intrinsic.Widget;
                name    : X.Strings.const_charp;
                args    : Xt.Intrinsic.ArgList;
                argCount: Xt.Intrinsic.Cardinal)
               return Xt.Intrinsic.Widget;                  -- List.h:230

    pragma Import(C, XmCreateScrolledList, "XmCreateScrolledList");

    function XmCreateScrolledList(
                parent  : Xt.Intrinsic.Widget;
                name    : Interfaces.C.Char_Array;
                args    : Xt.Intrinsic.ArgList;
                argCount: Xt.Intrinsic.Cardinal)
               return Xt.Intrinsic.Widget;                  -- List.h:230

    pragma Inline(XmCreateScrolledList);

    -- *************
    -- List.h macros
    -- *************

    function XmIsList (W: Xt.Intrinsic.Widget)
        return Xt.Intrinsic.Boolean;                        -- List.h:30

private

    type XmListRec is null record;                          -- List.h:34
    type XmListClassRec is null record;                     -- List.h:33

    pragma Import(C, xmListWidgetClass_obj, "xmListWidgetClass");
                                                            -- List.h:23
    pragma Import(C, XmListAddItem, "XmListAddItem");       -- List.h:81
    pragma Import(C, XmListAddItems, "XmListAddItems");     -- List.h:85
    pragma Import(C, XmListAddItemsUnselected, "XmListAddItemsUnselected");
                                                            -- List.h:90
    pragma Import(C, XmListAddItemUnselected, "XmListAddItemUnselected");
                                                            -- List.h:95
    pragma Import(C, XmListDeleteItem, "XmListDeleteItem"); -- List.h:99
    pragma Import(C, XmListDeleteItems, "XmListDeleteItems");
                                                            -- List.h:102
    pragma Import(C, XmListDeletePositions, "XmListDeletePositions");
                                                            -- List.h:106
    pragma Import(C, XmListDeletePos, "XmListDeletePos");   -- List.h:110
    pragma Import(C, XmListDeleteItemsPos, "XmListDeleteItemsPos");
                                                            -- List.h:113
    pragma Import(C, XmListDeleteAllItems, "XmListDeleteAllItems");
                                                            -- List.h:117
    pragma Import(C, XmListReplaceItems, "XmListReplaceItems");
                                                            -- List.h:119
    pragma Import(C, XmListReplaceItemsPos, "XmListReplaceItemsPos");
                                                            -- List.h:124
    pragma Import(C, XmListReplaceItemsUnselected, 
                     "XmListReplaceItemsUnselected");       -- List.h:129
    pragma Import(C, XmListReplaceItemsPosUnselected, 
                     "XmListReplaceItemsPosUnselected");    -- List.h:134
    pragma Import(C, XmListReplacePositions, "XmListReplacePositions");
                                                            -- List.h:139
    pragma Import(C, XmListSelectItem, "XmListSelectItem"); -- List.h:144
    pragma Import(C, XmListSelectPos, "XmListSelectPos");   -- List.h:152
    pragma Import(C, XmListDeselectItem, "XmListDeselectItem");
                                                            -- List.h:160
    pragma Import(C, XmListDeselectPos, "XmListDeselectPos");
                                                            -- List.h:163
    pragma Import(C, XmListDeselectAllItems, "XmListDeselectAllItems");
                                                            -- List.h:166
    pragma Import(C, XmListSetPos, "XmListSetPos");         -- List.h:168
    pragma Import(C, XmListSetBottomPos, "XmListSetBottomPos");
                                                            -- List.h:171
    pragma Import(C, XmListSetItem, "XmListSetItem");       -- List.h:174
    pragma Import(C, XmListSetBottomItem, "XmListSetBottomItem");
                                                            -- List.h:177
    pragma Import(C, XmListSetAddMode, "XmListSetAddMode"); -- List.h:180
    pragma Import(C, XmListItemExists, "XmListItemExists"); -- List.h:187
    pragma Import(C, XmListItemPos, "XmListItemPos");       -- List.h:190
    pragma Import(C, XmListGetKbdItemPos, "XmListGetKbdItemPos");
                                                            -- List.h:193
    pragma Import(C, XmListSetKbdItemPos, "XmListSetKbdItemPos");
                                                            -- List.h:195
    pragma Import(C, XmListYToPos, "XmListYToPos");         -- List.h:198
    pragma Import(C, XmListPosToBounds, "XmListPosToBounds");
                                                            -- List.h:201
    pragma Import(C, XmListGetMatchPos, "XmListGetMatchPos");
                                                            -- List.h:208
    pragma Import(C, XmListGetSelectedPos, "XmListGetSelectedPos");
                                                            -- List.h:213
    pragma Import(C, XmListSetHorizPos, "XmListSetHorizPos");
                                                            -- List.h:217
    pragma Import(C, XmListUpdateSelectedList, "XmListUpdateSelectedList");
                                                            -- List.h:220
    pragma Import(C, XmListPosSelected, "XmListPosSelected");
                                                            -- List.h:222

    pragma Inline(XmIsList);
end Motif.List;
