-- $Source: /home/harp/1/proto/monoBANK/xbind/motif-mwmutil.ads,v $ 
-- $Revision: 1.3 $ $Date: 95/12/05 08:53:11 $ $Author: mg $ 

-- --------------------------------------------------------------------------
-- THIS FILE AND ANY ASSOCIATED DOCUMENTATION IS PROVIDED "AS IS" WITHOUT 
-- WARRANTY OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
-- TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A 
-- PARTICULAR PURPOSE.  The user assumes the entire risk as to the accuracy 
-- and the use of this file.  
--  
-- Ada version Copyright (c) Intermetrics, Inc. 1994 
-- Royalty-free, unlimited, worldwide, non-exclusive use, modification, 
-- reproduction and further distribution of this Ada file is permitted. 
--
-- C version contains additional copyrights, 
-- see the accompanying file MwmUtil.h.
-- --------------------------------------------------------------------------

with Interfaces.C;
with X;
with X.Xmd;

package Motif.MwmUtil is

    subtype Char_Array is Interfaces.C.Char_Array;
    Nul: Interfaces.C.Char renames Interfaces.C.Nul;
    use type Interfaces.C.Char_Array;                       -- to get "&"

    MWM_HINTS_FUNCTIONS                : constant := 1;     -- MwmUtil.h:39
    MWM_HINTS_DECORATIONS              : constant := 2;     -- MwmUtil.h:40
    MWM_HINTS_INPUT_MODE               : constant := 4;     -- MwmUtil.h:41
    MWM_HINTS_STATUS                   : constant := 8;     -- MwmUtil.h:42
    MWM_FUNC_ALL                       : constant := 1;     -- MwmUtil.h:45
    MWM_FUNC_RESIZE                    : constant := 2;     -- MwmUtil.h:46
    MWM_FUNC_MOVE                      : constant := 4;     -- MwmUtil.h:47
    MWM_FUNC_MINIMIZE                  : constant := 8;     -- MwmUtil.h:48
    MWM_FUNC_MAXIMIZE                  : constant := 16;    -- MwmUtil.h:49
    MWM_FUNC_CLOSE                     : constant := 32;    -- MwmUtil.h:50
    MWM_DECOR_ALL                      : constant := 1;     -- MwmUtil.h:53
    MWM_DECOR_BORDER                   : constant := 2;     -- MwmUtil.h:54
    MWM_DECOR_RESIZEH                  : constant := 4;     -- MwmUtil.h:55
    MWM_DECOR_TITLE                    : constant := 8;     -- MwmUtil.h:56
    MWM_DECOR_MENU                     : constant := 16;    -- MwmUtil.h:57
    MWM_DECOR_MINIMIZE                 : constant := 32;    -- MwmUtil.h:58
    MWM_DECOR_MAXIMIZE                 : constant := 64;    -- MwmUtil.h:59
    MWM_INPUT_MODELESS                 : constant := 0;     -- MwmUtil.h:62
    MWM_INPUT_PRIMARY_APPLICATION_MODAL: constant := 1;     -- MwmUtil.h:63
    MWM_INPUT_SYSTEM_MODAL             : constant := 2;     -- MwmUtil.h:64
    MWM_INPUT_FULL_APPLICATION_MODAL   : constant := 3;     -- MwmUtil.h:65
    MWM_TEAROFF_WINDOW                 : constant := 1;     -- MwmUtil.h:68
    MWM_INPUT_APPLICATION_MODAL        : constant := 1;     -- MwmUtil.h:73
    MWM_INFO_STARTUP_STANDARD          : constant := 1;     -- MwmUtil.h:89
    MWM_INFO_STARTUP_CUSTOM            : constant := 2;     -- MwmUtil.h:90
    PROP_MOTIF_WM_HINTS_ELEMENTS       : constant := 5;     -- MwmUtil.h:111
    PROP_MWM_HINTS_ELEMENTS            : constant := 5;     -- MwmUtil.h:112

    XA_MOTIF_WM_HINTS      : constant Char_Array := "_MOTIF_WM_HINTS" & Nul;
                                                            -- MwmUtil.h:115
    XA_MWM_HINTS           : constant Char_Array := "_MOTIF_WM_HINTS" & Nul;
                                                            -- MwmUtil.h:116
    XA_MOTIF_WM_MESSAGES   : constant Char_Array := "_MOTIF_WM_MESSAGES" & Nul;
                                                            -- MwmUtil.h:122
    XA_MWM_MESSAGES        : constant Char_Array := "_MOTIF_WM_MESSAGES" & Nul;
                                                            -- MwmUtil.h:123
    XA_MOTIF_WM_OFFSET     : constant Char_Array := "_MOTIF_WM_OFFSET" & Nul;
                                                            -- MwmUtil.h:126
    XA_MOTIF_WM_MENU       : constant Char_Array := "_MOTIF_WM_MENU" & Nul;
                                                            -- MwmUtil.h:133
    XA_MWM_MENU            : constant Char_Array := "_MOTIF_WM_MENU" & Nul;
                                                            -- MwmUtil.h:134
    PROP_MOTIF_WM_INFO_ELEMENTS: constant := 2;             -- MwmUtil.h:151
    PROP_MWM_INFO_ELEMENTS : constant := 2;                 -- MwmUtil.h:152
    XA_MOTIF_WM_INFO       : constant Char_Array := "_MOTIF_WM_INFO" & Nul;
                                                            -- MwmUtil.h:155
    XA_MWM_INFO            : constant Char_Array := "_MOTIF_WM_INFO" & Nul;
                                                            -- MwmUtil.h:156
    XA_MOTIF_BINDINGS      : constant Char_Array := "_MOTIF_BINDINGS" & Nul;
                                                            -- MwmUtil.h:164

    type MotifWmHints is                                    -- MwmUtil.h:34
        record
            flags      : X.long;                            -- MwmUtil.h:29
            functions  : X.long;                            -- MwmUtil.h:30
            decorations: X.long;                            -- MwmUtil.h:31
            input_mode : X.signed_int;                      -- MwmUtil.h:32
            status     : X.long;                            -- MwmUtil.h:33
        end record;

    subtype MwmHints is MotifWmHints;                       -- MwmUtil.h:36

    type MotifWmInfo is                                     -- MwmUtil.h:84
        record
            flags    : X.long;                              -- MwmUtil.h:82
            wm_window: X.Window;                            -- MwmUtil.h:83
        end record;

    subtype MwmInfo is MotifWmInfo;                         -- MwmUtil.h:86

    type PropMotifWmHints is                                -- MwmUtil.h:105
        record
            flags      : X.Xmd.CARD32;                      -- MwmUtil.h:100
            functions  : X.Xmd.CARD32;                      -- MwmUtil.h:101
            decorations: X.Xmd.CARD32;                      -- MwmUtil.h:102
            inputMode  : X.Xmd.INT32;                       -- MwmUtil.h:103
            status     : X.Xmd.CARD32;                      -- MwmUtil.h:104
        end record;

    subtype PropMwmHints is PropMotifWmHints;               -- MwmUtil.h:107

    type PropMotifWmInfo is                                 -- MwmUtil.h:145
        record
            flags   : X.Xmd.CARD32;                         -- MwmUtil.h:143
            wmWindow: X.Xmd.CARD32;                         -- MwmUtil.h:144
        end record;

    subtype PropMwmInfo is PropMotifWmInfo;                 -- MwmUtil.h:147

    pragma Convention(C,  MotifWmHints);
    pragma Convention(C,  MotifWmInfo);
    pragma Convention(C,  PropMotifWmHints);
    pragma Convention(C,  PropMotifWmInfo);
end Motif.MwmUtil;
