-- $Source: /home/harp/1/proto/monoBANK/xbind/motif-protocols.adb,v $ 
-- $Revision: 1.6 $ $Date: 95/12/13 17:04:16 $ $Author: mg $ 

-- --------------------------------------------------------------------------
-- THIS FILE AND ANY ASSOCIATED DOCUMENTATION IS FURNISHED "AS IS" WITHOUT 
-- WARRANTY OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
-- TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A 
-- PARTICULAR PURPOSE.  The user assumes the entire risk as to the accuracy 
-- and the use of this file. 
--  
-- Copyright (c) Intermetrics, Inc. 1994 
-- Royalty-free, unlimited, worldwide, non-exclusive use, modification, 
-- reproduction and further distribution of this file is permitted. 
-- --------------------------------------------------------------------------

with Interfaces.C;
with Motif.Atommgr;
with Xt.Intrinsic;

package body Motif.Protocols is

    function "&"(S: Interfaces.C.Char_Array; C: Interfaces.C.Char)
	return Interfaces.C.Char_Array renames Interfaces.C."&";
    Pro: constant Interfaces.C.Char_Array := "WM_PROTOCOLS" & Interfaces.C.Nul;

    function XM_WM_PROTOCOL_ATOM (Shell: Xt.Intrinsic.Widget) 
        return X.Atom is
    begin
        return Motif.Atommgr.XmInternAtom (
                  Xt.Intrinsic.XtDisplay(shell), 
                  Pro(Pro'First)'unchecked_access, Xt.Intrinsic.FALSE);
    end XM_WM_PROTOCOL_ATOM;

    procedure XmAddWMProtocols (
        shell        : Xt.Intrinsic.Widget;
        protocols    : access X.Atom;
        num_protocols: Xt.Intrinsic.Cardinal) is
    begin
        XmAddProtocols(shell, XM_WM_PROTOCOL_ATOM(shell), 
                       protocols, num_protocols);
    end XmAddWMProtocols;

    procedure XmRemoveWMProtocols (
        shell        : Xt.Intrinsic.Widget;
        protocols    : access X.Atom;
        num_protocols: Xt.Intrinsic.Cardinal) is
    begin
        XmRemoveProtocols(shell, XM_WM_PROTOCOL_ATOM(shell), 
                          protocols, num_protocols);

    end XmRemoveWMProtocols;

    procedure XmAddWMProtocolCallback (
        shell   : Xt.Intrinsic.Widget;
        protocol: X.Atom;
        callback: Xt.Intrinsic.XtCallbackProc;
        closure : Xt.Intrinsic.XtPointer) is
    begin
        XmAddProtocolCallback(shell, XM_WM_PROTOCOL_ATOM(shell), 
                              protocol, callback, closure);
    end XmAddWMProtocolCallback;

    procedure XmRemoveWMProtocolCallback (
        shell   : Xt.Intrinsic.Widget;
        protocol: X.Atom;
        callback: Xt.Intrinsic.XtCallbackProc;
        closure : Xt.Intrinsic.XtPointer) is
    begin
        XmRemoveProtocolCallback(shell, XM_WM_PROTOCOL_ATOM(shell), 
                                 protocol, callback, closure);
    end XmRemoveWMProtocolCallback;

    procedure XmActivateWMProtocol (
        shell   : Xt.Intrinsic.Widget;
        protocol: X.Atom) is
    begin
        XmActivateProtocol(shell, XM_WM_PROTOCOL_ATOM(shell), protocol);
    end XmActivateWMProtocol;

    procedure XmDeactivateWMProtocol (
        shell   : Xt.Intrinsic.Widget;
        protocol: X.Atom) is
    begin
        XmDeactivateProtocol(shell, XM_WM_PROTOCOL_ATOM(shell), protocol);
    end XmDeactivateWMProtocol;

    procedure XmSetWMProtocolHooks (
        shell   : Xt.Intrinsic.Widget;
        protocol: X.Atom;
        pre_h   : Xt.Intrinsic.XtCallbackProc;
        pre_c   : Xt.Intrinsic.XtPointer;
        post_h  : Xt.Intrinsic.XtCallbackProc;
        post_c  : Xt.Intrinsic.XtPointer) is
    begin
        XmSetProtocolHooks(shell, XM_WM_PROTOCOL_ATOM(shell), 
                           protocol, pre_h, pre_c, post_h, post_c);
    end XmSetWMProtocolHooks;

end Motif.Protocols;
