-- $Source: /home/harp/1/proto/monoBANK/xbind/motif-protocols.ads,v $ 
-- $Revision: 1.2 $ $Date: 95/12/05 08:53:13 $ $Author: mg $ 

-- --------------------------------------------------------------------------
-- THIS FILE AND ANY ASSOCIATED DOCUMENTATION IS PROVIDED "AS IS" WITHOUT 
-- WARRANTY OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
-- TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A 
-- PARTICULAR PURPOSE.  The user assumes the entire risk as to the accuracy 
-- and the use of this file.  
--  
-- Ada version Copyright (c) Intermetrics, Inc. 1994 
-- Royalty-free, unlimited, worldwide, non-exclusive use, modification, 
-- reproduction and further distribution of this Ada file is permitted. 
--
-- C version contains additional copyrights, 
-- see the accompanying file Protocols.h.
-- --------------------------------------------------------------------------

with X;
with X.Xlib;
with Xt.Intrinsic;

package Motif.Protocols is

    XmCR_WM_PROTOCOLS               : constant := 6666;     -- Protocols.h:26

    procedure XmAddProtocols(
                shell        : Xt.Intrinsic.Widget;
                property     : X.Atom;
                protocols    : access X.Atom;
                num_protocols: Xt.Intrinsic.Cardinal);      -- Protocols.h:78

    procedure XmRemoveProtocols(
                shell        : Xt.Intrinsic.Widget;
                property     : X.Atom;
                protocols    : access X.Atom;
                num_protocols: Xt.Intrinsic.Cardinal);      -- Protocols.h:83

    procedure XmAddProtocolCallback(
                shell     : Xt.Intrinsic.Widget;
                property  : X.Atom;
                proto_atom: X.Atom;
                callback  : Xt.Intrinsic.XtCallbackProc;
                closure   : Xt.Intrinsic.XtPointer);        -- Protocols.h:88

    procedure XmRemoveProtocolCallback(
                shell     : Xt.Intrinsic.Widget;
                property  : X.Atom;
                proto_atom: X.Atom;
                callback  : Xt.Intrinsic.XtCallbackProc;
                closure   : Xt.Intrinsic.XtPointer);        -- Protocols.h:94

    procedure XmActivateProtocol(
                shell     : Xt.Intrinsic.Widget;
                property  : X.Atom;
                proto_atom: X.Atom);                        -- Protocols.h:100

    procedure XmDeactivateProtocol(
                shell     : Xt.Intrinsic.Widget;
                property  : X.Atom;
                proto_atom: X.Atom);                        -- Protocols.h:104

    procedure XmSetProtocolHooks(
                shell       : Xt.Intrinsic.Widget;
                property    : X.Atom;
                proto_atom  : X.Atom;
                pre_hook    : Xt.Intrinsic.XtCallbackProc;
                pre_closure : Xt.Intrinsic.XtPointer;
                post_hook   : Xt.Intrinsic.XtCallbackProc;
                post_closure: Xt.Intrinsic.XtPointer);      -- Protocols.h:108

    -- ******************
    -- Protocols.h macros
    -- ******************

    function XM_WM_PROTOCOL_ATOM (Shell: Xt.Intrinsic.Widget) return X.Atom;

    procedure XmAddWMProtocols (
        shell        : Xt.Intrinsic.Widget;
        protocols    : access X.Atom;
        num_protocols: Xt.Intrinsic.Cardinal);

    procedure XmRemoveWMProtocols (
        shell        : Xt.Intrinsic.Widget;
        protocols    : access X.Atom;
        num_protocols: Xt.Intrinsic.Cardinal);

    procedure XmAddWMProtocolCallback (
        shell   : Xt.Intrinsic.Widget;
        protocol: X.Atom;
        callback: Xt.Intrinsic.XtCallbackProc;
        closure : Xt.Intrinsic.XtPointer);

    procedure XmRemoveWMProtocolCallback (
        shell   : Xt.Intrinsic.Widget;
        protocol: X.Atom;
        callback: Xt.Intrinsic.XtCallbackProc;
        closure : Xt.Intrinsic.XtPointer);

    procedure XmActivateWMProtocol (
        shell   : Xt.Intrinsic.Widget;
        protocol: X.Atom);

    procedure XmDeactivateWMProtocol (
        shell   : Xt.Intrinsic.Widget;
        protocol: X.Atom);

    procedure XmSetWMProtocolHooks (
        shell   : Xt.Intrinsic.Widget;
        protocol: X.Atom;
        pre_h   : Xt.Intrinsic.XtCallbackProc;
        pre_c   : Xt.Intrinsic.XtPointer;
        post_h  : Xt.Intrinsic.XtCallbackProc;
        post_c  : Xt.Intrinsic.XtPointer);

private

    pragma Import(C, XmAddProtocols, "XmAddProtocols");     -- Protocols.h:78
    pragma Import(C, XmRemoveProtocols, "XmRemoveProtocols");
                                                            -- Protocols.h:83
    pragma Import(C, XmAddProtocolCallback, "XmAddProtocolCallback");
                                                            -- Protocols.h:88
    pragma Import(C, XmRemoveProtocolCallback, "XmRemoveProtocolCallback");
                                                            -- Protocols.h:94
    pragma Import(C, XmActivateProtocol, "XmActivateProtocol");
                                                            -- Protocols.h:100
    pragma Import(C, XmDeactivateProtocol, "XmDeactivateProtocol");
                                                            -- Protocols.h:104
    pragma Import(C, XmSetProtocolHooks, "XmSetProtocolHooks");
                                                            -- Protocols.h:108

    pragma Inline(XM_WM_PROTOCOL_ATOM);
    pragma Inline(XmAddWMProtocols);
    pragma Inline(XmRemoveWMProtocols);
    pragma Inline(XmAddWMProtocolCallback);
    pragma Inline(XmRemoveWMProtocolCallback);
    pragma Inline(XmActivateWMProtocol);
    pragma Inline(XmDeactivateWMProtocol);
    pragma Inline(XmSetWMProtocolHooks);

end Motif.Protocols;
