-- $Source: /home/harp/1/proto/monoBANK/xbind/motif-reptype.ads,v $ 
-- $Revision: 1.3 $ $Date: 95/12/05 08:53:14 $ $Author: mg $ 

-- --------------------------------------------------------------------------
-- THIS FILE AND ANY ASSOCIATED DOCUMENTATION IS PROVIDED "AS IS" WITHOUT 
-- WARRANTY OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
-- TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A 
-- PARTICULAR PURPOSE.  The user assumes the entire risk as to the accuracy 
-- and the use of this file.  
--  
-- Ada version Copyright (c) Intermetrics, Inc. 1994 
-- Royalty-free, unlimited, worldwide, non-exclusive use, modification, 
-- reproduction and further distribution of this Ada file is permitted. 
--
-- C version contains additional copyrights, 
-- see the accompanying file RepType.h.
-- --------------------------------------------------------------------------

with Interfaces.C;
with X;
with X.Strings;
with Xt.Intrinsic;

package Motif.RepType is

    XmREP_TYPE_INVALID              : constant := 16#1fff#; -- RepType.h:26

    type XmRepTypeId is new X.unsigned_short;               -- RepType.h:28

    type XmRepTypeEntryRec;                                 -- RepType.h:38

    type XmRepTypeEntry is access all XmRepTypeEntryRec;    -- RepType.h:38
    type XmRepTypeList is access all XmRepTypeEntryRec;     -- RepType.h:38

    type XmRepTypeEntryRec is                               -- RepType.h:38
        record
            rep_type_name    : X.Strings.charp;             -- RepType.h:32
            value_names      : X.Strings.charp_vector;      -- RepType.h:33
            values           : X.unsigned_char_access;      -- RepType.h:34
            num_values       : X.unsigned_char;             -- RepType.h:35
            reverse_installed: Xt.Intrinsic.Boolean;        -- RepType.h:36
            rep_type_id      : XmRepTypeId;                 -- RepType.h:37
        end record;

    subtype XmRepTypeListRec is XmRepTypeEntryRec;          -- RepType.h:38

    function XmRepTypeRegister(
                rep_type   : X.Strings.const_charp;
                value_names: X.Strings.charp_vector;
                values     : X.unsigned_char_access;
                num_values : X.unsigned_int)
               return XmRepTypeId;                          -- RepType.h:55

    pragma Import(C, XmRepTypeRegister, "XmRepTypeRegister");

    function XmRepTypeRegister(
                rep_type   : Interfaces.C.Char_Array;
                value_names: X.Strings.charp_vector;
                values     : X.unsigned_char_access;
                num_values : X.unsigned_int)
               return XmRepTypeId;                          -- RepType.h:55

    pragma Inline(XmRepTypeRegister);

    procedure XmRepTypeAddReverse(
                rep_type_id: X.signed_int);                 -- RepType.h:64

    function XmRepTypeValidValue(
                rep_type_id           : X.signed_int;
                test_value            : X.unsigned_int;
                enable_default_warning: Xt.Intrinsic.Widget)
               return Xt.Intrinsic.Boolean;                 -- RepType.h:70

    function XmRepTypeGetRegistered return XmRepTypeList;   -- RepType.h:79

    function XmRepTypeGetRecord(
                rep_type_id: X.signed_int)
               return XmRepTypeEntry;                       -- RepType.h:80

    function XmRepTypeGetId(
                rep_type: X.Strings.const_charp)
               return XmRepTypeId;                          -- RepType.h:86

    pragma Import(C, XmRepTypeGetId, "XmRepTypeGetId");

    function XmRepTypeGetId(
                rep_type: Interfaces.C.Char_Array)
               return XmRepTypeId;                          -- RepType.h:86

    pragma Inline(XmRepTypeGetId);

    function XmRepTypeGetNameList(
                rep_type_id         : X.signed_int;
                use_uppercase_format: X.signed_int)
               return X.Strings.charp_vector;               -- RepType.h:88

    procedure XmRepTypeInstallTearOffModelConverter;        -- RepType.h:96

private

    pragma Import(C, XmRepTypeAddReverse, "XmRepTypeAddReverse");
                                                            -- RepType.h:64
    pragma Import(C, XmRepTypeValidValue, "XmRepTypeValidValue");
                                                            -- RepType.h:70
    pragma Import(C, XmRepTypeGetRegistered, "XmRepTypeGetRegistered");
                                                            -- RepType.h:79
    pragma Import(C, XmRepTypeGetRecord, "XmRepTypeGetRecord");
                                                            -- RepType.h:80
    pragma Import(C, XmRepTypeGetNameList, "XmRepTypeGetNameList");
                                                            -- RepType.h:88
    pragma Import(C, XmRepTypeInstallTearOffModelConverter, 
                     "XmRepTypeInstallTearOffModelConverter");
                                                            -- RepType.h:96

    pragma Convention(C,  XmRepTypeEntryRec);
end Motif.RepType;
