-- $Source: /home/harp/1/proto/monoBANK/xbind/motif-scrollbar.ads,v $ 
-- $Revision: 1.3 $ $Date: 95/12/05 08:53:17 $ $Author: mg $ 

-- --------------------------------------------------------------------------
-- THIS FILE AND ANY ASSOCIATED DOCUMENTATION IS PROVIDED "AS IS" WITHOUT 
-- WARRANTY OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
-- TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A 
-- PARTICULAR PURPOSE.  The user assumes the entire risk as to the accuracy 
-- and the use of this file.  
--  
-- Ada version Copyright (c) Intermetrics, Inc. 1994 
-- Royalty-free, unlimited, worldwide, non-exclusive use, modification, 
-- reproduction and further distribution of this Ada file is permitted. 
--
-- C version contains additional copyrights, 
-- see the accompanying file ScrollBar.h.
-- --------------------------------------------------------------------------

with Interfaces.C;
with X;
with X.Strings;
with Xt.Intrinsic;

package Motif.ScrollBar is

    type XmScrollBarClassRec is private;                    -- ScrollBar.h:31
    type XmScrollBarRec is private;                         -- ScrollBar.h:32

    type XmScrollBarWidgetClass is access all XmScrollBarClassRec;
                                                            -- ScrollBar.h:31
    type XmScrollBarWidget is access all XmScrollBarRec;    -- ScrollBar.h:32

    xmScrollBarWidgetClass_obj: Xt.Intrinsic.WidgetClass;   -- ScrollBar.h:29

    function XmCreateScrollBar(
                parent  : Xt.Intrinsic.Widget;
                name    : X.Strings.const_charp;
                arglist : Xt.Intrinsic.ArgList;
                argcount: Xt.Intrinsic.Cardinal)
               return Xt.Intrinsic.Widget;                  -- ScrollBar.h:50

    pragma Import(C, XmCreateScrollBar, "XmCreateScrollBar");

    function XmCreateScrollBar(
                parent  : Xt.Intrinsic.Widget;
                name    : Interfaces.C.Char_Array;
                arglist : Xt.Intrinsic.ArgList;
                argcount: Xt.Intrinsic.Cardinal)
               return Xt.Intrinsic.Widget;                  -- ScrollBar.h:50

    pragma Inline(XmCreateScrollBar);

    procedure XmScrollBarGetValues(
                w             : Xt.Intrinsic.Widget;
                value         : access X.signed_int;
                slider_size   : access X.signed_int;
                increment     : access X.signed_int;
                page_increment: access X.signed_int);       -- ScrollBar.h:55

    procedure XmScrollBarSetValues(
                w             : Xt.Intrinsic.Widget;
                value         : X.signed_int;
                slider_size   : X.signed_int;
                increment     : X.signed_int;
                page_increment: X.signed_int;
                notify        : X.signed_int);              -- ScrollBar.h:61

    -- ******************
    -- ScrollBar.h macros
    -- ******************

    function XmIsScrollBar (W: Xt.Intrinsic.Widget)
        return Xt.Intrinsic.Boolean;                        -- ScrollBar.h:37

private

    type XmScrollBarRec is null record;                     -- ScrollBar.h:32
    type XmScrollBarClassRec is null record;                -- ScrollBar.h:31

    pragma Import(C, xmScrollBarWidgetClass_obj, "xmScrollBarWidgetClass");
                                                            -- ScrollBar.h:29
    pragma Import(C, XmScrollBarGetValues, "XmScrollBarGetValues");
                                                            -- ScrollBar.h:55
    pragma Import(C, XmScrollBarSetValues, "XmScrollBarSetValues");
                                                            -- ScrollBar.h:61

    pragma Inline(XmIsScrollBar);

end Motif.ScrollBar;
