-- $Source: /home/harp/1/proto/monoBANK/xbind/motif-text.adb,v $ 
-- $Revision: 1.4 $ $Date: 95/12/08 15:38:55 $ $Author: mg $ 

-- --------------------------------------------------------------------------
-- THIS FILE AND ANY ASSOCIATED DOCUMENTATION IS FURNISHED "AS IS" WITHOUT 
-- WARRANTY OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
-- TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A 
-- PARTICULAR PURPOSE.  The user assumes the entire risk as to the accuracy 
-- and the use of this file. 
--  
-- Copyright (c) Intermetrics, Inc. 1994 
-- Royalty-free, unlimited, worldwide, non-exclusive use, modification, 
-- reproduction and further distribution of this file is permitted. 
-- --------------------------------------------------------------------------

with Interfaces.C;

package body Motif.Text is

    function XmIsText (W: Xt.Intrinsic.Widget) 
        return Xt.Intrinsic.Boolean is
    begin
        return Xt.Intrinsic.XtIsSubclass(W, xmTextWidgetClass_obj);
    end XmIsText;

    function XmCreateScrolledText(
                parent  : Xt.Intrinsic.Widget;
                name    : Interfaces.C.Char_Array;
                arglist : Xt.Intrinsic.ArgList;
                argcount: Xt.Intrinsic.Cardinal) 
            return Xt.Intrinsic.Widget is

        function "&"(S: Interfaces.C.Char_Array; C: Interfaces.C.Char)
	    return Interfaces.C.Char_Array renames Interfaces.C."&";
        Tmp_name: constant Interfaces.C.Char_Array := 
            name & Interfaces.C.Nul;
    begin
        return XmCreateScrolledText(
                parent,
                Tmp_name(Tmp_name'First)'unchecked_access,
                arglist,
                argcount);
    end XmCreateScrolledText;                               -- Text.h:109

    function XmCreateText(
                parent  : Xt.Intrinsic.Widget;
                name    : Interfaces.C.Char_Array;
                arglist : Xt.Intrinsic.ArgList;
                argcount: Xt.Intrinsic.Cardinal) 
            return Xt.Intrinsic.Widget is

        function "&"(S: Interfaces.C.Char_Array; C: Interfaces.C.Char)
	    return Interfaces.C.Char_Array renames Interfaces.C."&";
        Tmp_name: constant Interfaces.C.Char_Array := 
            name & Interfaces.C.Nul;
    begin
        return XmCreateText(
                parent,
                Tmp_name(Tmp_name'First)'unchecked_access,
                arglist,
                argcount);
    end XmCreateText;                                       -- Text.h:114

    procedure XmTextGetSubstring(
                widget   : Xt.Intrinsic.Widget;
                start    : Xm.XmTextPosition;
                num_chars: X.signed_int;
                buf_size : X.signed_int;
                buffer   : in out Interfaces.C.Char_Array;
                result   : out X.signed_int) is

    begin
        result := XmTextGetSubstring(
                widget,
                start,
                num_chars,
                buf_size,
                buffer(buffer'First)'unchecked_access);
    end XmTextGetSubstring;                                 -- Text.h:119

    procedure XmTextSetString(
                widget: Xt.Intrinsic.Widget;
                value : Interfaces.C.Char_Array) is

        function "&"(S: Interfaces.C.Char_Array; C: Interfaces.C.Char)
	    return Interfaces.C.Char_Array renames Interfaces.C."&";
        Tmp_value: constant Interfaces.C.Char_Array := 
            value & Interfaces.C.Nul;
    begin
        XmTextSetString(
                widget,
                Tmp_value(Tmp_value'First)'unchecked_access);
    end XmTextSetString;                                    -- Text.h:137

    procedure XmTextReplace(
                widget : Xt.Intrinsic.Widget;
                frompos: Xm.XmTextPosition;
                topos  : Xm.XmTextPosition;
                value  : Interfaces.C.Char_Array) is

        function "&"(S: Interfaces.C.Char_Array; C: Interfaces.C.Char)
	    return Interfaces.C.Char_Array renames Interfaces.C."&";
        Tmp_value: constant Interfaces.C.Char_Array := 
            value & Interfaces.C.Nul;
    begin
        XmTextReplace(
                widget,
                frompos,
                topos,
                Tmp_value(Tmp_value'First)'unchecked_access);
    end XmTextReplace;                                      -- Text.h:143

    procedure XmTextInsert(
                widget  : Xt.Intrinsic.Widget;
                position: Xm.XmTextPosition;
                value   : Interfaces.C.Char_Array) is

        function "&"(S: Interfaces.C.Char_Array; C: Interfaces.C.Char)
	    return Interfaces.C.Char_Array renames Interfaces.C."&";
        Tmp_value: constant Interfaces.C.Char_Array := 
            value & Interfaces.C.Nul;
    begin
        XmTextInsert(
                widget,
                position,
                Tmp_value(Tmp_value'First)'unchecked_access);
    end XmTextInsert;                                       -- Text.h:153

    function XmTextFindString(
                w            : Xt.Intrinsic.Widget;
                start        : Xm.XmTextPosition;
                search_string: Interfaces.C.Char_Array;
                direction    : Xm.XmTextDirection;
                position     : access Motif.Xm.XmTextPosition) 
            return Xt.Intrinsic.Boolean is

        function "&"(S: Interfaces.C.Char_Array; C: Interfaces.C.Char)
	    return Interfaces.C.Char_Array renames Interfaces.C."&";
        Tmp_search_string: constant Interfaces.C.Char_Array := 
            search_string & Interfaces.C.Nul;
    begin
        return XmTextFindString(
                w,
                start,
                Tmp_search_string(Tmp_search_string'First)'unchecked_access,
                direction,
                position);
    end XmTextFindString;                                   -- Text.h:258

end Motif.Text;
