-- $Source: /home/harp/1/proto/monoBANK/xbind/motif-text.ads,v $ 
-- $Revision: 1.3 $ $Date: 95/12/05 08:53:20 $ $Author: mg $ 

-- --------------------------------------------------------------------------
-- THIS FILE AND ANY ASSOCIATED DOCUMENTATION IS PROVIDED "AS IS" WITHOUT 
-- WARRANTY OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
-- TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A 
-- PARTICULAR PURPOSE.  The user assumes the entire risk as to the accuracy 
-- and the use of this file.  
--  
-- Ada version Copyright (c) Intermetrics, Inc. 1994 
-- Royalty-free, unlimited, worldwide, non-exclusive use, modification, 
-- reproduction and further distribution of this Ada file is permitted. 
--
-- C version contains additional copyrights, 
-- see the accompanying file Text.h.
-- --------------------------------------------------------------------------

with Interfaces.C;
with X;
with Motif.Xm;
with X.Strings;
with X.Xlib;
with Xt.Intrinsic;

package Motif.Text is

    type XmTextSourceRec is private;                        -- Text.h:29
    type XmTextClassRec is private;                         -- Text.h:30
    type XmTextRec is private;                              -- Text.h:31

    type XmTextSource is access all XmTextSourceRec;        -- Text.h:29
    type XmTextWidgetClass is access all XmTextClassRec;    -- Text.h:30
    type XmTextWidget is access all XmTextRec;              -- Text.h:31

    xmTextWidgetClass_obj: Xt.Intrinsic.WidgetClass;        -- Text.h:36

    procedure XmTextSetHighlight(
                w    : Xt.Intrinsic.Widget;
                left : Motif.Xm.XmTextPosition;
                right: Motif.Xm.XmTextPosition;
                mode : Motif.Xm.XmHighlightMode);           -- Text.h:104

    function XmCreateScrolledText(
                parent  : Xt.Intrinsic.Widget;
                name    : X.Strings.const_charp;
                arglist : Xt.Intrinsic.ArgList;
                argcount: Xt.Intrinsic.Cardinal)
               return Xt.Intrinsic.Widget;                  -- Text.h:109

    pragma Import(C, XmCreateScrolledText, "XmCreateScrolledText");

    function XmCreateScrolledText(
                parent  : Xt.Intrinsic.Widget;
                name    : Interfaces.C.Char_Array;
                arglist : Xt.Intrinsic.ArgList;
                argcount: Xt.Intrinsic.Cardinal)
               return Xt.Intrinsic.Widget;                  -- Text.h:109

    pragma Inline(XmCreateScrolledText);

    function XmCreateText(
                parent  : Xt.Intrinsic.Widget;
                name    : X.Strings.const_charp;
                arglist : Xt.Intrinsic.ArgList;
                argcount: Xt.Intrinsic.Cardinal)
               return Xt.Intrinsic.Widget;                  -- Text.h:114

    pragma Import(C, XmCreateText, "XmCreateText");

    function XmCreateText(
                parent  : Xt.Intrinsic.Widget;
                name    : Interfaces.C.Char_Array;
                arglist : Xt.Intrinsic.ArgList;
                argcount: Xt.Intrinsic.Cardinal)
               return Xt.Intrinsic.Widget;                  -- Text.h:114

    pragma Inline(XmCreateText);

    function XmTextGetSubstring(
                widget   : Xt.Intrinsic.Widget;
                start    : Motif.Xm.XmTextPosition;
                num_chars: X.signed_int;
                buf_size : X.signed_int;
                buffer   : X.Strings.charp)
               return X.signed_int;                         -- Text.h:119

    pragma Import(C, XmTextGetSubstring, "XmTextGetSubstring");

    procedure XmTextGetSubstring(
                widget   : Xt.Intrinsic.Widget;
                start    : Xm.XmTextPosition;
                num_chars: X.signed_int;
                buf_size : X.signed_int;
                buffer   : in out Interfaces.C.Char_Array;
                result   : out X.signed_int);               -- Text.h:119

    pragma Inline(XmTextGetSubstring);

    function XmTextGetSubstringWcs(
                widget   : Xt.Intrinsic.Widget;
                start    : Motif.Xm.XmTextPosition;
                num_chars: X.signed_int;
                buf_size : X.signed_int;
                buffer   : access interfaces.c.wchar_t)
               return X.signed_int;                         -- Text.h:125

    function XmTextGetString(
                widget: Xt.Intrinsic.Widget)
               return X.Strings.charp;                      -- Text.h:131

    function XmTextGetStringWcs(
                widget: Xt.Intrinsic.Widget)
               return X.wchar_access;                       -- Text.h:133

    function XmTextGetLastPosition(
                widget: Xt.Intrinsic.Widget)
               return Motif.Xm.XmTextPosition;              -- Text.h:135

    procedure XmTextSetString(
                widget: Xt.Intrinsic.Widget;
                value : X.Strings.const_charp);             -- Text.h:137

    pragma Import(C, XmTextSetString, "XmTextSetString");

    procedure XmTextSetString(
                widget: Xt.Intrinsic.Widget;
                value : Interfaces.C.Char_Array);           -- Text.h:137

    pragma Inline(XmTextSetString);

    procedure XmTextSetStringWcs(
                widget  : Xt.Intrinsic.Widget;
                wc_value: access interfaces.c.wchar_t);     -- Text.h:140

    procedure XmTextReplace(
                widget : Xt.Intrinsic.Widget;
                frompos: Motif.Xm.XmTextPosition;
                topos  : Motif.Xm.XmTextPosition;
                value  : X.Strings.const_charp);            -- Text.h:143

    pragma Import(C, XmTextReplace, "XmTextReplace");

    procedure XmTextReplace(
                widget : Xt.Intrinsic.Widget;
                frompos: Xm.XmTextPosition;
                topos  : Xm.XmTextPosition;
                value  : Interfaces.C.Char_Array);          -- Text.h:143

    pragma Inline(XmTextReplace);

    procedure XmTextReplaceWcs(
                widget : Xt.Intrinsic.Widget;
                frompos: Motif.Xm.XmTextPosition;
                topos  : Motif.Xm.XmTextPosition;
                value  : access interfaces.c.wchar_t);      -- Text.h:148

    procedure XmTextInsert(
                widget  : Xt.Intrinsic.Widget;
                position: Motif.Xm.XmTextPosition;
                value   : X.Strings.const_charp);           -- Text.h:153

    pragma Import(C, XmTextInsert, "XmTextInsert");

    procedure XmTextInsert(
                widget  : Xt.Intrinsic.Widget;
                position: Xm.XmTextPosition;
                value   : Interfaces.C.Char_Array);         -- Text.h:153

    pragma Inline(XmTextInsert);

    procedure XmTextInsertWcs(
                widget  : Xt.Intrinsic.Widget;
                position: Motif.Xm.XmTextPosition;
                wc_value: access interfaces.c.wchar_t);     -- Text.h:157

    procedure XmTextSetAddMode(
                widget: Xt.Intrinsic.Widget;
                state : X.signed_int);                      -- Text.h:161

    function XmTextGetAddMode(
                widget: Xt.Intrinsic.Widget)
               return Xt.Intrinsic.Boolean;                 -- Text.h:168

    function XmTextGetEditable(
                widget: Xt.Intrinsic.Widget)
               return Xt.Intrinsic.Boolean;                 -- Text.h:170

    procedure XmTextSetEditable(
                widget  : Xt.Intrinsic.Widget;
                editable: X.signed_int);                    -- Text.h:172

    function XmTextGetMaxLength(
                widget: Xt.Intrinsic.Widget)
               return X.signed_int;                         -- Text.h:179

    procedure XmTextSetMaxLength(
                widget    : Xt.Intrinsic.Widget;
                max_length: X.signed_int);                  -- Text.h:181

    function XmTextGetTopCharacter(
                widget: Xt.Intrinsic.Widget)
               return Motif.Xm.XmTextPosition;              -- Text.h:184

    function XmTextGetTopPosition(
                widget: Xt.Intrinsic.Widget)
               return Motif.Xm.XmTextPosition 
               renames XmTextGetTopCharacter;               -- Xm.h:571

    procedure XmTextSetTopCharacter(
                widget       : Xt.Intrinsic.Widget;
                top_character: Motif.Xm.XmTextPosition);    -- Text.h:186

    procedure XmTextSetTopPosition(
                widget       : Xt.Intrinsic.Widget;
                top_character: Motif.Xm.XmTextPosition)
               renames XmTextSetTopCharacter;               -- Xm.h:571

    function XmTextGetCursorPosition(
                widget: Xt.Intrinsic.Widget)
               return Motif.Xm.XmTextPosition;              -- Text.h:189

    function XmTextGetInsertionPosition(
                widget: Xt.Intrinsic.Widget)
               return Motif.Xm.XmTextPosition;              -- Text.h:191

    procedure XmTextSetInsertionPosition(
                widget  : Xt.Intrinsic.Widget;
                position: Motif.Xm.XmTextPosition);         -- Text.h:193

    procedure XmTextSetCursorPosition(
                widget  : Xt.Intrinsic.Widget;
                position: Motif.Xm.XmTextPosition);         -- Text.h:196

    function XmTextRemove(
                widget: Xt.Intrinsic.Widget)
               return Xt.Intrinsic.Boolean;                 -- Text.h:199

    function XmTextCopy(
                widget   : Xt.Intrinsic.Widget;
                copy_time: X.Time)
               return Xt.Intrinsic.Boolean;                 -- Text.h:201

    function XmTextCut(
                widget  : Xt.Intrinsic.Widget;
                cut_time: X.Time)
               return Xt.Intrinsic.Boolean;                 -- Text.h:204

    function XmTextPaste(
                widget: Xt.Intrinsic.Widget)
               return Xt.Intrinsic.Boolean;                 -- Text.h:207

    function XmTextGetSelection(
                widget: Xt.Intrinsic.Widget)
               return X.Strings.charp;                      -- Text.h:209

    function XmTextGetSelectionWcs(
                widget: Xt.Intrinsic.Widget)
               return X.wchar_access;                       -- Text.h:211

    procedure XmTextSetSelection(
                widget  : Xt.Intrinsic.Widget;
                first   : Motif.Xm.XmTextPosition;
                last    : Motif.Xm.XmTextPosition;
                set_time: X.Time);                          -- Text.h:213

    procedure XmTextClearSelection(
                widget    : Xt.Intrinsic.Widget;
                clear_time: X.Time);                        -- Text.h:218

    function XmTextGetSelectionPosition(
                widget: Xt.Intrinsic.Widget;
                left  : access Motif.Xm.XmTextPosition;
                right : access Motif.Xm.XmTextPosition)
               return Xt.Intrinsic.Boolean;                 -- Text.h:221

    function XmTextXYToPos(
                widget: Xt.Intrinsic.Widget;
                xx    : X.signed_int;
                y     : X.signed_int)
               return Motif.Xm.XmTextPosition;              -- Text.h:225

    function XmTextPosToXY(
                widget  : Xt.Intrinsic.Widget;
                position: Motif.Xm.XmTextPosition;
                xx      : access Xt.Intrinsic.Position;
                y       : access Xt.Intrinsic.Position)
               return Xt.Intrinsic.Boolean;                 -- Text.h:234

    function XmTextGetSource(
                widget: Xt.Intrinsic.Widget)
               return XmTextSource;                         -- Text.h:239

    procedure XmTextSetSource(
                widget         : Xt.Intrinsic.Widget;
                source         : XmTextSource;
                top_character  : Motif.Xm.XmTextPosition;
                cursor_position: Motif.Xm.XmTextPosition);  -- Text.h:241

    procedure XmTextShowPosition(
                widget  : Xt.Intrinsic.Widget;
                position: Motif.Xm.XmTextPosition);         -- Text.h:246

    procedure XmTextScroll(
                widget: Xt.Intrinsic.Widget;
                n     : X.signed_int);                      -- Text.h:249

    function XmTextGetBaseline(
                widget: Xt.Intrinsic.Widget)
               return X.signed_int;                         -- Text.h:252

    procedure XmTextDisableRedisplay(
                widget: Xt.Intrinsic.Widget);               -- Text.h:254

    procedure XmTextEnableRedisplay(
                widget: Xt.Intrinsic.Widget);               -- Text.h:256

    function XmTextFindString(
                w            : Xt.Intrinsic.Widget;
                start        : Motif.Xm.XmTextPosition;
                search_string: X.Strings.const_charp;
                direction    : Motif.Xm.XmTextDirection;
                position     : access Motif.Xm.XmTextPosition)
               return Xt.Intrinsic.Boolean;                 -- Text.h:258

    pragma Import(C, XmTextFindString, "XmTextFindString");

    function XmTextFindString(
                w            : Xt.Intrinsic.Widget;
                start        : Xm.XmTextPosition;
                search_string: Interfaces.C.Char_Array;
                direction    : Xm.XmTextDirection;
                position     : access Motif.Xm.XmTextPosition)
               return Xt.Intrinsic.Boolean;                 -- Text.h:258

    pragma Inline(XmTextFindString);

    function XmTextFindStringWcs(
                w        : Xt.Intrinsic.Widget;
                start    : Motif.Xm.XmTextPosition;
                wc_string: access interfaces.c.wchar_t;
                direction: Motif.Xm.XmTextDirection;
                position : access Motif.Xm.XmTextPosition)
               return Xt.Intrinsic.Boolean;                 -- Text.h:264

    -- *************
    -- Text.h macros
    -- *************

    function XmIsText (W: Xt.Intrinsic.Widget)
        return Xt.Intrinsic.Boolean;                        -- Text.h:44

private

    type XmTextRec is null record;                          -- Text.h:31
    type XmTextClassRec is null record;                     -- Text.h:30
    type XmTextSourceRec is null record;                    -- Text.h:29

    pragma Import(C, xmTextWidgetClass_obj, "xmTextWidgetClass");
                                                            -- Text.h:36
    pragma Import(C, XmTextSetHighlight, "XmTextSetHighlight");
                                                            -- Text.h:104
    pragma Import(C, XmTextGetSubstringWcs, "XmTextGetSubstringWcs");
                                                            -- Text.h:125
    pragma Import(C, XmTextGetString, "XmTextGetString");   -- Text.h:131
    pragma Import(C, XmTextGetStringWcs, "XmTextGetStringWcs");
                                                            -- Text.h:133
    pragma Import(C, XmTextGetLastPosition, "XmTextGetLastPosition");
                                                            -- Text.h:135
    pragma Import(C, XmTextSetStringWcs, "XmTextSetStringWcs");
                                                            -- Text.h:140
    pragma Import(C, XmTextReplaceWcs, "XmTextReplaceWcs"); -- Text.h:148
    pragma Import(C, XmTextInsertWcs, "XmTextInsertWcs");   -- Text.h:157
    pragma Import(C, XmTextSetAddMode, "XmTextSetAddMode"); -- Text.h:161
    pragma Import(C, XmTextGetAddMode, "XmTextGetAddMode"); -- Text.h:168
    pragma Import(C, XmTextGetEditable, "XmTextGetEditable");
                                                            -- Text.h:170
    pragma Import(C, XmTextSetEditable, "XmTextSetEditable");
                                                            -- Text.h:172
    pragma Import(C, XmTextGetMaxLength, "XmTextGetMaxLength");
                                                            -- Text.h:179
    pragma Import(C, XmTextSetMaxLength, "XmTextSetMaxLength");
                                                            -- Text.h:181
    pragma Import(C, XmTextGetTopCharacter, "XmTextGetTopCharacter");
                                                            -- Text.h:184
    pragma Import(C, XmTextSetTopCharacter, "XmTextSetTopCharacter");
                                                            -- Text.h:186
    pragma Import(C, XmTextGetCursorPosition, "XmTextGetCursorPosition");
                                                            -- Text.h:189
    pragma Import(C, XmTextGetInsertionPosition, "XmTextGetInsertionPosition");
                                                            -- Text.h:191
    pragma Import(C, XmTextSetInsertionPosition, "XmTextSetInsertionPosition");
                                                            -- Text.h:193
    pragma Import(C, XmTextSetCursorPosition, "XmTextSetCursorPosition");
                                                            -- Text.h:196
    pragma Import(C, XmTextRemove, "XmTextRemove");         -- Text.h:199
    pragma Import(C, XmTextCopy, "XmTextCopy");             -- Text.h:201
    pragma Import(C, XmTextCut, "XmTextCut");               -- Text.h:204
    pragma Import(C, XmTextPaste, "XmTextPaste");           -- Text.h:207
    pragma Import(C, XmTextGetSelection, "XmTextGetSelection");
                                                            -- Text.h:209
    pragma Import(C, XmTextGetSelectionWcs, "XmTextGetSelectionWcs");
                                                            -- Text.h:211
    pragma Import(C, XmTextSetSelection, "XmTextSetSelection");
                                                            -- Text.h:213
    pragma Import(C, XmTextClearSelection, "XmTextClearSelection");
                                                            -- Text.h:218
    pragma Import(C, XmTextGetSelectionPosition, "XmTextGetSelectionPosition");
                                                            -- Text.h:221
    pragma Import(C, XmTextXYToPos, "XmTextXYToPos");       -- Text.h:225
    pragma Import(C, XmTextPosToXY, "XmTextPosToXY");       -- Text.h:234
    pragma Import(C, XmTextGetSource, "XmTextGetSource");   -- Text.h:239
    pragma Import(C, XmTextSetSource, "XmTextSetSource");   -- Text.h:241
    pragma Import(C, XmTextShowPosition, "XmTextShowPosition");
                                                            -- Text.h:246
    pragma Import(C, XmTextScroll, "XmTextScroll");         -- Text.h:249
    pragma Import(C, XmTextGetBaseline, "XmTextGetBaseline");
                                                            -- Text.h:252
    pragma Import(C, XmTextDisableRedisplay, "XmTextDisableRedisplay");
                                                            -- Text.h:254
    pragma Import(C, XmTextEnableRedisplay, "XmTextEnableRedisplay");
                                                            -- Text.h:256
    pragma Import(C, XmTextFindStringWcs, "XmTextFindStringWcs");
                                                            -- Text.h:264

    pragma Inline(XmIsText);

end Motif.Text;
