-- $Source: /home/harp/1/proto/monoBANK/xbind/motif-textf.adb,v $ 
-- $Revision: 1.4 $ $Date: 95/12/08 15:38:55 $ $Author: mg $ 

-- --------------------------------------------------------------------------
-- THIS FILE AND ANY ASSOCIATED DOCUMENTATION IS FURNISHED "AS IS" WITHOUT 
-- WARRANTY OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
-- TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A 
-- PARTICULAR PURPOSE.  The user assumes the entire risk as to the accuracy 
-- and the use of this file. 
--  
-- Copyright (c) Intermetrics, Inc. 1994 
-- Royalty-free, unlimited, worldwide, non-exclusive use, modification, 
-- reproduction and further distribution of this file is permitted. 
-- --------------------------------------------------------------------------

with Interfaces.C;

package body Motif.TextF is

    function XmIsTextField (W: Xt.Intrinsic.Widget) 
        return Xt.Intrinsic.Boolean is
    begin
        return Xt.Intrinsic.XtIsSubclass(W, xmTextFieldWidgetClass_obj);
    end XmIsTextField;

    procedure XmTextFieldGetSubstring(
                widget   : Xt.Intrinsic.Widget;
                start    : Xm.XmTextPosition;
                num_chars: X.signed_int;
                buf_size : X.signed_int;
                buffer   : in out Interfaces.C.Char_Array;
                result   : out X.signed_int) is

    begin
        result := XmTextFieldGetSubstring(
                widget,
                start,
                num_chars,
                buf_size,
                buffer(buffer'First)'unchecked_access);
    end XmTextFieldGetSubstring;                            -- TextF.h:99

    procedure XmTextFieldSetString(
                w    : Xt.Intrinsic.Widget;
                value: Interfaces.C.Char_Array) is

        function "&"(S: Interfaces.C.Char_Array; C: Interfaces.C.Char)
	    return Interfaces.C.Char_Array renames Interfaces.C."&";
        Tmp_value: constant Interfaces.C.Char_Array := 
            value & Interfaces.C.Nul;
    begin
        XmTextFieldSetString(
                w,
                Tmp_value(Tmp_value'First)'unchecked_access);
    end XmTextFieldSetString;                               -- TextF.h:115

    procedure XmTextFieldReplace(
                w       : Xt.Intrinsic.Widget;
                from_pos: Xm.XmTextPosition;
                to_pos  : Xm.XmTextPosition;
                value   : Interfaces.C.Char_Array) is

        function "&"(S: Interfaces.C.Char_Array; C: Interfaces.C.Char)
	    return Interfaces.C.Char_Array renames Interfaces.C."&";
        Tmp_value: constant Interfaces.C.Char_Array := 
            value & Interfaces.C.Nul;
    begin
        XmTextFieldReplace(
                w,
                from_pos,
                to_pos,
                Tmp_value(Tmp_value'First)'unchecked_access);
    end XmTextFieldReplace;                                 -- TextF.h:121

    procedure XmTextFieldInsert(
                w       : Xt.Intrinsic.Widget;
                position: Xm.XmTextPosition;
                value   : Interfaces.C.Char_Array) is

        function "&"(S: Interfaces.C.Char_Array; C: Interfaces.C.Char)
	    return Interfaces.C.Char_Array renames Interfaces.C."&";
        Tmp_value: constant Interfaces.C.Char_Array := 
            value & Interfaces.C.Nul;
    begin
        XmTextFieldInsert(
                w,
                position,
                Tmp_value(Tmp_value'First)'unchecked_access);
    end XmTextFieldInsert;                                  -- TextF.h:131

    function XmCreateTextField(
                parent  : Xt.Intrinsic.Widget;
                name    : Interfaces.C.Char_Array;
                arglist : Xt.Intrinsic.ArgList;
                argcount: Xt.Intrinsic.Cardinal) 
            return Xt.Intrinsic.Widget is

        function "&"(S: Interfaces.C.Char_Array; C: Interfaces.C.Char)
	    return Interfaces.C.Char_Array renames Interfaces.C."&";
        Tmp_name: constant Interfaces.C.Char_Array := 
            name & Interfaces.C.Nul;
    begin
        return XmCreateTextField(
                parent,
                Tmp_name(Tmp_name'First)'unchecked_access,
                arglist,
                argcount);
    end XmCreateTextField;                                  -- TextF.h:222

end Motif.TextF;
