-- $Source: /home/harp/1/proto/monoBANK/xbind/motif-textf.ads,v $ 
-- $Revision: 1.2 $ $Date: 95/12/05 08:53:20 $ $Author: mg $ 

-- --------------------------------------------------------------------------
-- THIS FILE AND ANY ASSOCIATED DOCUMENTATION IS PROVIDED "AS IS" WITHOUT 
-- WARRANTY OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
-- TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A 
-- PARTICULAR PURPOSE.  The user assumes the entire risk as to the accuracy 
-- and the use of this file.  
--  
-- Ada version Copyright (c) Intermetrics, Inc. 1994 
-- Royalty-free, unlimited, worldwide, non-exclusive use, modification, 
-- reproduction and further distribution of this Ada file is permitted. 
--
-- C version contains additional copyrights, 
-- see the accompanying file TextF.h.
-- --------------------------------------------------------------------------

with X;
with Interfaces.C;
with Motif.Xm;
with X.Strings;
with X.Xlib;
with Xt.Intrinsic;

package Motif.TextF is

    type XmTextFieldClassRec is private;                    -- TextF.h:26
    type XmTextFieldRec is private;                         -- TextF.h:27

    type XmTextFieldWidgetClass is access all XmTextFieldClassRec;
                                                            -- TextF.h:26
    type XmTextFieldWidget is access all XmTextFieldRec;    -- TextF.h:27

    xmTextFieldWidgetClass_obj: Xt.Intrinsic.WidgetClass;   -- TextF.h:32

    procedure ToggleCursorGC(
                widget: Xt.Intrinsic.Widget;
                state : X.signed_int);                      -- TextF.h:90

    function XmTextFieldGetString(
                w: Xt.Intrinsic.Widget)
               return X.Strings.charp;                      -- TextF.h:97

    function XmTextFieldGetSubstring(
                widget   : Xt.Intrinsic.Widget;
                start    : Motif.Xm.XmTextPosition;
                num_chars: X.signed_int;
                buf_size : X.signed_int;
                buffer   : X.Strings.charp)
               return X.signed_int;                         -- TextF.h:99

    pragma Import(C, XmTextFieldGetSubstring, "XmTextFieldGetSubstring");

    procedure XmTextFieldGetSubstring(
                widget   : Xt.Intrinsic.Widget;
                start    : Xm.XmTextPosition;
                num_chars: X.signed_int;
                buf_size : X.signed_int;
                buffer   : in out Interfaces.C.Char_Array;
                result   : out X.signed_int);               -- TextF.h:99

    pragma Inline(XmTextFieldGetSubstring);

    function XmTextFieldGetStringWcs(
                w: Xt.Intrinsic.Widget)
               return X.wchar_access;                       -- TextF.h:105

    function XmTextFieldGetSubstringWcs(
                widget   : Xt.Intrinsic.Widget;
                start    : Motif.Xm.XmTextPosition;
                num_chars: X.signed_int;
                buf_size : X.signed_int;
                buffer   : access interfaces.c.wchar_t)
               return X.signed_int;                         -- TextF.h:107

    function XmTextFieldGetLastPosition(
                w: Xt.Intrinsic.Widget)
               return Motif.Xm.XmTextPosition;              -- TextF.h:113

    procedure XmTextFieldSetString(
                w    : Xt.Intrinsic.Widget;
                value: X.Strings.const_charp);              -- TextF.h:115

    pragma Import(C, XmTextFieldSetString, "XmTextFieldSetString");

    procedure XmTextFieldSetString(
                w    : Xt.Intrinsic.Widget;
                value: Interfaces.C.Char_Array);            -- TextF.h:115

    pragma Inline(XmTextFieldSetString);

    procedure XmTextFieldSetStringWcs(
                w       : Xt.Intrinsic.Widget;
                wc_value: access interfaces.c.wchar_t);     -- TextF.h:118

    procedure XmTextFieldReplace(
                w       : Xt.Intrinsic.Widget;
                from_pos: Motif.Xm.XmTextPosition;
                to_pos  : Motif.Xm.XmTextPosition;
                value   : X.Strings.const_charp);           -- TextF.h:121

    pragma Import(C, XmTextFieldReplace, "XmTextFieldReplace");

    procedure XmTextFieldReplace(
                w       : Xt.Intrinsic.Widget;
                from_pos: Xm.XmTextPosition;
                to_pos  : Xm.XmTextPosition;
                value   : Interfaces.C.Char_Array);         -- TextF.h:121

    pragma Inline(XmTextFieldReplace);

    procedure XmTextFieldReplaceWcs(
                w       : Xt.Intrinsic.Widget;
                from_pos: Motif.Xm.XmTextPosition;
                to_pos  : Motif.Xm.XmTextPosition;
                wc_value: access interfaces.c.wchar_t);     -- TextF.h:126

    procedure XmTextFieldInsert(
                w       : Xt.Intrinsic.Widget;
                position: Motif.Xm.XmTextPosition;
                value   : X.Strings.const_charp);           -- TextF.h:131

    pragma Import(C, XmTextFieldInsert, "XmTextFieldInsert");

    procedure XmTextFieldInsert(
                w       : Xt.Intrinsic.Widget;
                position: Xm.XmTextPosition;
                value   : Interfaces.C.Char_Array);         -- TextF.h:131

    pragma Inline(XmTextFieldInsert);

    procedure XmTextFieldInsertWcs(
                w       : Xt.Intrinsic.Widget;
                position: Motif.Xm.XmTextPosition;
                wcstring: access interfaces.c.wchar_t);     -- TextF.h:135

    procedure XmTextFieldSetAddMode(
                w    : Xt.Intrinsic.Widget;
                state: X.signed_int);                       -- TextF.h:139

    function XmTextFieldGetAddMode(
                w: Xt.Intrinsic.Widget)
               return Xt.Intrinsic.Boolean;                 -- TextF.h:146

    function XmTextFieldGetEditable(
                w: Xt.Intrinsic.Widget)
               return Xt.Intrinsic.Boolean;                 -- TextF.h:148

    procedure XmTextFieldSetEditable(
                w       : Xt.Intrinsic.Widget;
                editable: X.signed_int);                    -- TextF.h:150

    function XmTextFieldGetMaxLength(
                w: Xt.Intrinsic.Widget)
               return X.signed_int;                         -- TextF.h:157

    procedure XmTextFieldSetMaxLength(
                w         : Xt.Intrinsic.Widget;
                max_length: X.signed_int);                  -- TextF.h:159

    function XmTextFieldGetCursorPosition(
                w: Xt.Intrinsic.Widget)
               return Motif.Xm.XmTextPosition;              -- TextF.h:162

    function XmTextFieldGetInsertionPosition(
                w: Xt.Intrinsic.Widget)
               return Motif.Xm.XmTextPosition;              -- TextF.h:164

    procedure XmTextFieldSetCursorPosition(
                w       : Xt.Intrinsic.Widget;
                position: Motif.Xm.XmTextPosition);         -- TextF.h:166

    procedure XmTextFieldSetInsertionPosition(
                w       : Xt.Intrinsic.Widget;
                position: Motif.Xm.XmTextPosition);         -- TextF.h:169

    function XmTextFieldGetSelectionPosition(
                w    : Xt.Intrinsic.Widget;
                left : access Motif.Xm.XmTextPosition;
                right: access Motif.Xm.XmTextPosition)
               return Xt.Intrinsic.Boolean;                 -- TextF.h:172

    function XmTextFieldGetSelection(
                w: Xt.Intrinsic.Widget)
               return X.Strings.charp;                      -- TextF.h:176

    function XmTextFieldGetSelectionWcs(
                w: Xt.Intrinsic.Widget)
               return X.wchar_access;                       -- TextF.h:178

    function XmTextFieldRemove(
                w: Xt.Intrinsic.Widget)
               return Xt.Intrinsic.Boolean;                 -- TextF.h:180

    function XmTextFieldCopy(
                w        : Xt.Intrinsic.Widget;
                clip_time: X.Time)
               return Xt.Intrinsic.Boolean;                 -- TextF.h:182

    function XmTextFieldCut(
                w        : Xt.Intrinsic.Widget;
                clip_time: X.Time)
               return Xt.Intrinsic.Boolean;                 -- TextF.h:185

    function XmTextFieldPaste(
                w: Xt.Intrinsic.Widget)
               return Xt.Intrinsic.Boolean;                 -- TextF.h:188

    procedure XmTextFieldClearSelection(
                w       : Xt.Intrinsic.Widget;
                sel_time: X.Time);                          -- TextF.h:190

    procedure XmTextFieldSetSelection(
                w       : Xt.Intrinsic.Widget;
                first   : Motif.Xm.XmTextPosition;
                last    : Motif.Xm.XmTextPosition;
                sel_time: X.Time);                          -- TextF.h:193

    function XmTextFieldXYToPos(
                w : Xt.Intrinsic.Widget;
                xx: X.signed_int;
                y : X.signed_int)
               return Motif.Xm.XmTextPosition;              -- TextF.h:198

    function XmTextFieldPosToXY(
                w       : Xt.Intrinsic.Widget;
                position: Motif.Xm.XmTextPosition;
                xx      : access Xt.Intrinsic.Position;
                y       : access Xt.Intrinsic.Position)
               return Xt.Intrinsic.Boolean;                 -- TextF.h:207

    procedure XmTextFieldShowPosition(
                w       : Xt.Intrinsic.Widget;
                position: Motif.Xm.XmTextPosition);         -- TextF.h:212

    procedure XmTextFieldSetHighlight(
                w    : Xt.Intrinsic.Widget;
                left : Motif.Xm.XmTextPosition;
                right: Motif.Xm.XmTextPosition;
                mode : Motif.Xm.XmHighlightMode);           -- TextF.h:215

    function XmTextFieldGetBaseline(
                w: Xt.Intrinsic.Widget)
               return X.signed_int;                         -- TextF.h:220

    function XmCreateTextField(
                parent  : Xt.Intrinsic.Widget;
                name    : X.Strings.const_charp;
                arglist : Xt.Intrinsic.ArgList;
                argcount: Xt.Intrinsic.Cardinal)
               return Xt.Intrinsic.Widget;                  -- TextF.h:222

    pragma Import(C, XmCreateTextField, "XmCreateTextField");

    function XmCreateTextField(
                parent  : Xt.Intrinsic.Widget;
                name    : Interfaces.C.Char_Array;
                arglist : Xt.Intrinsic.ArgList;
                argcount: Xt.Intrinsic.Cardinal)
               return Xt.Intrinsic.Widget;                  -- TextF.h:222

    pragma Inline(XmCreateTextField);

    -- ******************
    -- TextF.h macros
    -- ******************

    function XmIsTextField (W: Xt.Intrinsic.Widget)
        return Xt.Intrinsic.Boolean;                        -- TextF.h:39

private

    type XmTextFieldRec is null record;                     -- TextF.h:27
    type XmTextFieldClassRec is null record;                -- TextF.h:26

    pragma Import(C, xmTextFieldWidgetClass_obj, "xmTextFieldWidgetClass");
                                                            -- TextF.h:32
    pragma Import(C, ToggleCursorGC, "ToggleCursorGC");     -- TextF.h:90
    pragma Import(C, XmTextFieldGetString, "XmTextFieldGetString");
                                                            -- TextF.h:97
    pragma Import(C, XmTextFieldGetStringWcs, "XmTextFieldGetStringWcs");
                                                            -- TextF.h:105
    pragma Import(C, XmTextFieldGetSubstringWcs, "XmTextFieldGetSubstringWcs");
                                                            -- TextF.h:107
    pragma Import(C, XmTextFieldGetLastPosition, "XmTextFieldGetLastPosition");
                                                            -- TextF.h:113
    pragma Import(C, XmTextFieldSetStringWcs, "XmTextFieldSetStringWcs");
                                                            -- TextF.h:118
    pragma Import(C, XmTextFieldReplaceWcs, "XmTextFieldReplaceWcs");
                                                            -- TextF.h:126
    pragma Import(C, XmTextFieldInsertWcs, "XmTextFieldInsertWcs");
                                                            -- TextF.h:135
    pragma Import(C, XmTextFieldSetAddMode, "XmTextFieldSetAddMode");
                                                            -- TextF.h:139
    pragma Import(C, XmTextFieldGetAddMode, "XmTextFieldGetAddMode");
                                                            -- TextF.h:146
    pragma Import(C, XmTextFieldGetEditable, "XmTextFieldGetEditable");
                                                            -- TextF.h:148
    pragma Import(C, XmTextFieldSetEditable, "XmTextFieldSetEditable");
                                                            -- TextF.h:150
    pragma Import(C, XmTextFieldGetMaxLength, "XmTextFieldGetMaxLength");
                                                            -- TextF.h:157
    pragma Import(C, XmTextFieldSetMaxLength, "XmTextFieldSetMaxLength");
                                                            -- TextF.h:159
    pragma Import(C, XmTextFieldGetCursorPosition, 
                     "XmTextFieldGetCursorPosition");       -- TextF.h:162
    pragma Import(C, XmTextFieldGetInsertionPosition, 
                     "XmTextFieldGetInsertionPosition");    -- TextF.h:164
    pragma Import(C, XmTextFieldSetCursorPosition, 
                     "XmTextFieldSetCursorPosition");       -- TextF.h:166
    pragma Import(C, XmTextFieldSetInsertionPosition, 
                     "XmTextFieldSetInsertionPosition");    -- TextF.h:169
    pragma Import(C, XmTextFieldGetSelectionPosition, 
                     "XmTextFieldGetSelectionPosition");    -- TextF.h:172
    pragma Import(C, XmTextFieldGetSelection, "XmTextFieldGetSelection");
                                                            -- TextF.h:176
    pragma Import(C, XmTextFieldGetSelectionWcs, "XmTextFieldGetSelectionWcs");
                                                            -- TextF.h:178
    pragma Import(C, XmTextFieldRemove, "XmTextFieldRemove");
                                                            -- TextF.h:180
    pragma Import(C, XmTextFieldCopy, "XmTextFieldCopy");   -- TextF.h:182
    pragma Import(C, XmTextFieldCut, "XmTextFieldCut");     -- TextF.h:185
    pragma Import(C, XmTextFieldPaste, "XmTextFieldPaste"); -- TextF.h:188
    pragma Import(C, XmTextFieldClearSelection, "XmTextFieldClearSelection");
                                                            -- TextF.h:190
    pragma Import(C, XmTextFieldSetSelection, "XmTextFieldSetSelection");
                                                            -- TextF.h:193
    pragma Import(C, XmTextFieldXYToPos, "XmTextFieldXYToPos");
                                                            -- TextF.h:198
    pragma Import(C, XmTextFieldPosToXY, "XmTextFieldPosToXY");
                                                            -- TextF.h:207
    pragma Import(C, XmTextFieldShowPosition, "XmTextFieldShowPosition");
                                                            -- TextF.h:212
    pragma Import(C, XmTextFieldSetHighlight, "XmTextFieldSetHighlight");
                                                            -- TextF.h:215
    pragma Import(C, XmTextFieldGetBaseline, "XmTextFieldGetBaseline");
                                                            -- TextF.h:220

    pragma Inline(XmIsTextField);

end Motif.TextF;
