-- $Source: /home/harp/1/proto/monoBANK/xbind/motif-xm.adb,v $ 
-- $Revision: 1.6 $ $Date: 95/12/08 15:38:57 $ $Author: mg $ 

-- --------------------------------------------------------------------------
-- THIS FILE AND ANY ASSOCIATED DOCUMENTATION IS FURNISHED "AS IS" WITHOUT 
-- WARRANTY OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
-- TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A 
-- PARTICULAR PURPOSE.  The user assumes the entire risk as to the accuracy 
-- and the use of this file. 
--  
-- Copyright (c) Intermetrics, Inc. 1994 
-- Royalty-free, unlimited, worldwide, non-exclusive use, modification, 
-- reproduction and further distribution of this file is permitted. 
-- --------------------------------------------------------------------------

with Ada.Unchecked_Conversion;
with Interfaces.C;
with Stdarg.Impl;

package body Motif.Xm is

    -- *********************************
    -- Stdarg functions that need bodies
    -- *********************************

    function "&" is new Stdarg.Concat(Xt.Intrinsic.Widget);
    function "&" is new Stdarg.Concat(X.Strings.charp);
    function "&" is new Stdarg.Concat(X.Strings.const_charp);
    function "&" is new Stdarg.Concat(Xt.Intrinsic.XtCallbackProc);
    function "&" is new Stdarg.Concat(XmString);
    function "&" is new Stdarg.Concat(X.KeySym);
    function "&" is new Stdarg.Concat(X.signed_int);

    function To_Widget is new Ada.Unchecked_Conversion(
        Stdarg.C_Param, Xt.Intrinsic.Widget);

    function XmVaCreateSimpleMenuBar(
                parent: Xt.Intrinsic.Widget;
                name  : X.Strings.const_charp;
                args  : Stdarg.ArgList := Stdarg.Empty)
               return Xt.Intrinsic.Widget is                -- Xm.h:969

        use Stdarg, Stdarg.Impl;

        Complete_Args: Stdarg.ArgList :=
            Stdarg.Empty & parent & name & args;

        function C_XmVaCreateSimpleMenuBar return Integer;
        pragma Import(C, C_XmVaCreateSimpleMenuBar, "XmVaCreateSimpleMenuBar");

    begin
        return To_Widget(F_Varargs(
            C_XmVaCreateSimpleMenuBar'Address,
            ArgCount(Complete_Args),
            Address_of_First_Arg(Complete_Args)));

    end XmVaCreateSimpleMenuBar;

    function XmVaCreateSimplePopupMenu(
                parent  : Xt.Intrinsic.Widget;
                name    : X.Strings.const_charp;
                callback: Xt.Intrinsic.XtCallbackProc;
                args    : Stdarg.ArgList := Stdarg.Empty)
               return Xt.Intrinsic.Widget is                -- Xm.h:973

        use Stdarg, Stdarg.Impl;

        Complete_Args: Stdarg.ArgList :=
            Stdarg.Empty & parent & name & callback & args;

        function C_XmVaCreateSimplePopupMenu return Integer;
        pragma Import(C, C_XmVaCreateSimplePopupMenu, 
                     "XmVaCreateSimplePopupMenu");

    begin
        return To_Widget(F_Varargs(
            C_XmVaCreateSimplePopupMenu'Address,
            ArgCount(Complete_Args),
            Address_of_First_Arg(Complete_Args)));

    end XmVaCreateSimplePopupMenu;

    function XmVaCreateSimplePulldownMenu(
                parent          : Xt.Intrinsic.Widget;
                name            : X.Strings.const_charp;
                post_from_button: X.signed_int;
                callback        : Xt.Intrinsic.XtCallbackProc;
                args            : Stdarg.ArgList := Stdarg.Empty)
               return Xt.Intrinsic.Widget is                -- Xm.h:978

        use Stdarg, Stdarg.Impl;

        Complete_Args: Stdarg.ArgList :=
            Stdarg.Empty & parent & name & post_from_button & callback & args;

        function C_XmVaCreateSimplePulldownMenu return Integer;
        pragma Import(C, C_XmVaCreateSimplePulldownMenu, 
                     "XmVaCreateSimplePulldownMenu");

    begin
        return To_Widget(F_Varargs(
            C_XmVaCreateSimplePulldownMenu'Address,
            ArgCount(Complete_Args),
            Address_of_First_Arg(Complete_Args)));

    end XmVaCreateSimplePulldownMenu;

    function XmVaCreateSimpleOptionMenu(
                parent         : Xt.Intrinsic.Widget;
                name           : X.Strings.const_charp;
                option_label   : XmString;
                option_mnemonic: X.KeySym;
                button_set     : X.signed_int;
                callback       : Xt.Intrinsic.XtCallbackProc;
                args           : Stdarg.ArgList := Stdarg.Empty)
               return Xt.Intrinsic.Widget is                -- Xm.h:984

        use Stdarg, Stdarg.Impl;

        Complete_Args: Stdarg.ArgList :=
            Stdarg.Empty & parent & name & option_label & option_mnemonic &
                           button_set & callback & args;

        function C_XmVaCreateSimpleOptionMenu return Integer;
        pragma Import(C, C_XmVaCreateSimpleOptionMenu, 
                     "XmVaCreateSimpleOptionMenu");
    begin
        return To_Widget(F_Varargs(
            C_XmVaCreateSimpleOptionMenu'Address,
            ArgCount(Complete_Args),
            Address_of_First_Arg(Complete_Args)));

    end XmVaCreateSimpleOptionMenu;

    function XmVaCreateSimpleRadioBox(
                parent    : Xt.Intrinsic.Widget;
                name      : X.Strings.const_charp;
                button_set: X.signed_int;
                callback  : Xt.Intrinsic.XtCallbackProc;
                args      : Stdarg.ArgList := Stdarg.Empty)
               return Xt.Intrinsic.Widget is                -- Xm.h:992

        use Stdarg, Stdarg.Impl;

        Complete_Args: Stdarg.ArgList :=
            Stdarg.Empty & parent & name & button_set & callback & args;

        function C_XmVaCreateSimpleRadioBox return Integer;
        pragma Import(C, C_XmVaCreateSimpleRadioBox, 
                     "XmVaCreateSimpleRadioBox");
    begin
        return To_Widget(F_Varargs(
            C_XmVaCreateSimpleRadioBox'Address,
            ArgCount(Complete_Args),
            Address_of_First_Arg(Complete_Args)));

    end XmVaCreateSimpleRadioBox;

    function XmVaCreateSimpleCheckBox(
                parent  : Xt.Intrinsic.Widget;
                name    : X.Strings.const_charp;
                callback: Xt.Intrinsic.XtCallbackProc;
                args    : Stdarg.ArgList := Stdarg.Empty)
               return Xt.Intrinsic.Widget is                -- Xm.h:998

        use Stdarg, Stdarg.Impl;

        Complete_Args: Stdarg.ArgList :=
            Stdarg.Empty & parent & name & callback & args;

        function C_XmVaCreateSimpleCheckBox return Integer;
        pragma Import(C, C_XmVaCreateSimpleCheckBox, 
                     "XmVaCreateSimpleCheckBox");
    begin
        return To_Widget(F_Varargs(
            C_XmVaCreateSimpleCheckBox'Address,
            ArgCount(Complete_Args),
            Address_of_First_Arg(Complete_Args)));

    end XmVaCreateSimpleCheckBox;

    procedure XmImVaSetFocusValues(
                w   : Xt.Intrinsic.Widget;
                args: Stdarg.ArgList := Stdarg.Empty) is    -- Xm.h:1420

        use Stdarg, Stdarg.Impl;

        Complete_Args: Stdarg.ArgList :=
            Stdarg.Empty & w & args;

        procedure C_XmImVaSetFocusValues;
        pragma Import(C, C_XmImVaSetFocusValues, "XmImVaSetFocusValues");

    begin
        Do_Varargs(
            C_XmImVaSetFocusValues'Address,
            ArgCount(Complete_Args),
            Address_of_First_Arg(Complete_Args));

    end XmImVaSetFocusValues;

    procedure XmImVaSetValues(
                w   : Xt.Intrinsic.Widget;
                args: Stdarg.ArgList := Stdarg.Empty) is    -- Xm.h:1423

        use Stdarg, Stdarg.Impl;

        Complete_Args: Stdarg.ArgList :=
            Stdarg.Empty & w & args;

        procedure C_XmImVaSetValues;
        pragma Import(C, C_XmImVaSetValues, "XmImVaSetValues");

    begin
        Do_Varargs(
            C_XmImVaSetValues'Address,
            ArgCount(Complete_Args),
            Address_of_First_Arg(Complete_Args));

    end XmImVaSetValues;

    -- *********
    -- XM macros
    -- *********

    function XmIsPrimitive(W: Xt.Intrinsic.Widget) 
        return Xt.Intrinsic.Boolean is
    begin
        return Xt.Intrinsic.XtIsSubclass(w, xmPrimitiveWidgetClass_obj);
    end;

    function XmIsGadget(W: Xt.Intrinsic.Widget) 
        return Xt.Intrinsic.Boolean is
    begin
        return Xt.Intrinsic.XtIsSubclass(w, xmGadgetClass_obj);
    end;

    function XmIsManager(W: Xt.Intrinsic.Widget) 
        return Xt.Intrinsic.Boolean is
    begin
        return Xt.Intrinsic.XtIsSubclass(w, xmManagerWidgetClass_obj);
    end;

    -- *********************************
    -- String functions that need bodies
    -- *********************************

    function XmInstallImage(
                image     : X.Xlib.XImage_access;
                image_name: Interfaces.C.Char_Array) 
            return Xt.Intrinsic.Boolean is

        function "&"(S: Interfaces.C.Char_Array; C: Interfaces.C.Char)
	    return Interfaces.C.Char_Array renames Interfaces.C."&";
        Tmp_image_name: constant Interfaces.C.Char_Array := 
            image_name & Interfaces.C.Nul;
    begin
        return XmInstallImage(
                image,
                Tmp_image_name(Tmp_image_name'First)'unchecked_access);
    end XmInstallImage;                                     -- Xm.h:736

    function XmGetPixmap(
                screen    : X.Xlib.Screen_access;
                image_name: Interfaces.C.Char_Array;
                foreground: Xt.Intrinsic.Pixel;
                background: Xt.Intrinsic.Pixel) return X.Pixmap is

        function "&"(S: Interfaces.C.Char_Array; C: Interfaces.C.Char)
	    return Interfaces.C.Char_Array renames Interfaces.C."&";
        Tmp_image_name: constant Interfaces.C.Char_Array := 
            image_name & Interfaces.C.Nul;
    begin
        return XmGetPixmap(
                screen,
                Tmp_image_name(Tmp_image_name'First)'unchecked_access,
                foreground,
                background);
    end XmGetPixmap;                                        -- Xm.h:741

    function XmGetPixmapByDepth(
                screen    : X.Xlib.Screen_access;
                image_name: Interfaces.C.Char_Array;
                foreground: Xt.Intrinsic.Pixel;
                background: Xt.Intrinsic.Pixel;
                depth     : X.signed_int) return X.Pixmap is

        function "&"(S: Interfaces.C.Char_Array; C: Interfaces.C.Char)
	    return Interfaces.C.Char_Array renames Interfaces.C."&";
        Tmp_image_name: constant Interfaces.C.Char_Array := 
            image_name & Interfaces.C.Nul;
    begin
        return XmGetPixmapByDepth(
                screen,
                Tmp_image_name(Tmp_image_name'First)'unchecked_access,
                foreground,
                background,
                depth);
    end XmGetPixmapByDepth;                                 -- Xm.h:746

    function XmRegisterSegmentEncoding(
                fontlist_tag: Interfaces.C.Char_Array;
                ct_encoding : Interfaces.C.Char_Array) 
            return X.Strings.charp is

        function "&"(S: Interfaces.C.Char_Array; C: Interfaces.C.Char)
	    return Interfaces.C.Char_Array renames Interfaces.C."&";
        Tmp_fontlist_tag: constant Interfaces.C.Char_Array := 
            fontlist_tag & Interfaces.C.Nul;
        Tmp_ct_encoding: constant Interfaces.C.Char_Array := 
            ct_encoding & Interfaces.C.Nul;
    begin
        return XmRegisterSegmentEncoding(
                Tmp_fontlist_tag(Tmp_fontlist_tag'First)'unchecked_access,
                Tmp_ct_encoding(Tmp_ct_encoding'First)'unchecked_access);
    end XmRegisterSegmentEncoding;                          -- Xm.h:824

    function XmMapSegmentEncoding(
                fontlist_tag: Interfaces.C.Char_Array) 
            return X.Strings.charp is

        function "&"(S: Interfaces.C.Char_Array; C: Interfaces.C.Char)
	    return Interfaces.C.Char_Array renames Interfaces.C."&";
        Tmp_fontlist_tag: constant Interfaces.C.Char_Array := 
            fontlist_tag & Interfaces.C.Nul;
    begin
        return XmMapSegmentEncoding(
                Tmp_fontlist_tag(Tmp_fontlist_tag'First)'unchecked_access);
    end XmMapSegmentEncoding;                               -- Xm.h:827

    function XmCvtCTToXmString(
                text: Interfaces.C.Char_Array) return XmString is

        function "&"(S: Interfaces.C.Char_Array; C: Interfaces.C.Char)
	    return Interfaces.C.Char_Array renames Interfaces.C."&";
        Tmp_text: constant Interfaces.C.Char_Array := 
            text & Interfaces.C.Nul;
    begin
        return XmCvtCTToXmString(
                Tmp_text(Tmp_text'First)'unchecked_access);
    end XmCvtCTToXmString;                                  -- Xm.h:829

    function XmCreateSimpleMenuBar(
                parent   : Xt.Intrinsic.Widget;
                name     : Interfaces.C.Char_Array;
                args     : Xt.Intrinsic.ArgList;
                arg_count: Xt.Intrinsic.Cardinal) 
            return Xt.Intrinsic.Widget is

        function "&"(S: Interfaces.C.Char_Array; C: Interfaces.C.Char)
	    return Interfaces.C.Char_Array renames Interfaces.C."&";
        Tmp_name: constant Interfaces.C.Char_Array := 
            name & Interfaces.C.Nul;
    begin
        return XmCreateSimpleMenuBar(
                parent,
                Tmp_name(Tmp_name'First)'unchecked_access,
                args,
                arg_count);
    end XmCreateSimpleMenuBar;                              -- Xm.h:926

    function XmCreateSimplePopupMenu(
                parent   : Xt.Intrinsic.Widget;
                name     : Interfaces.C.Char_Array;
                args     : Xt.Intrinsic.ArgList;
                arg_count: Xt.Intrinsic.Cardinal) 
            return Xt.Intrinsic.Widget is

        function "&"(S: Interfaces.C.Char_Array; C: Interfaces.C.Char)
	    return Interfaces.C.Char_Array renames Interfaces.C."&";
        Tmp_name: constant Interfaces.C.Char_Array := 
            name & Interfaces.C.Nul;
    begin
        return XmCreateSimplePopupMenu(
                parent,
                Tmp_name(Tmp_name'First)'unchecked_access,
                args,
                arg_count);
    end XmCreateSimplePopupMenu;                            -- Xm.h:931

    function XmCreateSimplePulldownMenu(
                parent   : Xt.Intrinsic.Widget;
                name     : Interfaces.C.Char_Array;
                args     : Xt.Intrinsic.ArgList;
                arg_count: Xt.Intrinsic.Cardinal) 
            return Xt.Intrinsic.Widget is

        function "&"(S: Interfaces.C.Char_Array; C: Interfaces.C.Char)
	    return Interfaces.C.Char_Array renames Interfaces.C."&";
        Tmp_name: constant Interfaces.C.Char_Array := 
            name & Interfaces.C.Nul;
    begin
        return XmCreateSimplePulldownMenu(
                parent,
                Tmp_name(Tmp_name'First)'unchecked_access,
                args,
                arg_count);
    end XmCreateSimplePulldownMenu;                         -- Xm.h:936

    function XmCreateSimpleOptionMenu(
                parent   : Xt.Intrinsic.Widget;
                name     : Interfaces.C.Char_Array;
                args     : Xt.Intrinsic.ArgList;
                arg_count: Xt.Intrinsic.Cardinal) 
            return Xt.Intrinsic.Widget is

        function "&"(S: Interfaces.C.Char_Array; C: Interfaces.C.Char)
	    return Interfaces.C.Char_Array renames Interfaces.C."&";
        Tmp_name: constant Interfaces.C.Char_Array := 
            name & Interfaces.C.Nul;
    begin
        return XmCreateSimpleOptionMenu(
                parent,
                Tmp_name(Tmp_name'First)'unchecked_access,
                args,
                arg_count);
    end XmCreateSimpleOptionMenu;                           -- Xm.h:941

    function XmCreateSimpleRadioBox(
                parent   : Xt.Intrinsic.Widget;
                name     : Interfaces.C.Char_Array;
                args     : Xt.Intrinsic.ArgList;
                arg_count: Xt.Intrinsic.Cardinal) 
            return Xt.Intrinsic.Widget is

        function "&"(S: Interfaces.C.Char_Array; C: Interfaces.C.Char)
	    return Interfaces.C.Char_Array renames Interfaces.C."&";
        Tmp_name: constant Interfaces.C.Char_Array := 
            name & Interfaces.C.Nul;
    begin
        return XmCreateSimpleRadioBox(
                parent,
                Tmp_name(Tmp_name'First)'unchecked_access,
                args,
                arg_count);
    end XmCreateSimpleRadioBox;                             -- Xm.h:946

    function XmCreateSimpleCheckBox(
                parent   : Xt.Intrinsic.Widget;
                name     : Interfaces.C.Char_Array;
                args     : Xt.Intrinsic.ArgList;
                arg_count: Xt.Intrinsic.Cardinal) 
            return Xt.Intrinsic.Widget is

        function "&"(S: Interfaces.C.Char_Array; C: Interfaces.C.Char)
	    return Interfaces.C.Char_Array renames Interfaces.C."&";
        Tmp_name: constant Interfaces.C.Char_Array := 
            name & Interfaces.C.Nul;
    begin
        return XmCreateSimpleCheckBox(
                parent,
                Tmp_name(Tmp_name'First)'unchecked_access,
                args,
                arg_count);
    end XmCreateSimpleCheckBox;                             -- Xm.h:951

    function XmVaCreateSimpleMenuBar(
                parent: Xt.Intrinsic.Widget;
                name  : Interfaces.C.Char_Array;
                Args  : Stdarg.ArgList := Stdarg.Empty) 
            return Xt.Intrinsic.Widget is

        function "&"(S: Interfaces.C.Char_Array; C: Interfaces.C.Char)
	    return Interfaces.C.Char_Array renames Interfaces.C."&";
        Tmp_name: constant Interfaces.C.Char_Array := 
            name & Interfaces.C.Nul;
    begin
        return XmVaCreateSimpleMenuBar(
                parent,
                Tmp_name(Tmp_name'First)'unchecked_access,
                Args);
    end XmVaCreateSimpleMenuBar;                            -- Xm.h:969

    function XmVaCreateSimplePopupMenu(
                parent  : Xt.Intrinsic.Widget;
                name    : Interfaces.C.Char_Array;
                callback: Xt.Intrinsic.XtCallbackProc;
                Args    : Stdarg.ArgList := Stdarg.Empty) 
            return Xt.Intrinsic.Widget is

        function "&"(S: Interfaces.C.Char_Array; C: Interfaces.C.Char)
	    return Interfaces.C.Char_Array renames Interfaces.C."&";
        Tmp_name: constant Interfaces.C.Char_Array := 
            name & Interfaces.C.Nul;
    begin
        return XmVaCreateSimplePopupMenu(
                parent,
                Tmp_name(Tmp_name'First)'unchecked_access,
                callback,
                Args);
    end XmVaCreateSimplePopupMenu;                          -- Xm.h:973

    function XmVaCreateSimplePulldownMenu(
                parent          : Xt.Intrinsic.Widget;
                name            : Interfaces.C.Char_Array;
                post_from_button: X.signed_int;
                callback        : Xt.Intrinsic.XtCallbackProc;
                Args            : Stdarg.ArgList := Stdarg.Empty) 
            return Xt.Intrinsic.Widget is

        function "&"(S: Interfaces.C.Char_Array; C: Interfaces.C.Char)
	    return Interfaces.C.Char_Array renames Interfaces.C."&";
        Tmp_name: constant Interfaces.C.Char_Array := 
            name & Interfaces.C.Nul;
    begin
        return XmVaCreateSimplePulldownMenu(
                parent,
                Tmp_name(Tmp_name'First)'unchecked_access,
                post_from_button,
                callback,
                Args);
    end XmVaCreateSimplePulldownMenu;                       -- Xm.h:978

    function XmVaCreateSimpleOptionMenu(
                parent         : Xt.Intrinsic.Widget;
                name           : Interfaces.C.Char_Array;
                option_label   : XmString;
                option_mnemonic: X.KeySym;
                button_set     : X.signed_int;
                callback       : Xt.Intrinsic.XtCallbackProc;
                Args           : Stdarg.ArgList := Stdarg.Empty) 
            return Xt.Intrinsic.Widget is

        function "&"(S: Interfaces.C.Char_Array; C: Interfaces.C.Char)
	    return Interfaces.C.Char_Array renames Interfaces.C."&";
        Tmp_name: constant Interfaces.C.Char_Array := name & Interfaces.C.Nul;
    begin
        return XmVaCreateSimpleOptionMenu(
                parent,
                Tmp_name(Tmp_name'First)'unchecked_access,
                option_label,
                option_mnemonic,
                button_set,
                callback,
                Args);
    end XmVaCreateSimpleOptionMenu;                         -- Xm.h:984

    function XmVaCreateSimpleRadioBox(
                parent    : Xt.Intrinsic.Widget;
                name      : Interfaces.C.Char_Array;
                button_set: X.signed_int;
                callback  : Xt.Intrinsic.XtCallbackProc;
                Args      : Stdarg.ArgList := Stdarg.Empty) 
            return Xt.Intrinsic.Widget is

        function "&"(S: Interfaces.C.Char_Array; C: Interfaces.C.Char)
	    return Interfaces.C.Char_Array renames Interfaces.C."&";
        Tmp_name: constant Interfaces.C.Char_Array := 
            name & Interfaces.C.Nul;
    begin
        return XmVaCreateSimpleRadioBox(
                parent,
                Tmp_name(Tmp_name'First)'unchecked_access,
                button_set,
                callback,
                Args);
    end XmVaCreateSimpleRadioBox;                           -- Xm.h:992

    function XmVaCreateSimpleCheckBox(
                parent  : Xt.Intrinsic.Widget;
                name    : Interfaces.C.Char_Array;
                callback: Xt.Intrinsic.XtCallbackProc;
                Args    : Stdarg.ArgList := Stdarg.Empty) 
            return Xt.Intrinsic.Widget is

        function "&"(S: Interfaces.C.Char_Array; C: Interfaces.C.Char)
	    return Interfaces.C.Char_Array renames Interfaces.C."&";
        Tmp_name: constant Interfaces.C.Char_Array := 
            name & Interfaces.C.Nul;
    begin
        return XmVaCreateSimpleCheckBox(
                parent,
                Tmp_name(Tmp_name'First)'unchecked_access,
                callback,
                Args);
    end XmVaCreateSimpleCheckBox;                           -- Xm.h:998

    function XmStringCreate(
                text   : Interfaces.C.Char_Array;
                charset: Interfaces.C.Char_Array) return Xmstring is

        function "&"(S: Interfaces.C.Char_Array; C: Interfaces.C.Char)
	    return Interfaces.C.Char_Array renames Interfaces.C."&";
        Tmp_text: constant Interfaces.C.Char_Array := 
            text & Interfaces.C.Nul;
        Tmp_charset: constant Interfaces.C.Char_Array := 
            charset & Interfaces.C.Nul;
    begin
        return XmStringCreate(
                Tmp_text(Tmp_text'First)'unchecked_access,
                Tmp_charset(Tmp_charset'First)'unchecked_access);
    end XmStringCreate;                                     -- Xm.h:1125

    function XmStringCreateSimple(
                text: Interfaces.C.Char_Array) return Xmstring is

        function "&"(S: Interfaces.C.Char_Array; C: Interfaces.C.Char)
	    return Interfaces.C.Char_Array renames Interfaces.C."&";
        Tmp_text: constant Interfaces.C.Char_Array := 
            text & Interfaces.C.Nul;
    begin
        return XmStringCreateSimple(
                Tmp_text(Tmp_text'First)'unchecked_access);
    end XmStringCreateSimple;                               -- Xm.h:1128

    function XmStringCreateLocalized(
                text: Interfaces.C.Char_Array)
               return XmString is

        function "&"(S: Interfaces.C.Char_Array; C: Interfaces.C.Char)
	    return Interfaces.C.Char_Array renames Interfaces.C."&";
        Tmp_text: constant Interfaces.C.Char_Array := 
            text & Interfaces.C.Nul;
    begin
        return XmStringCreateLocalized(
                Tmp_text(Tmp_text'First)'unchecked_access);
    end XmStringCreateLocalized;                            -- Xm.h:1130

    function XmStringSegmentCreate(
                text     : Interfaces.C.Char_Array;
                charset  : Interfaces.C.Char_Array;
                direction: X.signed_int;
                separator: X.signed_int) return Xmstring is

        function "&"(S: Interfaces.C.Char_Array; C: Interfaces.C.Char)
	    return Interfaces.C.Char_Array renames Interfaces.C."&";
        Tmp_text: constant Interfaces.C.Char_Array := 
            text & Interfaces.C.Nul;
        Tmp_charset: constant Interfaces.C.Char_Array := 
            charset & Interfaces.C.Nul;
    begin
        return XmStringSegmentCreate(
                Tmp_text(Tmp_text'First)'unchecked_access,
                Tmp_charset(Tmp_charset'First)'unchecked_access,
                direction,
                separator);
    end XmStringSegmentCreate;                              -- Xm.h:1139

    function XmStringLtoRCreate(
                text   : Interfaces.C.Char_Array;
                charset: Interfaces.C.Char_Array) return Xmstring is

        function "&"(S: Interfaces.C.Char_Array; C: Interfaces.C.Char)
	    return Interfaces.C.Char_Array renames Interfaces.C."&";
        Tmp_text: constant Interfaces.C.Char_Array := 
            text & Interfaces.C.Nul;
        Tmp_charset: constant Interfaces.C.Char_Array := 
            charset & Interfaces.C.Nul;
    begin
        return XmStringLtoRCreate(
                Tmp_text(Tmp_text'First)'unchecked_access,
                Tmp_charset(Tmp_charset'First)'unchecked_access);
    end XmStringLtoRCreate;                                 -- Xm.h:1149

    function XmStringCreateLtoR(
                text   : Interfaces.C.Char_Array;
                charset: Interfaces.C.Char_Array) return Xmstring is

        function "&"(S: Interfaces.C.Char_Array; C: Interfaces.C.Char)
	    return Interfaces.C.Char_Array renames Interfaces.C."&";
        Tmp_text: constant Interfaces.C.Char_Array := 
            text & Interfaces.C.Nul;
        Tmp_charset: constant Interfaces.C.Char_Array := 
            charset & Interfaces.C.Nul;
    begin
        return XmStringCreateLtoR(
                Tmp_text(Tmp_text'First)'unchecked_access,
                Tmp_charset(Tmp_charset'First)'unchecked_access);
    end XmStringCreateLtoR;                                 -- Xm.h:1152

    function XmStringGetLtoR(
                string : XmString;
                charset: Interfaces.C.Char_Array;
                text   : X.Strings.charp_vector) 
            return Xt.Intrinsic.Boolean is

        function "&"(S: Interfaces.C.Char_Array; C: Interfaces.C.Char)
	    return Interfaces.C.Char_Array renames Interfaces.C."&";
        Tmp_charset: constant Interfaces.C.Char_Array := 
            charset & Interfaces.C.Nul;
    begin
        return XmStringGetLtoR(
                string,
                Tmp_charset(Tmp_charset'First)'unchecked_access,
                text);
    end XmStringGetLtoR;                                    -- Xm.h:1176

    function XmFontListEntryCreate(
                tag   : Interfaces.C.Char_Array;
                c_type: XmFontType;
                font  : Xt.Intrinsic.XtPointer) return XmFontListEntry is

        function "&"(S: Interfaces.C.Char_Array; C: Interfaces.C.Char)
	    return Interfaces.C.Char_Array renames Interfaces.C."&";
        Tmp_tag: constant Interfaces.C.Char_Array := 
            tag & Interfaces.C.Nul;
    begin
        return XmFontListEntryCreate(
                Tmp_tag(Tmp_tag'First)'unchecked_access,
                c_type,
                font);
    end XmFontListEntryCreate;                              -- Xm.h:1180

    function XmFontListEntryLoad(
                display : access X.Xlib.Display;
                fontName: Interfaces.C.Char_Array;
                c_type  : XmFontType;
                tag     : Interfaces.C.Char_Array) return XmFontListEntry is

        function "&"(S: Interfaces.C.Char_Array; C: Interfaces.C.Char)
	    return Interfaces.C.Char_Array renames Interfaces.C."&";
        Tmp_fontName: constant Interfaces.C.Char_Array := 
            fontName & Interfaces.C.Nul;
        Tmp_tag: constant Interfaces.C.Char_Array := 
            tag & Interfaces.C.Nul;
    begin
        return XmFontListEntryLoad(
                display,
                Tmp_fontName(Tmp_fontName'First)'unchecked_access,
                c_type,
                Tmp_tag(Tmp_tag'First)'unchecked_access);
    end XmFontListEntryLoad;                                -- Xm.h:1199

    function XmFontListCreate(
                font   : X.Xlib.XFontStruct_access;
                charset: Interfaces.C.Char_Array) return XmFontList is

        function "&"(S: Interfaces.C.Char_Array; C: Interfaces.C.Char)
	    return Interfaces.C.Char_Array renames Interfaces.C."&";
        Tmp_charset: constant Interfaces.C.Char_Array := 
            charset & Interfaces.C.Nul;
    begin
        return XmFontListCreate(
                font,
                Tmp_charset(Tmp_charset'First)'unchecked_access);
    end XmFontListCreate;                                   -- Xm.h:1204

    function XmStringCreateFontList(
                font   : X.Xlib.XFontStruct_access;
                charset: Interfaces.C.Char_Array) return XmFontList is

        function "&"(S: Interfaces.C.Char_Array; C: Interfaces.C.Char)
	    return Interfaces.C.Char_Array renames Interfaces.C."&";
        Tmp_charset: constant Interfaces.C.Char_Array := 
            charset & Interfaces.C.Nul;
    begin
        return XmStringCreateFontList(
                font,
                Tmp_charset(Tmp_charset'First)'unchecked_access);
    end XmStringCreateFontList;                             -- Xm.h:1207

    function XmFontListAdd(
                old    : XmFontList;
                font   : X.Xlib.XFontStruct_access;
                charset: Interfaces.C.Char_Array) return XmFontList is

        function "&"(S: Interfaces.C.Char_Array; C: Interfaces.C.Char)
	    return Interfaces.C.Char_Array renames Interfaces.C."&";
        Tmp_charset: constant Interfaces.C.Char_Array := 
            charset & Interfaces.C.Nul;
    begin
        return XmFontListAdd(
                old,
                font,
                Tmp_charset(Tmp_charset'First)'unchecked_access);
    end XmFontListAdd;                                      -- Xm.h:1212

    procedure XmImMbLookupString(
                w     : Xt.Intrinsic.Widget;
                event : access X.Xlib.XKeyEvent;
                buf   : in out Interfaces.C.Char_Array;
                nbytes: X.signed_int;
                keysym: access X.Keysym;
                status: access X.signed_int;
                result: out X.signed_int) is

    begin
        result := XmImMbLookupString(
                w,
                event,
                buf(buf'First)'unchecked_access,
                nbytes,
                keysym,
                status);
    end XmImMbLookupString;                                 -- Xm.h:1413

end Motif.Xm;
