-- $Source: /home/harp/1/proto/monoBANK/xbind/motif-xm.ads,v $ 
-- $Revision: 1.7 $ $Date: 95/12/19 15:35:10 $ $Author: mg $ 

-- --------------------------------------------------------------------------
-- THIS FILE AND ANY ASSOCIATED DOCUMENTATION IS PROVIDED "AS IS" WITHOUT 
-- WARRANTY OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
-- TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A 
-- PARTICULAR PURPOSE.  The user assumes the entire risk as to the accuracy 
-- and the use of this file.  
--  
-- Ada version Copyright (c) Intermetrics, Inc. 1994 
-- Royalty-free, unlimited, worldwide, non-exclusive use, modification, 
-- reproduction and further distribution of this Ada file is permitted. 
--
-- C version contains additional copyrights, 
-- see the accompanying file Xm.h.
-- --------------------------------------------------------------------------

with X;
with Interfaces.C;
with Stdarg;
with X.Xatom;
with X.Strings;
with X.Xlib;
with X.Xresource;
with Xt.Intrinsic;

package Motif.Xm is

    subtype Char_Array is Interfaces.C.Char_Array;
    Nul: Interfaces.C.Char renames Interfaces.C.Nul;
    function "&"(S: Interfaces.C.Char_Array; C: Interfaces.C.Char)
	return Interfaces.C.Char_Array renames Interfaces.C."&";

    XmVERSION                     : constant := 1;          -- Xm.h:37
    XmREVISION                    : constant := 2;          -- Xm.h:38
    XmUPDATE_LEVEL                : constant := 2;          -- Xm.h:39
    XmVersion_2                   : constant := 1002;       -- Xm.h:40
    XmVERSION_STRING              : constant Char_Array := 
                                    "@(#)OSF/Motif Version 1.2.2" & Nul;
                                                            -- Xm.h:41
    XmUNSPECIFIED_PIXMAP          : constant := 2;          -- Xm.h:48
    XmSTRING_OS_CHARSET           : constant Char_Array := "ISO8859-1" & Nul;
                                                            -- Xm.h:57
    XmFALLBACK_CHARSET            : constant Char_Array := "ISO8859-1" & Nul;
                                                            -- Xm.h:59
    XmDEFAULT_DARK_THRESHOLD      : constant := 15;         -- Xm.h:64
    XmDEFAULT_LIGHT_THRESHOLD     : constant := 77;         -- Xm.h:65
    XmDEFAULT_FOREGROUND_THRESHOLD: constant := 35;         -- Xm.h:66
    XmDYNAMIC_DEFAULT_TAB_GROUP   : constant := 255;        -- Xm.h:197
    SW_TOP                        : constant := 1;          -- Xm.h:482
    SW_BOTTOM                     : constant := 0;          -- Xm.h:483
    SW_LEFT                       : constant := 2;          -- Xm.h:484
    SW_RIGHT                      : constant := 0;          -- Xm.h:485
    XmTOP_LEFT                    : constant := 3;          -- Xm.h:487
    XmBOTTOM_LEFT                 : constant := 2;          -- Xm.h:488
    XmTOP_RIGHT                   : constant := 1;          -- Xm.h:489
    XmBOTTOM_RIGHT                : constant := 0;          -- Xm.h:490
    XmCOPY_FAILED                 : constant := 0;          -- Xm.h:574
    XmCOPY_SUCCEEDED              : constant := 1;          -- Xm.h:575
    XmCOPY_TRUNCATED              : constant := 2;          -- Xm.h:576
    XmFILE_DIRECTORY              : constant := 1;          -- Xm.h:627
    XmFILE_REGULAR                : constant := 2;          -- Xm.h:628
    XmFILE_ANY_TYPE               : constant := 3;          -- Xm.h:629

    type XmTextFormat is new X.Atom;                        -- Xm.h:515
    XmFMT_8_BIT                   : constant XmTextFormat := 
                                    XmTextFormat(X.Xatom.XA_STRING);
                                                            -- Xm.h:517
    FMT8BIT                       : XmTextFormat renames XmFMT_8_BIT;
                                                            -- Xm.h:520

    XmFMT_16_BIT                  : constant XmTextFormat := 2;
                                                            -- Xm.h:518
    FMT16BIT                      : XmTextFormat renames XmFMT_16_BIT;
                                                            -- Xm.h:521

    type XmFontType is (                                    -- Xm.h:77
        XmFONT_IS_FONT,                                     -- Xm.h:77
        XmFONT_IS_FONTSET                                   -- Xm.h:77
    );
    for XmFontType'Size use X.Int'Size;                     -- Xm.h:77

    type enum_anonymous2_t is (                             -- Xm.h:81
        XmSTRING_DIRECTION_L_TO_R,                          -- Xm.h:79
        XmSTRING_DIRECTION_R_TO_L,                          -- Xm.h:79
        XmSTRING_DIRECTION_DEFAULT                          -- Xm.h:81
    );
    for enum_anonymous2_t use (                             -- Xm.h:81
        XmSTRING_DIRECTION_L_TO_R => 0,                     -- Xm.h:79
        XmSTRING_DIRECTION_R_TO_L => 1,                     -- Xm.h:79
        XmSTRING_DIRECTION_DEFAULT => 255                   -- Xm.h:81
    );
    for enum_anonymous2_t'Size use X.Int'Size;              -- Xm.h:81

    type XmStringDirection is new X.unsigned_char;          -- Xm.h:83
    type XmStringComponentType is new X.unsigned_char;      -- Xm.h:87
    XmSTRING_COMPONENT_END        : constant XmStringComponentType := 126;
                                                            -- Xm.h:102
    XmSTRING_COMPONENT_USER_BEGIN : constant XmStringComponentType := 128;
                                                            -- Xm.h:104
    XmSTRING_COMPONENT_USER_END   : constant XmStringComponentType := 255;
                                                            -- Xm.h:106

    type enum_anonymous3_t is (                             -- Xm.h:100
        XmSTRING_COMPONENT_UNKNOWN,                         -- Xm.h:96
        XmSTRING_COMPONENT_CHARSET,                         -- Xm.h:96
        XmSTRING_COMPONENT_TEXT,                            -- Xm.h:97
        XmSTRING_COMPONENT_DIRECTION,                       -- Xm.h:97
        XmSTRING_COMPONENT_SEPARATOR,                       -- Xm.h:98
        XmSTRING_COMPONENT_LOCALE_TEXT                      -- Xm.h:100
    );
    for enum_anonymous3_t'Size use X.Int'Size;              -- Xm.h:100

    type enum_anonymous4_t is (                             -- Xm.h:173
        XmCHANGE_ALL,                                       -- Xm.h:171
        XmCHANGE_NONE,                                      -- Xm.h:171
        XmCHANGE_WIDTH,                                     -- Xm.h:172
        XmCHANGE_HEIGHT                                     -- Xm.h:173
    );
    for enum_anonymous4_t'Size use X.Int'Size;              -- Xm.h:173

    type enum_anonymous5_t is (                             -- Xm.h:180
        XmPIXELS,                                           -- Xm.h:177
        Xm100TH_MILLIMETERS,                                -- Xm.h:177
        Xm1000TH_INCHES,                                    -- Xm.h:178
        Xm100TH_POINTS,                                     -- Xm.h:178
        Xm100TH_FONT_UNITS                                  -- Xm.h:180
    );
    for enum_anonymous5_t'Size use X.Int'Size;              -- Xm.h:180

    type enum_anonymous6_t is (                             -- Xm.h:186
        XmDESTROY,                                          -- Xm.h:184
        XmUNMAP,                                            -- Xm.h:184
        XmDO_NOTHING                                        -- Xm.h:186
    );
    for enum_anonymous6_t'Size use X.Int'Size;              -- Xm.h:186

    type enum_anonymous7_t is (                             -- Xm.h:188
        XmEXPLICIT,                                         -- Xm.h:187
        XmPOINTER                                           -- Xm.h:188
    );
    for enum_anonymous7_t'Size use X.Int'Size;              -- Xm.h:188

    type enum_anonymous8_t is (                             -- Xm.h:195
        XmNONE,                                             -- Xm.h:193
        XmTAB_GROUP,                                        -- Xm.h:193
        XmSTICKY_TAB_GROUP,                                 -- Xm.h:194
        XmEXCLUSIVE_TAB_GROUP                               -- Xm.h:195
    );
    for enum_anonymous8_t'Size use X.Int'Size;              -- Xm.h:195

    type enum_anonymous9_t is (                             -- Xm.h:204
        XmBELL                                              -- Xm.h:204
    );
    for enum_anonymous9_t use (                             -- Xm.h:204
        XmBELL => 1                                         -- Xm.h:204
    );
    for enum_anonymous9_t'Size use X.Int'Size;              -- Xm.h:204

    type enum_anonymous10_t is (                            -- Xm.h:212
        XmNO_ORIENTATION,                                   -- Xm.h:210
        XmVERTICAL,                                         -- Xm.h:210
        XmHORIZONTAL                                        -- Xm.h:212
    );
    for enum_anonymous10_t'Size use X.Int'Size;             -- Xm.h:212

    type enum_anonymous11_t is (                            -- Xm.h:216
        XmWORK_AREA,                                        -- Xm.h:213
        XmMENU_BAR,                                         -- Xm.h:213
        XmMENU_PULLDOWN,                                    -- Xm.h:214
        XmMENU_POPUP,                                       -- Xm.h:214
        XmMENU_OPTION                                       -- Xm.h:216
    );
    for enum_anonymous11_t'Size use X.Int'Size;             -- Xm.h:216

    type enum_anonymous12_t is (                            -- Xm.h:219
        XmNO_PACKING,                                       -- Xm.h:217
        XmPACK_TIGHT,                                       -- Xm.h:217
        XmPACK_COLUMN,                                      -- Xm.h:218
        XmPACK_NONE                                         -- Xm.h:219
    );
    for enum_anonymous12_t'Size use X.Int'Size;             -- Xm.h:219

    type enum_anonymous13_t is (                            -- Xm.h:223
        XmALIGNMENT_CONTENTS_TOP,                           -- Xm.h:220
        XmALIGNMENT_CONTENTS_BOTTOM                         -- Xm.h:223
    );
    for enum_anonymous13_t use (                            -- Xm.h:223
        XmALIGNMENT_CONTENTS_TOP => 3,                      -- Xm.h:220
        XmALIGNMENT_CONTENTS_BOTTOM => 4                    -- Xm.h:223
    );
    for enum_anonymous13_t'Size use X.Int'Size;             -- Xm.h:223

    type enum_anonymous14_t is (                            -- Xm.h:225
        XmTEAR_OFF_ENABLED,                                 -- Xm.h:224
        XmTEAR_OFF_DISABLED                                 -- Xm.h:225
    );
    for enum_anonymous14_t'Size use X.Int'Size;             -- Xm.h:225

    type enum_anonymous15_t is (                            -- Xm.h:227
        XmUNPOST,                                           -- Xm.h:226
        XmUNPOST_AND_REPLAY                                 -- Xm.h:227
    );
    for enum_anonymous15_t'Size use X.Int'Size;             -- Xm.h:227

    type enum_anonymous16_t is (                            -- Xm.h:229
        XmLAST_POSITION,                                    -- Xm.h:228
        XmFIRST_POSITION                                    -- Xm.h:229
    );
    for enum_anonymous16_t use (                            -- Xm.h:229
        XmLAST_POSITION => -1,                              -- Xm.h:228
        XmFIRST_POSITION => 0                               -- Xm.h:229
    );
    for enum_anonymous16_t'Size use X.Int'Size;             -- Xm.h:229

    type enum_anonymous17_t is (                            -- Xm.h:236
        XmALIGNMENT_BEGINNING,                              -- Xm.h:234
        XmALIGNMENT_CENTER,                                 -- Xm.h:234
        XmALIGNMENT_END                                     -- Xm.h:236
    );
    for enum_anonymous17_t'Size use X.Int'Size;             -- Xm.h:236

    type enum_anonymous18_t is (                            -- Xm.h:240
        XmALIGNMENT_BASELINE_TOP,                           -- Xm.h:237
        XmALIGNMENT_BASELINE_BOTTOM,                        -- Xm.h:238
        XmALIGNMENT_WIDGET_TOP,                             -- Xm.h:238
        XmALIGNMENT_WIDGET_BOTTOM                           -- Xm.h:240
    );
    for enum_anonymous18_t use (                            -- Xm.h:240
        XmALIGNMENT_BASELINE_TOP => 0,                      -- Xm.h:237
        XmALIGNMENT_BASELINE_BOTTOM => 2,                   -- Xm.h:238
        XmALIGNMENT_WIDGET_TOP => 3,                        -- Xm.h:238
        XmALIGNMENT_WIDGET_BOTTOM => 4                      -- Xm.h:240
    );
    for enum_anonymous18_t'Size use X.Int'Size;             -- Xm.h:240

    type enum_anonymous19_t is (                            -- Xm.h:247
        XmFRAME_GENERIC_CHILD,                              -- Xm.h:245
        XmFRAME_WORKAREA_CHILD,                             -- Xm.h:245
        XmFRAME_TITLE_CHILD                                 -- Xm.h:247
    );
    for enum_anonymous19_t'Size use X.Int'Size;             -- Xm.h:247

    type enum_anonymous20_t is (                            -- Xm.h:253
        XmN_OF_MANY,                                        -- Xm.h:252
        XmONE_OF_MANY                                       -- Xm.h:253
    );
    for enum_anonymous20_t use (                            -- Xm.h:253
        XmN_OF_MANY => 1,                                   -- Xm.h:252
        XmONE_OF_MANY => 2                                  -- Xm.h:253
    );
    for enum_anonymous20_t'Size use X.Int'Size;             -- Xm.h:253

    type enum_anonymous21_t is (                            -- Xm.h:262
        XmATTACH_NONE,                                      -- Xm.h:258
        XmATTACH_FORM,                                      -- Xm.h:258
        XmATTACH_OPPOSITE_FORM,                             -- Xm.h:259
        XmATTACH_WIDGET,                                    -- Xm.h:259
        XmATTACH_OPPOSITE_WIDGET,                           -- Xm.h:260
        XmATTACH_POSITION,                                  -- Xm.h:260
        XmATTACH_SELF                                       -- Xm.h:262
    );
    for enum_anonymous21_t'Size use X.Int'Size;             -- Xm.h:262

    type enum_anonymous22_t is (                            -- Xm.h:265
        XmRESIZE_NONE,                                      -- Xm.h:263
        XmRESIZE_GROW,                                      -- Xm.h:263
        XmRESIZE_ANY                                        -- Xm.h:265
    );
    for enum_anonymous22_t'Size use X.Int'Size;             -- Xm.h:265

    type enum_anonymous23_t is (                            -- Xm.h:292
        XmCR_NONE,                                          -- Xm.h:270
        XmCR_HELP,                                          -- Xm.h:270
        XmCR_VALUE_CHANGED,                                 -- Xm.h:271
        XmCR_INCREMENT,                                     -- Xm.h:271
        XmCR_DECREMENT,                                     -- Xm.h:272
        XmCR_PAGE_INCREMENT,                                -- Xm.h:272
        XmCR_PAGE_DECREMENT,                                -- Xm.h:273
        XmCR_TO_TOP,                                        -- Xm.h:273
        XmCR_TO_BOTTOM,                                     -- Xm.h:274
        XmCR_DRAG,                                          -- Xm.h:274
        XmCR_ACTIVATE,                                      -- Xm.h:275
        XmCR_ARM,                                           -- Xm.h:275
        XmCR_DISARM,                                        -- Xm.h:276
        XmCR_MAP,                                           -- Xm.h:276
        XmCR_UNMAP,                                         -- Xm.h:277
        XmCR_FOCUS,                                         -- Xm.h:277
        XmCR_LOSING_FOCUS,                                  -- Xm.h:278
        XmCR_MODIFYING_TEXT_VALUE,                          -- Xm.h:278
        XmCR_MOVING_INSERT_CURSOR,                          -- Xm.h:279
        XmCR_EXECUTE,                                       -- Xm.h:279
        XmCR_SINGLE_SELECT,                                 -- Xm.h:280
        XmCR_MULTIPLE_SELECT,                               -- Xm.h:280
        XmCR_EXTENDED_SELECT,                               -- Xm.h:281
        XmCR_BROWSE_SELECT,                                 -- Xm.h:281
        XmCR_DEFAULT_ACTION,                                -- Xm.h:282
        XmCR_CLIPBOARD_DATA_REQUEST,                        -- Xm.h:282
        XmCR_CLIPBOARD_DATA_DELETE,                         -- Xm.h:283
        XmCR_CASCADING,                                     -- Xm.h:283
        XmCR_OK,                                            -- Xm.h:284
        XmCR_CANCEL,                                        -- Xm.h:284
        XmCR_APPLY,                                         -- Xm.h:285
        XmCR_NO_MATCH,                                      -- Xm.h:285
        XmCR_COMMAND_ENTERED,                               -- Xm.h:286
        XmCR_COMMAND_CHANGED,                               -- Xm.h:286
        XmCR_EXPOSE,                                        -- Xm.h:287
        XmCR_RESIZE,                                        -- Xm.h:287
        XmCR_INPUT,                                         -- Xm.h:288
        XmCR_GAIN_PRIMARY,                                  -- Xm.h:288
        XmCR_LOSE_PRIMARY,                                  -- Xm.h:289
        XmCR_CREATE,                                        -- Xm.h:289
        XmCR_TEAR_OFF_ACTIVATE,                             -- Xm.h:290
        XmCR_TEAR_OFF_DEACTIVATE,                           -- Xm.h:290
        XmCR_OBSCURED_TRAVERSAL                             -- Xm.h:292
    );
    for enum_anonymous23_t use (                            -- Xm.h:292
        XmCR_NONE => 0,                                     -- Xm.h:270
        XmCR_HELP => 1,                                     -- Xm.h:270
        XmCR_VALUE_CHANGED => 2,                            -- Xm.h:271
        XmCR_INCREMENT => 3,                                -- Xm.h:271
        XmCR_DECREMENT => 4,                                -- Xm.h:272
        XmCR_PAGE_INCREMENT => 5,                           -- Xm.h:272
        XmCR_PAGE_DECREMENT => 6,                           -- Xm.h:273
        XmCR_TO_TOP => 7,                                   -- Xm.h:273
        XmCR_TO_BOTTOM => 8,                                -- Xm.h:274
        XmCR_DRAG => 9,                                     -- Xm.h:274
        XmCR_ACTIVATE => 10,                                -- Xm.h:275
        XmCR_ARM => 11,                                     -- Xm.h:275
        XmCR_DISARM => 12,                                  -- Xm.h:276
        XmCR_MAP => 16,                                     -- Xm.h:276
        XmCR_UNMAP => 17,                                   -- Xm.h:277
        XmCR_FOCUS => 18,                                   -- Xm.h:277
        XmCR_LOSING_FOCUS => 19,                            -- Xm.h:278
        XmCR_MODIFYING_TEXT_VALUE => 20,                    -- Xm.h:278
        XmCR_MOVING_INSERT_CURSOR => 21,                    -- Xm.h:279
        XmCR_EXECUTE => 22,                                 -- Xm.h:279
        XmCR_SINGLE_SELECT => 23,                           -- Xm.h:280
        XmCR_MULTIPLE_SELECT => 24,                         -- Xm.h:280
        XmCR_EXTENDED_SELECT => 25,                         -- Xm.h:281
        XmCR_BROWSE_SELECT => 26,                           -- Xm.h:281
        XmCR_DEFAULT_ACTION => 27,                          -- Xm.h:282
        XmCR_CLIPBOARD_DATA_REQUEST => 28,                  -- Xm.h:282
        XmCR_CLIPBOARD_DATA_DELETE => 29,                   -- Xm.h:283
        XmCR_CASCADING => 30,                               -- Xm.h:283
        XmCR_OK => 31,                                      -- Xm.h:284
        XmCR_CANCEL => 32,                                  -- Xm.h:284
        XmCR_APPLY => 34,                                   -- Xm.h:285
        XmCR_NO_MATCH => 35,                                -- Xm.h:285
        XmCR_COMMAND_ENTERED => 36,                         -- Xm.h:286
        XmCR_COMMAND_CHANGED => 37,                         -- Xm.h:286
        XmCR_EXPOSE => 38,                                  -- Xm.h:287
        XmCR_RESIZE => 39,                                  -- Xm.h:287
        XmCR_INPUT => 40,                                   -- Xm.h:288
        XmCR_GAIN_PRIMARY => 41,                            -- Xm.h:288
        XmCR_LOSE_PRIMARY => 42,                            -- Xm.h:289
        XmCR_CREATE => 43,                                  -- Xm.h:289
        XmCR_TEAR_OFF_ACTIVATE => 44,                       -- Xm.h:290
        XmCR_TEAR_OFF_DEACTIVATE => 45,                     -- Xm.h:290
        XmCR_OBSCURED_TRAVERSAL => 46                       -- Xm.h:292
    );
    for enum_anonymous23_t'Size use X.Int'Size;             -- Xm.h:292

    type enum_anonymous37_t is (                            -- Xm.h:413
        XmMULTICLICK_DISCARD,                               -- Xm.h:412
        XmMULTICLICK_KEEP                                   -- Xm.h:413
    );
    for enum_anonymous37_t'Size use X.Int'Size;             -- Xm.h:413

    type enum_anonymous38_t is (                            -- Xm.h:419
        XmSHADOW_IN,                                        -- Xm.h:418
        XmSHADOW_OUT                                        -- Xm.h:419
    );
    for enum_anonymous38_t use (                            -- Xm.h:419
        XmSHADOW_IN => 7,                                   -- Xm.h:418
        XmSHADOW_OUT => 8                                   -- Xm.h:419
    );
    for enum_anonymous38_t'Size use X.Int'Size;             -- Xm.h:419

    type enum_anonymous39_t is (                            -- Xm.h:426
        XmARROW_UP,                                         -- Xm.h:424
        XmARROW_DOWN,                                       -- Xm.h:424
        XmARROW_LEFT,                                       -- Xm.h:425
        XmARROW_RIGHT                                       -- Xm.h:426
    );
    for enum_anonymous39_t'Size use X.Int'Size;             -- Xm.h:426

    type enum_anonymous40_t is (                            -- Xm.h:437
        XmNO_LINE,                                          -- Xm.h:432
        XmSINGLE_LINE,                                      -- Xm.h:432
        XmDOUBLE_LINE,                                      -- Xm.h:433
        XmSINGLE_DASHED_LINE,                               -- Xm.h:433
        XmDOUBLE_DASHED_LINE,                               -- Xm.h:434
        XmSHADOW_ETCHED_IN,                                 -- Xm.h:434
        XmSHADOW_ETCHED_OUT,                                -- Xm.h:435
        XmSHADOW_ETCHED_IN_DASH,                            -- Xm.h:435
        XmSHADOW_ETCHED_OUT_DASH,                           -- Xm.h:436
        XmINVALID_SEPARATOR_TYPE                            -- Xm.h:437
    );
    for enum_anonymous40_t'Size use X.Int'Size;             -- Xm.h:437

    type enum_anonymous41_t is (                            -- Xm.h:440
        XmPIXMAP,                                           -- Xm.h:439
        XmSTRING_enum                                       -- Xm.h:440
    );
    for enum_anonymous41_t use (                            -- Xm.h:440
        XmPIXMAP => 1,                                      -- Xm.h:439
        XmSTRING_enum => 2                                  -- Xm.h:440
    );
    for enum_anonymous41_t'Size use X.Int'Size;             -- Xm.h:440

    type enum_anonymous42_t is (                            -- Xm.h:448
        XmWINDOW,                                           -- Xm.h:446
        XmCURSOR                                            -- Xm.h:448
    );
    for enum_anonymous42_t use (                            -- Xm.h:448
        XmWINDOW => 0,                                      -- Xm.h:446
        XmCURSOR => 2                                       -- Xm.h:448
    );
    for enum_anonymous42_t'Size use X.Int'Size;             -- Xm.h:448

    type enum_anonymous43_t is (                            -- Xm.h:456
        XmMAX_ON_TOP,                                       -- Xm.h:454
        XmMAX_ON_BOTTOM,                                    -- Xm.h:454
        XmMAX_ON_LEFT,                                      -- Xm.h:455
        XmMAX_ON_RIGHT                                      -- Xm.h:456
    );
    for enum_anonymous43_t'Size use X.Int'Size;             -- Xm.h:456

    type enum_anonymous44_t is (                            -- Xm.h:465
        XmSINGLE_SELECT,                                    -- Xm.h:463
        XmMULTIPLE_SELECT,                                  -- Xm.h:463
        XmEXTENDED_SELECT,                                  -- Xm.h:464
        XmBROWSE_SELECT                                     -- Xm.h:465
    );
    for enum_anonymous44_t'Size use X.Int'Size;             -- Xm.h:465

    type enum_anonymous45_t is (                            -- Xm.h:467
        XmSTATIC,                                           -- Xm.h:466
        XmDYNAMIC                                           -- Xm.h:467
    );
    for enum_anonymous45_t'Size use X.Int'Size;             -- Xm.h:467

    type enum_anonymous46_t is (                            -- Xm.h:476
        XmVARIABLE,                                         -- Xm.h:474
        XmCONSTANT,                                         -- Xm.h:474
        XmRESIZE_IF_POSSIBLE                                -- Xm.h:476
    );
    for enum_anonymous46_t'Size use X.Int'Size;             -- Xm.h:476

    type enum_anonymous47_t is (                            -- Xm.h:478
        XmAUTOMATIC,                                        -- Xm.h:477
        XmAPPLICATION_DEFINED                               -- Xm.h:478
    );
    for enum_anonymous47_t'Size use X.Int'Size;             -- Xm.h:478

    type enum_anonymous48_t is (                            -- Xm.h:480
        XmAS_NEEDED                                         -- Xm.h:480
    );
    for enum_anonymous48_t use (                            -- Xm.h:480
        XmAS_NEEDED => 1                                    -- Xm.h:480
    );
    for enum_anonymous48_t'Size use X.Int'Size;             -- Xm.h:480

    type enum_anonymous49_t is (                            -- Xm.h:499
        XmCOMMAND_ABOVE_WORKSPACE,                          -- Xm.h:498
        XmCOMMAND_BELOW_WORKSPACE                           -- Xm.h:499
    );
    for enum_anonymous49_t'Size use X.Int'Size;             -- Xm.h:499

    type enum_anonymous50_t is (                            -- Xm.h:507
        XmMULTI_LINE_EDIT,                                  -- Xm.h:506
        XmSINGLE_LINE_EDIT                                  -- Xm.h:507
    );
    for enum_anonymous50_t'Size use X.Int'Size;             -- Xm.h:507

    type XmTextDirection is (                               -- Xm.h:512
        XmTEXT_FORWARD,                                     -- Xm.h:510
        XmTEXT_BACKWARD                                     -- Xm.h:512
    );
    for XmTextDirection'Size use X.Int'Size;                -- Xm.h:512

    type XmTextPosition is new X.signed_int;                -- Xm.h:514

    type XmTextScanType is (                                -- Xm.h:527
        XmSELECT_POSITION,                                  -- Xm.h:524
        XmSELECT_WHITESPACE,                                -- Xm.h:524
        XmSELECT_WORD,                                      -- Xm.h:525
        XmSELECT_LINE,                                      -- Xm.h:525
        XmSELECT_ALL,                                       -- Xm.h:526
        XmSELECT_PARAGRAPH                                  -- Xm.h:527
    );
    for XmTextScanType'Size use X.Int'Size;                 -- Xm.h:527

    type XmHighlightMode is (                               -- Xm.h:532
        XmHIGHLIGHT_NORMAL,                                 -- Xm.h:530
        XmHIGHLIGHT_SELECTED,                               -- Xm.h:530
        XmHIGHLIGHT_SECONDARY_SELECTED                      -- Xm.h:532
    );
    for XmHighlightMode'Size use X.Int'Size;                -- Xm.h:532

    type enum_anonymous58_t is (                            -- Xm.h:596
        XmDIALOG_NONE,                                      -- Xm.h:587
        XmDIALOG_APPLY_BUTTON,                              -- Xm.h:587
        XmDIALOG_CANCEL_BUTTON,                             -- Xm.h:588
        XmDIALOG_DEFAULT_BUTTON,                            -- Xm.h:588
        XmDIALOG_OK_BUTTON,                                 -- Xm.h:589
        XmDIALOG_FILTER_LABEL,                              -- Xm.h:589
        XmDIALOG_FILTER_TEXT,                               -- Xm.h:590
        XmDIALOG_HELP_BUTTON,                               -- Xm.h:590
        XmDIALOG_LIST,                                      -- Xm.h:591
        XmDIALOG_LIST_LABEL,                                -- Xm.h:591
        XmDIALOG_MESSAGE_LABEL,                             -- Xm.h:592
        XmDIALOG_SELECTION_LABEL,                           -- Xm.h:592
        XmDIALOG_SYMBOL_LABEL,                              -- Xm.h:593
        XmDIALOG_TEXT,                                      -- Xm.h:593
        XmDIALOG_SEPARATOR,                                 -- Xm.h:594
        XmDIALOG_DIR_LIST,                                  -- Xm.h:594
        XmDIALOG_DIR_LIST_LABEL                             -- Xm.h:596
    );
    for enum_anonymous58_t'Size use X.Int'Size;             -- Xm.h:596

    function XmDIALOG_HISTORY_LIST return enum_anonymous58_t
        renames XmDIALOG_LIST;                              -- Xm.h:598

    function XmDIALOG_PROMPT_LABEL return enum_anonymous58_t
        renames XmDIALOG_SELECTION_LABEL;                   -- Xm.h:599

    function XmDIALOG_VALUE_TEXT return enum_anonymous58_t
        renames XmDIALOG_TEXT;                              -- Xm.h:600

    function XmDIALOG_COMMAND_TEXT return enum_anonymous58_t
        renames XmDIALOG_TEXT;                              -- Xm.h:601

    function XmDIALOG_FILE_LIST return enum_anonymous58_t
        renames XmDIALOG_LIST;                              -- Xm.h:602

    function XmDIALOG_FILE_LIST_LABEL return enum_anonymous58_t
        renames XmDIALOG_LIST_LABEL;                        -- Xm.h:603

    type enum_anonymous59_t is (                            -- Xm.h:609
        XmDIALOG_MODELESS,                                  -- Xm.h:607
        XmDIALOG_PRIMARY_APPLICATION_MODAL,                 -- Xm.h:607
        XmDIALOG_FULL_APPLICATION_MODAL,                    -- Xm.h:608
        XmDIALOG_SYSTEM_MODAL                               -- Xm.h:609
    );
    for enum_anonymous59_t'Size use X.Int'Size;             -- Xm.h:609

    function XmDIALOG_APPLICATION_MODAL return enum_anonymous59_t
        renames XmDIALOG_PRIMARY_APPLICATION_MODAL;         -- Xm.h:613

    type enum_anonymous60_t is (                            -- Xm.h:623
        XmPLACE_TOP,                                        -- Xm.h:621
        XmPLACE_ABOVE_SELECTION,                            -- Xm.h:621
        XmPLACE_BELOW_SELECTION                             -- Xm.h:623
    );
    for enum_anonymous60_t'Size use X.Int'Size;             -- Xm.h:623

    type enum_anonymous61_t is (                            -- Xm.h:636
        XmDIALOG_WORK_AREA,                                 -- Xm.h:633
        XmDIALOG_PROMPT,                                    -- Xm.h:633
        XmDIALOG_SELECTION,                                 -- Xm.h:634
        XmDIALOG_COMMAND,                                   -- Xm.h:634
        XmDIALOG_FILE_SELECTION                             -- Xm.h:636
    );
    for enum_anonymous61_t'Size use X.Int'Size;             -- Xm.h:636

    type enum_anonymous62_t is (                            -- Xm.h:648
        XmDIALOG_TEMPLATE,                                  -- Xm.h:644
        XmDIALOG_ERROR,                                     -- Xm.h:644
        XmDIALOG_INFORMATION,                               -- Xm.h:645
        XmDIALOG_MESSAGE,                                   -- Xm.h:645
        XmDIALOG_QUESTION,                                  -- Xm.h:646
        XmDIALOG_WARNING,                                   -- Xm.h:646
        XmDIALOG_WORKING                                    -- Xm.h:648
    );
    for enum_anonymous62_t'Size use X.Int'Size;             -- Xm.h:648

    type XmVisibility is (                                  -- Xm.h:655
        XmVISIBILITY_UNOBSCURED,                            -- Xm.h:653
        XmVISIBILITY_PARTIALLY_OBSCURED,                    -- Xm.h:653
        XmVISIBILITY_FULLY_OBSCURED                         -- Xm.h:655
    );
    for XmVisibility'Size use X.Int'Size;                   -- Xm.h:655

    type XmTraversalDirection is (                          -- Xm.h:664
        XmTRAVERSE_CURRENT,                                 -- Xm.h:659
        XmTRAVERSE_NEXT,                                    -- Xm.h:659
        XmTRAVERSE_PREV,                                    -- Xm.h:660
        XmTRAVERSE_HOME,                                    -- Xm.h:660
        XmTRAVERSE_NEXT_TAB_GROUP,                          -- Xm.h:661
        XmTRAVERSE_PREV_TAB_GROUP,                          -- Xm.h:661
        XmTRAVERSE_UP,                                      -- Xm.h:662
        XmTRAVERSE_DOWN,                                    -- Xm.h:662
        XmTRAVERSE_LEFT,                                    -- Xm.h:663
        XmTRAVERSE_RIGHT                                    -- Xm.h:664
    );
    for XmTraversalDirection'Size use X.Int'Size;           -- Xm.h:664

    type XmNavigationType is new X.unsigned_char;           -- Xm.h:673
    type XmButtonType is new X.unsigned_char;               -- Xm.h:682

    type enum_anonymous65_t is (                            -- Xm.h:691
        XmPUSHBUTTON,                                       -- Xm.h:687
        XmTOGGLEBUTTON,                                     -- Xm.h:687
        XmRADIOBUTTON,                                      -- Xm.h:688
        XmCASCADEBUTTON,                                    -- Xm.h:688
        XmSEPARATOR,                                        -- Xm.h:689
        XmDOUBLE_SEPARATOR,                                 -- Xm.h:689
        XmTITLE                                             -- Xm.h:691
    );
    for enum_anonymous65_t use (                            -- Xm.h:691
        XmPUSHBUTTON => 1,                                  -- Xm.h:687
        XmTOGGLEBUTTON => 2,                                -- Xm.h:687
        XmRADIOBUTTON => 3,                                 -- Xm.h:688
        XmCASCADEBUTTON => 4,                               -- Xm.h:688
        XmSEPARATOR => 5,                                   -- Xm.h:689
        XmDOUBLE_SEPARATOR => 6,                            -- Xm.h:689
        XmTITLE => 7                                        -- Xm.h:691
    );
    for enum_anonymous65_t'Size use X.Int'Size;             -- Xm.h:691

    function XmCHECKBUTTON return enum_anonymous65_t
        renames XmTOGGLEBUTTON;                             -- Xm.h:692

    type XmOffset is new X.signed_int;                      -- Xm.h:774

    type XmStringCharSet is new X.Strings.charp;            -- Xm.h:86
    type const_XmStringCharSet is new X.Strings.const_charp;
    type XmButtonTypeTable is access all XmButtonType;      -- Xm.h:683
    type XmKeySymTable is access all X.KeySym;              -- Xm.h:684
    type XmStringCharSetTable is access all XmStringCharSet;-- Xm.h:685
    type XmOffsetPtr is access all XmOffset;                -- Xm.h:775

    type XmFontListRec is private;                          -- Xm.h:89
    type XmStringContextRec is private;                     -- Xm.h:91
    type XmStringRec is private;                            -- Xm.h:92
    type XmtStringContextRec is private;                    -- Xm.h:93
    type XmFontListContextRec is private;                   -- Xm.h:94
    type XmPrimitiveClassRec is private;                    -- Xm.h:123
    type XmPrimitiveRec is private;                         -- Xm.h:124
    type XmGadgetClassRec is private;                       -- Xm.h:133
    type XmGadgetRec is private;                            -- Xm.h:134
    type XmManagerClassRec is private;                      -- Xm.h:144
    type XmManagerRec is private;                           -- Xm.h:145

    type XmTextBlockRec;                                    -- Xm.h:540
    type XmTextVerifyCallbackStruct;                        -- Xm.h:550
    type XmTextBlockRecWcs;                                 -- Xm.h:558
    type XmTextVerifyCallbackStructWcs;                     -- Xm.h :568
    type XmSecondaryResourceDataRec;                        -- Xm.h:702

    type XmFontListEntry is access all XmFontListRec;       -- Xm.h:89
    type XmFontList is access all XmFontListRec;            -- Xm.h:90
    type XmString is access all XmStringRec;                -- Xm.h:92
    type XmStringTable is access all XmString;              -- Xm.h:85
    type XmStringContext is access all XmtStringContextRec; -- Xm.h:93
    type XmFontContext is access all XmFontListContextRec;  -- Xm.h:94
    type XmPrimitiveWidgetClass is access all XmPrimitiveClassRec;
                                                            -- Xm.h:123
    type XmPrimitiveWidget is access all XmPrimitiveRec;    -- Xm.h:124
    type XmGadgetClass is access all XmGadgetClassRec;      -- Xm.h:133
    type XmGadget is access all XmGadgetRec;                -- Xm.h:134
    type XmManagerWidgetClass is access all XmManagerClassRec;
                                                            -- Xm.h:144
    type XmManagerWidget is access all XmManagerRec;        -- Xm.h:145
    type XmTextBlock is access all XmTextBlockRec;          -- Xm.h:540
    type XmTextVerifyPtr is access all XmTextVerifyCallbackStruct;
                                                            -- Xm.h:550
    type XmTextBlockWcs is access all XmTextBlockRecWcs;    -- Xm.h:558
    type XmTextVerifyPtrWcs is access all XmTextVerifyCallbackStructWcs;
                                                            -- Xm.h:568
    type XmSecondaryResourceData is access all XmSecondaryResourceDataRec;
                                                            -- Xm.h:709
    type XmSecondaryResourceData_access is access all XmSecondaryResourceData;

    type XmAnyCallbackStruct is                             -- Xm.h:301
        record
            reason: X.signed_int;                           -- Xm.h:299
            event : X.Xlib.XEvent_access;                   -- Xm.h:300
        end record;

    type XmArrowButtonCallbackStruct is                     -- Xm.h:308
        record
            reason     : X.signed_int;                      -- Xm.h:305
            event      : X.Xlib.XEvent_access;              -- Xm.h:306
            click_count: X.signed_int;                      -- Xm.h:307
        end record;

    type XmDrawingAreaCallbackStruct is                     -- Xm.h:315
        record
            reason: X.signed_int;                           -- Xm.h:312
            event : X.Xlib.XEvent_access;                   -- Xm.h:313
            window: X.Window;                               -- Xm.h:314
        end record;

    type XmDrawnButtonCallbackStruct is                     -- Xm.h:323
        record
            reason     : X.signed_int;                      -- Xm.h:319
            event      : X.Xlib.XEvent_access;              -- Xm.h:320
            window     : X.Window;                          -- Xm.h:321
            click_count: X.signed_int;                      -- Xm.h:322
        end record;

    type XmPushButtonCallbackStruct is                      -- Xm.h:330
        record
            reason     : X.signed_int;                      -- Xm.h:327
            event      : X.Xlib.XEvent_access;              -- Xm.h:328
            click_count: X.signed_int;                      -- Xm.h:329
        end record;

    type XmRowColumnCallbackStruct is                       -- Xm.h:339
        record
            reason        : X.signed_int;                   -- Xm.h:334
            event         : X.Xlib.XEvent_access;           -- Xm.h:335
            widget        : Xt.Intrinsic.Widget;            -- Xm.h:336
            data          : X.Strings.charp;                -- Xm.h:337
            callbackstruct: X.Strings.charp;                -- Xm.h:338
        end record;

    type XmScrollBarCallbackStruct is                       -- Xm.h:347
        record
            reason: X.signed_int;                           -- Xm.h:343
            event : X.Xlib.XEvent_access;                   -- Xm.h:344
            value : X.signed_int;                           -- Xm.h:345
            pixel : X.signed_int;                           -- Xm.h:346
        end record;

    type XmToggleButtonCallbackStruct is                    -- Xm.h:354
        record
            reason: X.signed_int;                           -- Xm.h:351
            event : X.Xlib.XEvent_access;                   -- Xm.h:352
            set   : X.signed_int;                           -- Xm.h:353
        end record;

    type XmListCallbackStruct is                            -- Xm.h:367
        record
            reason                 : X.signed_int;          -- Xm.h:358
            event                  : X.Xlib.XEvent_access;  -- Xm.h:359
            item                   : XmString;              -- Xm.h:360
            item_length            : X.signed_int;          -- Xm.h:361
            item_position          : X.signed_int;          -- Xm.h:362
            selected_items         : X.Strings.charp_vector;-- Xm.h:363
            selected_item_count    : X.signed_int;          -- Xm.h:364
            selected_item_positions: X.int_access;          -- Xm.h:365
            selection_type         : X.signed_char;         -- Xm.h:366
        end record;

    type XmSelectionBoxCallbackStruct is                    -- Xm.h:375
        record
            reason: X.signed_int;                           -- Xm.h:371
            event : X.Xlib.XEvent_access;                   -- Xm.h:372
            value : XmString;                               -- Xm.h:373
            length: X.signed_int;                           -- Xm.h:374
        end record;

    type XmCommandCallbackStruct is                         -- Xm.h:383
        record
            reason: X.signed_int;                           -- Xm.h:379
            event : X.Xlib.XEvent_access;                   -- Xm.h:380
            value : XmString;                               -- Xm.h:381
            length: X.signed_int;                           -- Xm.h:382
        end record;

    type XmFileSelectionBoxCallbackStruct is                -- Xm.h:397
        record
            reason        : X.signed_int;                   -- Xm.h:387
            event         : X.Xlib.XEvent_access;           -- Xm.h:388
            value         : XmString;                       -- Xm.h:389
            length        : X.signed_int;                   -- Xm.h:390
            mask          : XmString;                       -- Xm.h:391
            mask_length   : X.signed_int;                   -- Xm.h:392
            dir           : XmString;                       -- Xm.h:393
            dir_length    : X.signed_int;                   -- Xm.h:394
            pattern       : XmString;                       -- Xm.h:395
            pattern_length: X.signed_int;                   -- Xm.h:396
        end record;

    type XmScaleCallbackStruct is                           -- Xm.h:405
        record
            reason: X.signed_int;                           -- Xm.h:402
            event : X.Xlib.XEvent_access;                   -- Xm.h:403
            value : X.signed_int;                           -- Xm.h:404
        end record;

    type XmTextBlockRec is                                  -- Xm.h:540
        record
            ptr   : X.Strings.charp;                        -- Xm.h:537
            length: X.signed_int;                           -- Xm.h:538
            format: XmTextFormat;                           -- Xm.h:539
        end record;

    type XmTextVerifyCallbackStruct is                      -- Xm.h:550
        record
            reason    : X.signed_int;                       -- Xm.h:544
            event     : X.Xlib.XEvent_access;               -- Xm.h:545
            doit      : Xt.Intrinsic.Boolean;               -- Xm.h:546
            currInsert: X.signed_int;                       -- Xm.h:547
            newInsert : X.signed_int;                       -- Xm.h:547
            startPos  : X.signed_int;                       -- Xm.h:548
            endPos    : X.signed_int;                       -- Xm.h:548
            text      : XmTextBlock;                        -- Xm.h:549
        end record;

    type XmTextBlockRecWcs is                               -- Xm.h:558
        record
            wcsptr: X.wchar_access;                         -- Xm.h:556
            length: X.signed_int;                           -- Xm.h:557
        end record;

    type XmTextVerifyCallbackStructWcs is                   -- Xm.h:568
        record
            reason    : X.signed_int;                       -- Xm.h:562
            event     : X.Xlib.XEvent_access;               -- Xm.h:563
            doit      : Xt.Intrinsic.Boolean;               -- Xm.h:564
            currInsert: X.signed_int;                       -- Xm.h:565
            newInsert : X.signed_int;                       -- Xm.h:565
            startPos  : X.signed_int;                       -- Xm.h:566
            endPos    : X.signed_int;                       -- Xm.h:566
            text      : XmTextBlockWcs;                     -- Xm.h:567
        end record;

    type XmTraverseObscuredCallbackStruct is                -- Xm.h:666
        record
            reason               : X.signed_int;            -- Xm.h:667
            event                : X.Xlib.XEvent_access;    -- Xm.h:668
            traversal_destination: Xt.Intrinsic.Widget;     -- Xm.h:669
            direction            : XmTraversalDirection;    -- Xm.h:670
        end record;

    type XmResourceBaseProc is access function (
                p1: Xt.Intrinsic.Widget;
                p2: Xt.Intrinsic.XtPointer)
               return Xt.Intrinsic.XtPointer;               -- Xm.h:699


    type XmSecondaryResourceDataRec is                      -- Xm.h:702
        record
            base_proc    : XmResourceBaseProc;              -- Xm.h:703
            client_data  : Xt.Intrinsic.XtPointer;          -- Xm.h:704
            name         : X.Strings.charp;                 -- Xm.h:705
            res_class    : X.Strings.charp;                 -- Xm.h:706
            resources    : Xt.Intrinsic.XtResourceList;     -- Xm.h:707
            num_resources: Xt.Intrinsic.Cardinal;           -- Xm.h:708
        end record;

    type XmColorProc is access procedure (
                bg_color : access X.Xlib.XColor;
                fg_color : access X.Xlib.XColor;
                sel_color: access X.Xlib.XColor;
                ts_color : access X.Xlib.XColor;
                bs_color : access X.Xlib.XColor);           -- Xm.h:1039


    xmUseVersion          : X.signed_int;                   -- Xm.h:43

    XmSDEFAULT_FONT: Char_Array(0..X.Anysize_Array);        -- Xm.h:68
    XmDEFAULT_FONT : Char_Array renames XmSDEFAULT_FONT;    -- Xm.h:62

    XmSDEFAULT_BACKGROUND: Char_Array(0..X.Anysize_Array);  -- Xm.h:69
    XmDEFAULT_BACKGROUND : Char_Array renames XmSDEFAULT_BACKGROUND;
                                                            -- Xm.h:63

    xmPrimitiveWidgetClass_obj: Xt.Intrinsic.WidgetClass;   -- Xm.h:120
    xmGadgetClass_obj         : Xt.Intrinsic.WidgetClass;   -- Xm.h:130
    xmManagerWidgetClass_obj  : Xt.Intrinsic.WidgetClass;   -- Xm.h:141

    function XmGetSecondaryResourceData(
                w_class         : Xt.Intrinsic.WidgetClass;
                secondaryDataRtn: access XmSecondaryResourceData_access)
               return Xt.Intrinsic.Cardinal;                -- Xm.h:718

    function XmInstallImage(
                image     : access X.Xlib.XImage;
                image_name: X.Strings.const_charp)
               return Xt.Intrinsic.Boolean;                 -- Xm.h:736

    pragma Import(C, XmInstallImage, "XmInstallImage");

    function XmInstallImage(
                image     : X.Xlib.XImage_access;
                image_name: Interfaces.C.Char_Array)
               return Xt.Intrinsic.Boolean;                 -- Xm.h:736

    pragma Inline(XmInstallImage);

    function XmUninstallImage(
                image: access X.Xlib.XImage)
               return Xt.Intrinsic.Boolean;                 -- Xm.h:739

    function XmGetPixmap(
                screen    : access X.Xlib.Screen;
                image_name: X.Strings.const_charp;
                foreground: Xt.Intrinsic.Pixel;
                background: Xt.Intrinsic.Pixel)
               return X.Pixmap;                             -- Xm.h:741

    pragma Import(C, XmGetPixmap, "XmGetPixmap");

    function XmGetPixmap(
                screen    : X.Xlib.Screen_access;
                image_name: Interfaces.C.Char_Array;
                foreground: Xt.Intrinsic.Pixel;
                background: Xt.Intrinsic.Pixel)
               return X.Pixmap;                             -- Xm.h:741

    pragma Inline(XmGetPixmap);

    function XmGetPixmapByDepth(
                screen    : access X.Xlib.Screen;
                image_name: X.Strings.const_charp;
                foreground: Xt.Intrinsic.Pixel;
                background: Xt.Intrinsic.Pixel;
                depth     : X.signed_int)
               return X.Pixmap;                             -- Xm.h:746

    pragma Import(C, XmGetPixmapByDepth, "XmGetPixmapByDepth");

    function XmGetPixmapByDepth(
                screen    : X.Xlib.Screen_access;
                image_name: Interfaces.C.Char_Array;
                foreground: Xt.Intrinsic.Pixel;
                background: Xt.Intrinsic.Pixel;
                depth     : X.signed_int)
               return X.Pixmap;                             -- Xm.h:746

    pragma Inline(XmGetPixmapByDepth);

    function XmDestroyPixmap(
                screen: access X.Xlib.Screen;
                pixmap: X.Pixmap)
               return Xt.Intrinsic.Boolean;                 -- Xm.h:752

    procedure XmUpdateDisplay(
                w: Xt.Intrinsic.Widget);                    -- Xm.h:766

    procedure XmResolvePartOffsets(
                w_class: Xt.Intrinsic.WidgetClass;
                offset : access XmOffsetPtr);               -- Xm.h:786

    procedure XmResolveAllPartOffsets(
                w_class          : Xt.Intrinsic.WidgetClass;
                offset           : access XmOffsetPtr;
                constraint_offset: access XmOffsetPtr);     -- Xm.h:789

    function XmWidgetGetBaselines(
                wid       : Xt.Intrinsic.Widget;
                baselines : access Xt.Intrinsic.Dimension_access;
                line_count: access X.signed_int)
               return Xt.Intrinsic.Boolean;                 -- Xm.h:793

    function XmWidgetGetDisplayRect(
                wid        : Xt.Intrinsic.Widget;
                displayrect: access X.Xlib.XRectangle)
               return Xt.Intrinsic.Boolean;                 -- Xm.h:797

    procedure XmRegisterConverters;                         -- Xm.h:818

    procedure XmCvtStringToUnitType(
                args    : X.Xresource.XrmValuePtr;
                num_args: access Xt.Intrinsic.Cardinal;
                from_val: access X.Xresource.XrmValue;
                to_val  : access X.Xresource.XrmValue);     -- Xm.h:819

    function XmRegisterSegmentEncoding(
                fontlist_tag: X.Strings.const_charp;
                ct_encoding : X.Strings.const_charp)
               return X.Strings.charp;                      -- Xm.h:824

    pragma Import(C, XmRegisterSegmentEncoding, "XmRegisterSegmentEncoding");

    function XmRegisterSegmentEncoding(
                fontlist_tag: Interfaces.C.Char_Array;
                ct_encoding : Interfaces.C.Char_Array)
               return X.Strings.charp;                      -- Xm.h:824

    pragma Inline(XmRegisterSegmentEncoding);

    function XmMapSegmentEncoding(
                fontlist_tag: X.Strings.const_charp)
               return X.Strings.charp;                      -- Xm.h:827

    pragma Import(C, XmMapSegmentEncoding, "XmMapSegmentEncoding");

    function XmMapSegmentEncoding(
                fontlist_tag: Interfaces.C.Char_Array)
               return X.Strings.charp;                      -- Xm.h:827

    pragma Inline(XmMapSegmentEncoding);

    function XmCvtCTToXmString(
                text: X.Strings.const_charp)
               return XmString;                             -- Xm.h:829

    pragma Import(C, XmCvtCTToXmString, "XmCvtCTToXmString");

    function XmCvtCTToXmString(
                text: Interfaces.C.Char_Array)
               return XmString;                             -- Xm.h:829

    pragma Inline(XmCvtCTToXmString);

    function XmCvtTextToXmString(
                display       : access X.Xlib.Display;
                args          : X.Xresource.XrmValuePtr;
                num_args      : access Xt.Intrinsic.Cardinal;
                from_val      : access X.Xresource.XrmValue;
                to_val        : access X.Xresource.XrmValue;
                converter_data: access Xt.Intrinsic.XtPointer)
               return Xt.Intrinsic.Boolean;                 -- Xm.h:831

    function XmCvtXmStringToCT(
                string: XmString)
               return X.Strings.charp;                      -- Xm.h:838

    function XmCvtXmStringToText(
                display       : access X.Xlib.Display;
                args          : X.Xresource.XrmValuePtr;
                num_args      : access Xt.Intrinsic.Cardinal;
                from_val      : access X.Xresource.XrmValue;
                to_val        : access X.Xresource.XrmValue;
                converter_data: access Xt.Intrinsic.XtPointer)
               return Xt.Intrinsic.Boolean;                 -- Xm.h:840

    function XmConvertUnits(
                widget   : Xt.Intrinsic.Widget;
                dimension: X.signed_int;
                from_type: X.signed_int;
                from_val : X.signed_int;
                to_type  : X.signed_int)
               return X.signed_int;                         -- Xm.h:864

    function XmCvtToHorizontalPixels(
                screen   : access X.Xlib.Screen;
                from_val : X.signed_int;
                from_type: X.signed_int)
               return X.signed_int;                         -- Xm.h:870

    function XmCvtToVerticalPixels(
                screen   : access X.Xlib.Screen;
                from_val : X.signed_int;
                from_type: X.signed_int)
               return X.signed_int;                         -- Xm.h:874

    function XmCvtFromHorizontalPixels(
                screen  : access X.Xlib.Screen;
                from_val: X.signed_int;
                to_type : X.signed_int)
               return X.signed_int;                         -- Xm.h:878

    function XmCvtFromVerticalPixels(
                screen  : access X.Xlib.Screen;
                from_val: X.signed_int;
                to_type : X.signed_int)
               return X.signed_int;                         -- Xm.h:882

    procedure XmSetFontUnits(
                display: access X.Xlib.Display;
                h_value: X.signed_int;
                v_value: X.signed_int);                     -- Xm.h:886

    procedure XmSetFontUnit(
                display: access X.Xlib.Display;
                value  : X.signed_int);                     -- Xm.h:890

    procedure XmSetMenuCursor(
                display : access X.Xlib.Display;
                cursorId: X.Cursor);                        -- Xm.h:905

    function XmGetMenuCursor(
                display: access X.Xlib.Display)
               return X.Cursor;                             -- Xm.h:908

    function XmCreateSimpleMenuBar(
                parent   : Xt.Intrinsic.Widget;
                name     : X.Strings.const_charp;
                args     : Xt.Intrinsic.ArgList;
                arg_count: Xt.Intrinsic.Cardinal)
               return Xt.Intrinsic.Widget;                  -- Xm.h:926

    pragma Import(C, XmCreateSimpleMenuBar, "XmCreateSimpleMenuBar");

    function XmCreateSimpleMenuBar(
                parent   : Xt.Intrinsic.Widget;
                name     : Interfaces.C.Char_Array;
                args     : Xt.Intrinsic.ArgList;
                arg_count: Xt.Intrinsic.Cardinal)
               return Xt.Intrinsic.Widget;                  -- Xm.h:926

    pragma Inline(XmCreateSimpleMenuBar);

    function XmCreateSimplePopupMenu(
                parent   : Xt.Intrinsic.Widget;
                name     : X.Strings.const_charp;
                args     : Xt.Intrinsic.ArgList;
                arg_count: Xt.Intrinsic.Cardinal)
               return Xt.Intrinsic.Widget;                  -- Xm.h:931

    pragma Import(C, XmCreateSimplePopupMenu, "XmCreateSimplePopupMenu");

    function XmCreateSimplePopupMenu(
                parent   : Xt.Intrinsic.Widget;
                name     : Interfaces.C.Char_Array;
                args     : Xt.Intrinsic.ArgList;
                arg_count: Xt.Intrinsic.Cardinal)
               return Xt.Intrinsic.Widget;                  -- Xm.h:931

    pragma Inline(XmCreateSimplePopupMenu);

    function XmCreateSimplePulldownMenu(
                parent   : Xt.Intrinsic.Widget;
                name     : X.Strings.const_charp;
                args     : Xt.Intrinsic.ArgList;
                arg_count: Xt.Intrinsic.Cardinal)
               return Xt.Intrinsic.Widget;                  -- Xm.h:936

    pragma Import(C, XmCreateSimplePulldownMenu, "XmCreateSimplePulldownMenu");

    function XmCreateSimplePulldownMenu(
                parent   : Xt.Intrinsic.Widget;
                name     : Interfaces.C.Char_Array;
                args     : Xt.Intrinsic.ArgList;
                arg_count: Xt.Intrinsic.Cardinal)
               return Xt.Intrinsic.Widget;                  -- Xm.h:936

    pragma Inline(XmCreateSimplePulldownMenu);

    function XmCreateSimpleOptionMenu(
                parent   : Xt.Intrinsic.Widget;
                name     : X.Strings.const_charp;
                args     : Xt.Intrinsic.ArgList;
                arg_count: Xt.Intrinsic.Cardinal)
               return Xt.Intrinsic.Widget;                  -- Xm.h:941

    pragma Import(C, XmCreateSimpleOptionMenu, "XmCreateSimpleOptionMenu");

    function XmCreateSimpleOptionMenu(
                parent   : Xt.Intrinsic.Widget;
                name     : Interfaces.C.Char_Array;
                args     : Xt.Intrinsic.ArgList;
                arg_count: Xt.Intrinsic.Cardinal)
               return Xt.Intrinsic.Widget;                  -- Xm.h:941

    pragma Inline(XmCreateSimpleOptionMenu);

    function XmCreateSimpleRadioBox(
                parent   : Xt.Intrinsic.Widget;
                name     : X.Strings.const_charp;
                args     : Xt.Intrinsic.ArgList;
                arg_count: Xt.Intrinsic.Cardinal)
               return Xt.Intrinsic.Widget;                  -- Xm.h:946

    pragma Import(C, XmCreateSimpleRadioBox, "XmCreateSimpleRadioBox");

    function XmCreateSimpleRadioBox(
                parent   : Xt.Intrinsic.Widget;
                name     : Interfaces.C.Char_Array;
                args     : Xt.Intrinsic.ArgList;
                arg_count: Xt.Intrinsic.Cardinal)
               return Xt.Intrinsic.Widget;                  -- Xm.h:946

    pragma Inline(XmCreateSimpleRadioBox);

    function XmCreateSimpleCheckBox(
                parent   : Xt.Intrinsic.Widget;
                name     : X.Strings.const_charp;
                args     : Xt.Intrinsic.ArgList;
                arg_count: Xt.Intrinsic.Cardinal)
               return Xt.Intrinsic.Widget;                  -- Xm.h:951

    pragma Import(C, XmCreateSimpleCheckBox, "XmCreateSimpleCheckBox");

    function XmCreateSimpleCheckBox(
                parent   : Xt.Intrinsic.Widget;
                name     : Interfaces.C.Char_Array;
                args     : Xt.Intrinsic.ArgList;
                arg_count: Xt.Intrinsic.Cardinal)
               return Xt.Intrinsic.Widget;                  -- Xm.h:951

    pragma Inline(XmCreateSimpleCheckBox);

    function XmVaCreateSimpleMenuBar(
                parent: Xt.Intrinsic.Widget;
                name  : X.Strings.const_charp;
                args  : Stdarg.ArgList := Stdarg.Empty)
               return Xt.Intrinsic.Widget;                  -- Xm.h:969

    function XmVaCreateSimpleMenuBar(
                parent: Xt.Intrinsic.Widget;
                name  : Interfaces.C.Char_Array;
                Args  : Stdarg.ArgList := Stdarg.Empty)
               return Xt.Intrinsic.Widget;                  -- Xm.h:969

    pragma Inline(XmVaCreateSimpleMenuBar);

    function XmVaCreateSimplePopupMenu(
                parent  : Xt.Intrinsic.Widget;
                name    : X.Strings.const_charp;
                callback: Xt.Intrinsic.XtCallbackProc;
                args    : Stdarg.ArgList := Stdarg.Empty)
               return Xt.Intrinsic.Widget;                  -- Xm.h:973

    function XmVaCreateSimplePopupMenu(
                parent  : Xt.Intrinsic.Widget;
                name    : Interfaces.C.Char_Array;
                callback: Xt.Intrinsic.XtCallbackProc;
                Args    : Stdarg.ArgList := Stdarg.Empty)
               return Xt.Intrinsic.Widget;                  -- Xm.h:973

    pragma Inline(XmVaCreateSimplePopupMenu);

    function XmVaCreateSimplePulldownMenu(
                parent          : Xt.Intrinsic.Widget;
                name            : X.Strings.const_charp;
                post_from_button: X.signed_int;
                callback        : Xt.Intrinsic.XtCallbackProc;
                args            : Stdarg.ArgList := Stdarg.Empty)
               return Xt.Intrinsic.Widget;                  -- Xm.h:978

    function XmVaCreateSimplePulldownMenu(
                parent          : Xt.Intrinsic.Widget;
                name            : Interfaces.C.Char_Array;
                post_from_button: X.signed_int;
                callback        : Xt.Intrinsic.XtCallbackProc;
                Args            : Stdarg.ArgList := Stdarg.Empty)
               return Xt.Intrinsic.Widget;                  -- Xm.h:978

    pragma Inline(XmVaCreateSimplePulldownMenu);

    function XmVaCreateSimpleOptionMenu(
                parent         : Xt.Intrinsic.Widget;
                name           : X.Strings.const_charp;
                option_label   : XmString;
                option_mnemonic: X.KeySym;
                button_set     : X.signed_int;
                callback       : Xt.Intrinsic.XtCallbackProc;
                args           : Stdarg.ArgList := Stdarg.Empty)
               return Xt.Intrinsic.Widget;                  -- Xm.h:984

    function XmVaCreateSimpleOptionMenu(
                parent         : Xt.Intrinsic.Widget;
                name           : Interfaces.C.Char_Array;
                option_label   : XmString;
                option_mnemonic: X.KeySym;
                button_set     : X.signed_int;
                callback       : Xt.Intrinsic.XtCallbackProc;
                Args           : Stdarg.ArgList := Stdarg.Empty)
               return Xt.Intrinsic.Widget;                  -- Xm.h:984

    pragma Inline(XmVaCreateSimpleOptionMenu);

    function XmVaCreateSimpleRadioBox(
                parent    : Xt.Intrinsic.Widget;
                name      : X.Strings.const_charp;
                button_set: X.signed_int;
                callback  : Xt.Intrinsic.XtCallbackProc;
                args      : Stdarg.ArgList := Stdarg.Empty)
               return Xt.Intrinsic.Widget;                  -- Xm.h:992

    function XmVaCreateSimpleRadioBox(
                parent    : Xt.Intrinsic.Widget;
                name      : Interfaces.C.Char_Array;
                button_set: X.signed_int;
                callback  : Xt.Intrinsic.XtCallbackProc;
                Args      : Stdarg.ArgList := Stdarg.Empty)
               return Xt.Intrinsic.Widget;                  -- Xm.h:992

    pragma Inline(XmVaCreateSimpleRadioBox);

    function XmVaCreateSimpleCheckBox(
                parent  : Xt.Intrinsic.Widget;
                name    : X.Strings.const_charp;
                callback: Xt.Intrinsic.XtCallbackProc;
                args    : Stdarg.ArgList := Stdarg.Empty)
               return Xt.Intrinsic.Widget;                  -- Xm.h:998

    function XmVaCreateSimpleCheckBox(
                parent  : Xt.Intrinsic.Widget;
                name    : Interfaces.C.Char_Array;
                callback: Xt.Intrinsic.XtCallbackProc;
                Args    : Stdarg.ArgList := Stdarg.Empty)
               return Xt.Intrinsic.Widget;                  -- Xm.h:998

    pragma Inline(XmVaCreateSimpleCheckBox);

    function XmTrackingEvent(
                widget   : Xt.Intrinsic.Widget;
                cursor   : X.Cursor;
                confineTo: X.signed_int;
                pev      : access X.Xlib.XEvent)
               return Xt.Intrinsic.Widget;                  -- Xm.h:1014

    function XmTrackingLocate(
                widget   : Xt.Intrinsic.Widget;
                cursor   : X.Cursor;
                confineTo: X.signed_int)
               return Xt.Intrinsic.Widget;                  -- Xm.h:1023

    function XmSetColorCalculation(
                proc: XmColorProc)
               return XmColorProc;                          -- Xm.h:1053

    function XmGetColorCalculation return XmColorProc;      -- Xm.h:1055

    procedure XmGetColors(
                screen           : access X.Xlib.Screen;
                color_map        : X.Colormap;
                background       : Xt.Intrinsic.Pixel;
                foreground_ret   : access Xt.Intrinsic.Pixel;
                top_shadow_ret   : access Xt.Intrinsic.Pixel;
                bottom_shadow_ret: access Xt.Intrinsic.Pixel;
                select_ret       : access Xt.Intrinsic.Pixel);
                                                            -- Xm.h:1056

    procedure XmChangeColor(
                widget    : Xt.Intrinsic.Widget;
                background: Xt.Intrinsic.Pixel);            -- Xm.h:1064

    function XmStringCreate(
                text   : X.Strings.const_charp;
                charset: const_XmStringCharSet)
               return XmString;                             -- Xm.h:1125

    pragma Import(C, XmStringCreate, "XmStringCreate");

    function XmStringCreate(
                text   : Interfaces.C.Char_Array;
                charset: Interfaces.C.Char_Array)
               return XmString;                             -- Xm.h:1125

    pragma Inline(XmStringCreate);

    function XmStringCreateSimple(
                text: X.Strings.const_charp)
               return XmString;                             -- Xm.h:1128

    pragma Import(C, XmStringCreateSimple, "XmStringCreateSimple");

    function XmStringCreateSimple(
                text: Interfaces.C.Char_Array)
               return XmString;                             -- Xm.h:1128

    pragma Inline(XmStringCreateSimple);

    function XmStringCreateLocalized(
                text: X.Strings.const_charp)
               return XmString;                             -- Xm.h:1130

    pragma Import(C, XmStringCreateLocalized, "XmStringCreateLocalized");

    function XmStringCreateLocalized(
                text: Interfaces.C.Char_Array)
               return XmString;                             -- Xm.h:1130

    pragma Inline(XmStringCreateLocalized);

    function XmStringDirectionCreate(
                direction: X.signed_int)
               return XmString;                             -- Xm.h:1132

    function XmStringSeparatorCreate return XmString;       -- Xm.h:1138

    function XmStringSegmentCreate(
                text     : X.Strings.const_charp;
                charset  : const_XmStringCharSet;
                direction: X.signed_int;
                separator: X.signed_int)
               return XmString;                             -- Xm.h:1139

    pragma Import(C, XmStringSegmentCreate, "XmStringSegmentCreate");

    function XmStringSegmentCreate(
                text     : Interfaces.C.Char_Array;
                charset  : Interfaces.C.Char_Array;
                direction: X.signed_int;
                separator: X.signed_int)
               return XmString;                             -- Xm.h:1139

    pragma Inline(XmStringSegmentCreate);

    function XmStringLtoRCreate(
                text   : X.Strings.const_charp;
                charset: const_XmStringCharSet)
               return XmString;                             -- Xm.h:1149

    pragma Import(C, XmStringLtoRCreate, "XmStringLtoRCreate");

    function XmStringLtoRCreate(
                text   : Interfaces.C.Char_Array;
                charset: Interfaces.C.Char_Array)
               return XmString;                             -- Xm.h:1149

    pragma Inline(XmStringLtoRCreate);

    function XmStringCreateLtoR(
                text   : X.Strings.const_charp;
                charset: const_XmStringCharSet)
               return XmString;                             -- Xm.h:1152

    pragma Import(C, XmStringCreateLtoR, "XmStringCreateLtoR");

    function XmStringCreateLtoR(
                text   : Interfaces.C.Char_Array;
                charset: Interfaces.C.Char_Array)
               return XmString;                             -- Xm.h:1152

    pragma Inline(XmStringCreateLtoR);

    function XmStringInitContext(
                context: access XmStringContext;
                string : XmString)
               return Xt.Intrinsic.Boolean;                 -- Xm.h:1155

    procedure XmStringFreeContext(
                context: XmStringContext);                  -- Xm.h:1158

    function XmStringGetNextComponent(
                context       : XmStringContext;
                text          : X.Strings.charp_vector;
                charset       : access XmStringCharSet;
                direction     : access XmStringDirection;
                unknown_tag   : access XmStringComponentType;
                unknown_length: access X.unsigned_short;
                unknown_value : access X.unsigned_char_access)
               return XmStringComponentType;                -- Xm.h:1160

    function XmStringPeekNextComponent(
                context: XmStringContext)
               return XmStringComponentType;                -- Xm.h:1168

    function XmStringGetNextSegment(
                context  : XmStringContext;
                text     : X.Strings.charp_vector;
                charset  : access XmStringCharSet;
                direction: access XmStringDirection;
                separator: access Xt.Intrinsic.Boolean)
               return Xt.Intrinsic.Boolean;                 -- Xm.h:1170

    function XmStringGetLtoR(
                string : XmString;
                charset: const_XmStringCharSet;
                text   : X.Strings.charp_vector)
               return Xt.Intrinsic.Boolean;                 -- Xm.h:1176

    pragma Import(C, XmStringGetLtoR, "XmStringGetLtoR");

    function XmStringGetLtoR(
                string : XmString;
                charset: Interfaces.C.Char_Array;
                text   : X.Strings.charp_vector)
               return Xt.Intrinsic.Boolean;                 -- Xm.h:1176

    pragma Inline(XmStringGetLtoR);

    function XmFontListEntryCreate(
                tag   : X.Strings.const_charp;
                c_type: XmFontType;
                font  : Xt.Intrinsic.XtPointer)
               return XmFontListEntry;                      -- Xm.h:1180

    pragma Import(C, XmFontListEntryCreate, "XmFontListEntryCreate");

    function XmFontListEntryCreate(
                tag   : Interfaces.C.Char_Array;
                c_type: XmFontType;
                font  : Xt.Intrinsic.XtPointer)
               return XmFontListEntry;                      -- Xm.h:1180

    pragma Inline(XmFontListEntryCreate);

    procedure XmFontListEntryFree(
                c_entry: access XmFontListEntry);           -- Xm.h:1184

    function XmFontListEntryGetFont(
                c_entry   : XmFontListEntry;
                typeReturn: access XmFontType)
               return Xt.Intrinsic.XtPointer;               -- Xm.h:1186

    function XmFontListEntryGetTag(
                c_entry: XmFontListEntry)
               return X.Strings.charp;                      -- Xm.h:1189

    function XmFontListAppendEntry(
                old    : XmFontList;
                c_entry: XmFontListEntry)
               return XmFontList;                           -- Xm.h:1191

    function XmFontListNextEntry(
                context: XmFontContext)
               return XmFontListEntry;                      -- Xm.h:1194

    function XmFontListRemoveEntry(
                old    : XmFontList;
                c_entry: XmFontListEntry)
               return XmFontList;                           -- Xm.h:1196

    function XmFontListEntryLoad(
                display : access X.Xlib.Display;
                fontName: X.Strings.const_charp;
                c_type  : XmFontType;
                tag     : X.Strings.const_charp)
               return XmFontListEntry;                      -- Xm.h:1199

    pragma Import(C, XmFontListEntryLoad, "XmFontListEntryLoad");

    function XmFontListEntryLoad(
                display : access X.Xlib.Display;
                fontName: Interfaces.C.Char_Array;
                c_type  : XmFontType;
                tag     : Interfaces.C.Char_Array)
               return XmFontListEntry;                      -- Xm.h:1199

    pragma Inline(XmFontListEntryLoad);

    function XmFontListCreate(
                font   : access X.Xlib.XFontStruct;
                charset: const_XmStringCharSet)
               return XmFontList;                           -- Xm.h:1204

    pragma Import(C, XmFontListCreate, "XmFontListCreate");

    function XmFontListCreate(
                font   : X.Xlib.XFontStruct_access;
                charset: Interfaces.C.Char_Array)
               return XmFontList;                           -- Xm.h:1204

    pragma Inline(XmFontListCreate);

    function XmStringCreateFontList(
                font   : access X.Xlib.XFontStruct;
                charset: const_XmStringCharSet)
               return XmFontList;                           -- Xm.h:1207

    pragma Import(C, XmStringCreateFontList, "XmStringCreateFontList");

    function XmStringCreateFontList(
                font   : X.Xlib.XFontStruct_access;
                charset: Interfaces.C.Char_Array)
               return XmFontList;                           -- Xm.h:1207

    pragma Inline(XmStringCreateFontList);

    procedure XmFontListFree(
                fontlist: XmFontList);                      -- Xm.h:1210

    function XmFontListAdd(
                old    : XmFontList;
                font   : access X.Xlib.XFontStruct;
                charset: const_XmStringCharSet)
               return XmFontList;                           -- Xm.h:1212

    pragma Import(C, XmFontListAdd, "XmFontListAdd");

    function XmFontListAdd(
                old    : XmFontList;
                font   : X.Xlib.XFontStruct_access;
                charset: Interfaces.C.Char_Array)
               return XmFontList;                           -- Xm.h:1212

    pragma Inline(XmFontListAdd);

    function XmFontListCopy(
                fontlist: XmFontList)
               return XmFontList;                           -- Xm.h:1216

    function XmFontListInitFontContext(
                context : access XmFontContext;
                fontlist: XmFontList)
               return Xt.Intrinsic.Boolean;                 -- Xm.h:1218

    function XmFontListGetNextFont(
                context: XmFontContext;
                charset: access XmStringCharSet;
                font   : X.Xlib.XFontStruct_access_access)
               return Xt.Intrinsic.Boolean;                 -- Xm.h:1221

    procedure XmFontListFreeFontContext(
                context: XmFontContext);                    -- Xm.h:1225

    function XmStringConcat(
                a: XmString;
                b: XmString)
               return XmString;                             -- Xm.h:1227

    function XmStringNConcat(
                first : XmString;
                second: XmString;
                n     : X.signed_int)
               return XmString;                             -- Xm.h:1230

    function XmStringCopy(
                string: XmString)
               return XmString;                             -- Xm.h:1234

    function XmStringNCopy(
                str: XmString;
                n  : X.signed_int)
               return XmString;                             -- Xm.h:1236

    function XmStringByteCompare(
                a1: XmString;
                b1: XmString)
               return Xt.Intrinsic.Boolean;                 -- Xm.h:1239

    function XmStringCompare(
                a: XmString;
                b: XmString)
               return Xt.Intrinsic.Boolean;                 -- Xm.h:1242

    function XmStringLength(
                string: XmString)
               return X.signed_int;                         -- Xm.h:1245

    function XmStringEmpty(
                string: XmString)
               return Xt.Intrinsic.Boolean;                 -- Xm.h:1247

    function XmStringHasSubstring(
                string   : XmString;
                substring: XmString)
               return Xt.Intrinsic.Boolean;                 -- Xm.h:1249

    procedure XmStringFree(
                string: XmString);                          -- Xm.h:1252

    function XmStringBaseline(
                fontlist: XmFontList;
                string  : XmString)
               return Xt.Intrinsic.Dimension;               -- Xm.h:1254

    function XmStringWidth(
                fontlist: XmFontList;
                string  : XmString)
               return Xt.Intrinsic.Dimension;               -- Xm.h:1257

    function XmStringHeight(
                fontlist: XmFontList;
                string  : XmString)
               return Xt.Intrinsic.Dimension;               -- Xm.h:1260

    procedure XmStringExtent(
                fontlist: XmFontList;
                string  : XmString;
                width   : access Xt.Intrinsic.Dimension;
                height  : access Xt.Intrinsic.Dimension);   -- Xm.h:1263

    function XmStringLineCount(
                string: XmString)
               return X.signed_int;                         -- Xm.h:1268

    procedure XmStringDraw(
                d       : access X.Xlib.Display;
                w       : X.Window;
                fontlist: XmFontList;
                string  : XmString;
                gc      : X.Xlib.GC;
                xx      : X.signed_int;
                y       : X.signed_int;
                width   : X.signed_int;
                align   : X.unsigned_int;
                lay_dir : X.unsigned_int;
                clip    : access X.Xlib.XRectangle);        -- Xm.h:1270

    procedure XmStringDrawImage(
                d       : access X.Xlib.Display;
                w       : X.Window;
                fontlist: XmFontList;
                string  : XmString;
                gc      : X.Xlib.GC;
                xx      : X.signed_int;
                y       : X.signed_int;
                width   : X.signed_int;
                align   : X.unsigned_int;
                lay_dir : X.unsigned_int;
                clip    : access X.Xlib.XRectangle);        -- Xm.h:1290

    procedure XmStringDrawUnderline(
                d      : access X.Xlib.Display;
                w      : X.Window;
                fntlst : XmFontList;
                str    : XmString;
                gc     : X.Xlib.GC;
                xx     : X.signed_int;
                y      : X.signed_int;
                width  : X.signed_int;
                align  : X.unsigned_int;
                lay_dir: X.unsigned_int;
                clip   : access X.Xlib.XRectangle;
                under  : XmString);                         -- Xm.h:1310

    function XmGetDestination(
                display: access X.Xlib.Display)
               return Xt.Intrinsic.Widget;                  -- Xm.h:1342

    function XmIsTraversable(
                wid: Xt.Intrinsic.Widget)
               return Xt.Intrinsic.Boolean;                 -- Xm.h:1361

    function XmGetVisibility(
                wid: Xt.Intrinsic.Widget)
               return XmVisibility;                         -- Xm.h:1363

    function XmGetTabGroup(
                wid: Xt.Intrinsic.Widget)
               return Xt.Intrinsic.Widget;                  -- Xm.h:1365

    function XmGetFocusWidget(
                wid: Xt.Intrinsic.Widget)
               return Xt.Intrinsic.Widget;                  -- Xm.h:1367

    function XmProcessTraversal(
                w  : Xt.Intrinsic.Widget;
                dir: XmTraversalDirection)
               return Xt.Intrinsic.Boolean;                 -- Xm.h:1369

    procedure XmAddTabGroup(
                tabGroup: Xt.Intrinsic.Widget);             -- Xm.h:1372

    procedure XmRemoveTabGroup(
                w: Xt.Intrinsic.Widget);                    -- Xm.h:1374

    procedure XmImRegister(
                w       : Xt.Intrinsic.Widget;
                reserved: X.unsigned_int);                  -- Xm.h:1396

    procedure XmImUnregister(
                w: Xt.Intrinsic.Widget);                    -- Xm.h:1399

    procedure XmImSetFocusValues(
                w       : Xt.Intrinsic.Widget;
                args    : Xt.Intrinsic.ArgList;
                num_args: Xt.Intrinsic.Cardinal);           -- Xm.h:1401

    procedure XmImSetValues(
                w       : Xt.Intrinsic.Widget;
                args    : Xt.Intrinsic.ArgList;
                num_args: Xt.Intrinsic.Cardinal);           -- Xm.h:1405

    procedure XmImUnsetFocus(
                w: Xt.Intrinsic.Widget);                    -- Xm.h:1409

    function XmImGetXIM(
                w: Xt.Intrinsic.Widget)
               return X.Xlib.XIM;                           -- Xm.h:1411

    function XmImMbLookupString(
                w     : Xt.Intrinsic.Widget;
                event : access X.Xlib.XKeyEvent;
                buf   : X.Strings.charp;
                nbytes: X.signed_int;
                keysym: access X.KeySym;
                status: access X.signed_int)
               return X.signed_int;                         -- Xm.h:1413

    pragma Import(C, XmImMbLookupString, "XmImMbLookupString");

    procedure XmImMbLookupString(
                w     : Xt.Intrinsic.Widget;
                event : access X.Xlib.XKeyEvent;
                buf   : in out Interfaces.C.Char_Array;
                nbytes: X.signed_int;
                keysym: access X.KeySym;
                status: access X.signed_int;
                result: out X.signed_int);                  -- Xm.h:1413

    pragma Inline(XmImMbLookupString);

    procedure XmImVaSetFocusValues(
                w   : Xt.Intrinsic.Widget;
                args: Stdarg.ArgList := Stdarg.Empty);      -- Xm.h:1420

    procedure XmImVaSetValues(
                w   : Xt.Intrinsic.Widget;
                args: Stdarg.ArgList := Stdarg.Empty);      -- Xm.h:1423

    -- *********
    -- Xm macros
    -- *********

    function XmIsPrimitive(W: Xt.Intrinsic.Widget) 
        return Xt.Intrinsic.Boolean;

    function XmIsGadget(W: Xt.Intrinsic.Widget) 
        return Xt.Intrinsic.Boolean;

    function XmIsManager(W: Xt.Intrinsic.Widget) 
        return Xt.Intrinsic.Boolean;

private

    type XmManagerRec is null record;                       -- Xm.h:145
    type XmManagerClassRec is null record;                  -- Xm.h:144
    type XmGadgetRec is null record;                        -- Xm.h:134
    type XmGadgetClassRec is null record;                   -- Xm.h:133
    type XmPrimitiveRec is null record;                     -- Xm.h:124
    type XmPrimitiveClassRec is null record;                -- Xm.h:123
    type XmFontListContextRec is null record;               -- Xm.h:94
    type XmtStringContextRec is null record;                -- Xm.h:93
    type XmStringRec is null record;                        -- Xm.h:92
    type XmStringContextRec is null record;                 -- Xm.h:91
    type XmFontListRec is null record;                      -- Xm.h:89
    -- ---------------------------------------------------------
    -- These three lines cause gnat 2.03 to crash.
    -- However they must be put back in at some point.
    -- pragma Import(C, xmUseVersion, "xmUseVersion");             -- Xm.h:43
    -- pragma Import(C, XmSDEFAULT_FONT, "_XmSDEFAULT_FONT");      -- Xm.h:68
    -- pragma Import(C, XmSDEFAULT_BACKGROUND, "_XmSDEFAULT_BACKGROUND");
                                                            -- Xm.h:69
    -- ---------------------------------------------------------

    pragma Import(C, XmGetSecondaryResourceData, "XmGetSecondaryResourceData");
                                                            -- Xm.h:718
    pragma Import(C, XmUninstallImage, "XmUninstallImage"); -- Xm.h:739
    pragma Import(C, XmDestroyPixmap, "XmDestroyPixmap");   -- Xm.h:752
    pragma Import(C, XmUpdateDisplay, "XmUpdateDisplay");   -- Xm.h:766
    pragma Import(C, XmResolvePartOffsets, "XmResolvePartOffsets");
                                                            -- Xm.h:786
    pragma Import(C, XmResolveAllPartOffsets, "XmResolveAllPartOffsets");
                                                            -- Xm.h:789
    pragma Import(C, XmWidgetGetBaselines, "XmWidgetGetBaselines");
                                                            -- Xm.h:793
    pragma Import(C, XmWidgetGetDisplayRect, "XmWidgetGetDisplayRect");
                                                            -- Xm.h:797
    pragma Import(C, XmRegisterConverters, "XmRegisterConverters");
                                                            -- Xm.h:818
    pragma Import(C, XmCvtStringToUnitType, "XmCvtStringToUnitType");
                                                            -- Xm.h:819
    pragma Import(C, XmCvtTextToXmString, "XmCvtTextToXmString");
                                                            -- Xm.h:831
    pragma Import(C, XmCvtXmStringToCT, "XmCvtXmStringToCT");
                                                            -- Xm.h:838
    pragma Import(C, XmCvtXmStringToText, "XmCvtXmStringToText");
                                                            -- Xm.h:840
    pragma Import(C, XmConvertUnits, "XmConvertUnits");     -- Xm.h:864
    pragma Import(C, XmCvtToHorizontalPixels, "XmCvtToHorizontalPixels");
                                                            -- Xm.h:870
    pragma Import(C, XmCvtToVerticalPixels, "XmCvtToVerticalPixels");
                                                            -- Xm.h:874
    pragma Import(C, XmCvtFromHorizontalPixels, "XmCvtFromHorizontalPixels");
                                                            -- Xm.h:878
    pragma Import(C, XmCvtFromVerticalPixels, "XmCvtFromVerticalPixels");
                                                            -- Xm.h:882
    pragma Import(C, XmSetFontUnits, "XmSetFontUnits");     -- Xm.h:886
    pragma Import(C, XmSetFontUnit, "XmSetFontUnit");       -- Xm.h:890
    pragma Import(C, XmSetMenuCursor, "XmSetMenuCursor");   -- Xm.h:905
    pragma Import(C, XmGetMenuCursor, "XmGetMenuCursor");   -- Xm.h:908
    pragma Import(C, XmTrackingEvent, "XmTrackingEvent");   -- Xm.h:1014
    pragma Import(C, XmTrackingLocate, "XmTrackingLocate"); -- Xm.h:1023
    pragma Import(C, XmSetColorCalculation, "XmSetColorCalculation");
                                                            -- Xm.h:1053
    pragma Import(C, XmGetColorCalculation, "XmGetColorCalculation");
                                                            -- Xm.h:1055
    pragma Import(C, XmGetColors, "XmGetColors");           -- Xm.h:1056
    pragma Import(C, XmChangeColor, "XmChangeColor");       -- Xm.h:1064
    pragma Import(C, XmStringDirectionCreate, "XmStringDirectionCreate");
                                                            -- Xm.h:1132
    pragma Import(C, XmStringSeparatorCreate, "XmStringSeparatorCreate");
                                                            -- Xm.h:1138
    pragma Import(C, XmStringInitContext, "XmStringInitContext");
                                                            -- Xm.h:1155
    pragma Import(C, XmStringFreeContext, "XmStringFreeContext");
                                                            -- Xm.h:1158
    pragma Import(C, XmStringGetNextComponent, "XmStringGetNextComponent");
                                                            -- Xm.h:1160
    pragma Import(C, XmStringPeekNextComponent, "XmStringPeekNextComponent");
                                                            -- Xm.h:1168
    pragma Import(C, XmStringGetNextSegment, "XmStringGetNextSegment");
                                                            -- Xm.h:1170
    pragma Import(C, XmFontListEntryFree, "XmFontListEntryFree");
                                                            -- Xm.h:1184
    pragma Import(C, XmFontListEntryGetFont, "XmFontListEntryGetFont");
                                                            -- Xm.h:1186
    pragma Import(C, XmFontListEntryGetTag, "XmFontListEntryGetTag");
                                                            -- Xm.h:1189
    pragma Import(C, XmFontListAppendEntry, "XmFontListAppendEntry");
                                                            -- Xm.h:1191
    pragma Import(C, XmFontListNextEntry, "XmFontListNextEntry");
                                                            -- Xm.h:1194
    pragma Import(C, XmFontListRemoveEntry, "XmFontListRemoveEntry");
                                                            -- Xm.h:1196
    pragma Import(C, XmFontListFree, "XmFontListFree");     -- Xm.h:1210
    pragma Import(C, XmFontListCopy, "XmFontListCopy");     -- Xm.h:1216
    pragma Import(C, XmFontListInitFontContext, "XmFontListInitFontContext");
                                                            -- Xm.h:1218
    pragma Import(C, XmFontListGetNextFont, "XmFontListGetNextFont");
                                                            -- Xm.h:1221
    pragma Import(C, XmFontListFreeFontContext, "XmFontListFreeFontContext");
                                                            -- Xm.h:1225
    pragma Import(C, XmStringConcat, "XmStringConcat");     -- Xm.h:1227
    pragma Import(C, XmStringNConcat, "XmStringNConcat");   -- Xm.h:1230
    pragma Import(C, XmStringCopy, "XmStringCopy");         -- Xm.h:1234
    pragma Import(C, XmStringNCopy, "XmStringNCopy");       -- Xm.h:1236
    pragma Import(C, XmStringByteCompare, "XmStringByteCompare");
                                                            -- Xm.h:1239
    pragma Import(C, XmStringCompare, "XmStringCompare");   -- Xm.h:1242
    pragma Import(C, XmStringLength, "XmStringLength");     -- Xm.h:1245
    pragma Import(C, XmStringEmpty, "XmStringEmpty");       -- Xm.h:1247
    pragma Import(C, XmStringHasSubstring, "XmStringHasSubstring");
                                                            -- Xm.h:1249
    pragma Import(C, XmStringFree, "XmStringFree");         -- Xm.h:1252
    pragma Import(C, XmStringBaseline, "XmStringBaseline"); -- Xm.h:1254
    pragma Import(C, XmStringWidth, "XmStringWidth");       -- Xm.h:1257
    pragma Import(C, XmStringHeight, "XmStringHeight");     -- Xm.h:1260
    pragma Import(C, XmStringExtent, "XmStringExtent");     -- Xm.h:1263
    pragma Import(C, XmStringLineCount, "XmStringLineCount");
                                                            -- Xm.h:1268
    pragma Import(C, XmStringDraw, "XmStringDraw");         -- Xm.h:1270
    pragma Import(C, XmStringDrawImage, "XmStringDrawImage");
                                                            -- Xm.h:1290
    pragma Import(C, XmStringDrawUnderline, "XmStringDrawUnderline");
                                                            -- Xm.h:1310
    pragma Import(C, XmGetDestination, "XmGetDestination"); -- Xm.h:1342
    pragma Import(C, XmIsTraversable, "XmIsTraversable");   -- Xm.h:1361
    pragma Import(C, XmGetVisibility, "XmGetVisibility");   -- Xm.h:1363
    pragma Import(C, XmGetTabGroup, "XmGetTabGroup");       -- Xm.h:1365
    pragma Import(C, XmGetFocusWidget, "XmGetFocusWidget"); -- Xm.h:1367
    pragma Import(C, XmProcessTraversal, "XmProcessTraversal");
                                                            -- Xm.h:1369
    pragma Import(C, XmAddTabGroup, "XmAddTabGroup");       -- Xm.h:1372
    pragma Import(C, XmRemoveTabGroup, "XmRemoveTabGroup"); -- Xm.h:1374
    pragma Import(C, XmImRegister, "XmImRegister");         -- Xm.h:1396
    pragma Import(C, XmImUnregister, "XmImUnregister");     -- Xm.h:1399
    pragma Import(C, XmImSetFocusValues, "XmImSetFocusValues");
                                                            -- Xm.h:1401
    pragma Import(C, XmImSetValues, "XmImSetValues");       -- Xm.h:1405
    pragma Import(C, XmImUnsetFocus, "XmImUnsetFocus");     -- Xm.h:1409
    pragma Import(C, XmImGetXIM, "XmImGetXIM");             -- Xm.h:1411

    pragma Inline(XmIsPrimitive);
    pragma Inline(XmIsGadget);
    pragma Inline(XmIsManager);

    pragma Convention(C,  XmAnyCallbackStruct);
    pragma Convention(C,  XmArrowButtonCallbackStruct);
    pragma Convention(C,  XmDrawingAreaCallbackStruct);
    pragma Convention(C,  XmDrawnButtonCallbackStruct);
    pragma Convention(C,  XmPushButtonCallbackStruct);
    pragma Convention(C,  XmRowColumnCallbackStruct);
    pragma Convention(C,  XmScrollBarCallbackStruct);
    pragma Convention(C,  XmToggleButtonCallbackStruct);
    pragma Convention(C,  XmListCallbackStruct);
    pragma Convention(C,  XmSelectionBoxCallbackStruct);
    pragma Convention(C,  XmCommandCallbackStruct);
    pragma Convention(C,  XmFileSelectionBoxCallbackStruct);
    pragma Convention(C,  XmScaleCallbackStruct);
    pragma Convention(C,  XmTextBlockRec);
    pragma Convention(C,  XmTextVerifyCallbackStruct);
    pragma Convention(C,  XmTextBlockRecWcs);
    pragma Convention(C,  XmTextVerifyCallbackStructWcs);
    pragma Convention(C,  XmTraverseObscuredCallbackStruct);
    pragma Convention(C,  XmSecondaryResourceDataRec);
    pragma Convention(C, XmResourceBaseProc);
    pragma Convention(C, XmColorProc);
end Motif.Xm;
