-- $Source: /home/harp/1/proto/monoBANK/xbind/mrm-mrmdecls.ads,v $ 
-- $Revision: 1.4 $ $Date: 95/12/19 15:35:13 $ $Author: mg $ 


-- --------------------------------------------------------------------------
-- THIS FILE AND ANY ASSOCIATED DOCUMENTATION IS PROVIDED "AS IS" WITHOUT 
-- WARRANTY OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
-- TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A 
-- PARTICULAR PURPOSE.  The user assumes the entire risk as to the accuracy 
-- and the use of this file.  
--  
-- Ada version Copyright (c) Intermetrics, Inc. 1994 
-- Royalty-free, unlimited, worldwide, non-exclusive use, modification, 
-- reproduction and further distribution of this Ada file is permitted. 
--
-- C version contains additional copyrights, 
-- see the accompanying file MrmDecls.h.
-- --------------------------------------------------------------------------

with Interfaces.C;
with Mrm.MrmPublic;
with X;
with X.Strings;
with X.Xlib;
with Xt.Intrinsic;

package Mrm.MrmDecls is

    --  * Declarations of Mrm public entry points
    --  
    --  
    --  * (c) Copyright 1989, 1990, 1991, 1992 OPEN SOFTWARE FOUNDATION, INC. 
    --  * ALL RIGHTS RESERVED 
    --  
    --  * Motif Release 1.2
    --    $RCSfile: MrmDecls.h,v $ $Revision: 1.6 $ $Date: 92/03/13 16:19:50 $ 
    -- *  (c) Copyright 1989, 1990, DIGITAL EQUIPMENT CORPORATION, MAYNARD, MASS. 
    MrmDecls_H                          : constant Boolean := True;
                                              -- /usr/include/Mrm/MrmDecls.h:13

    procedure MrmInitialize;                  -- /usr/include/Mrm/MrmDecls.h:31


    --  mrmlread.c 

    function MrmFetchLiteral(
                hierarchy_id: Mrm.MrmPublic.MrmHierarchy;
                index       : X.Strings.charp;
                display     : access X.Xlib.Display;
                value_return: access Xt.Intrinsic.XtPointer;
                type_return : access Mrm.MrmPublic.MrmCode)
               return Xt.Intrinsic.Cardinal;  -- /usr/include/Mrm/MrmDecls.h:34



    function MrmFetchIconLiteral(
                hierarchy_id : Mrm.MrmPublic.MrmHierarchy;
                index        : X.Strings.charp;
                screen       : access X.Xlib.Screen;
                display      : access X.Xlib.Display;
                fgpix        : Xt.Intrinsic.Pixel;
                bgpix        : Xt.Intrinsic.Pixel;
                pixmap_return: access X.Pixmap)
               return Xt.Intrinsic.Cardinal;  -- /usr/include/Mrm/MrmDecls.h:35



    function MrmFetchBitmapLiteral(
                hierarchy_id : Mrm.MrmPublic.MrmHierarchy;
                index        : X.Strings.charp;
                screen       : access X.Xlib.Screen;
                display      : access X.Xlib.Display;
                pixmap_return: access X.Pixmap;
                width        : access Xt.Intrinsic.Dimension;
                height       : access Xt.Intrinsic.Dimension)
               return Xt.Intrinsic.Cardinal;  -- /usr/include/Mrm/MrmDecls.h:36



    function MrmFetchColorLiteral(
                hierarchy_id: Mrm.MrmPublic.MrmHierarchy;
                index       : X.Strings.charp;
                display     : access X.Xlib.Display;
                cmap        : X.Colormap;
                pixel_return: access Xt.Intrinsic.Pixel)
               return Xt.Intrinsic.Cardinal;  -- /usr/include/Mrm/MrmDecls.h:37


    --  Deal with Wide stuff now because there is an error in Saber 3.0 

    function MrmOpenHierarchy(
                num_files          : X.int;
                name_list          : access X.Strings.charp;
                os_ext_list        : access Mrm.MrmPublic.MrmOsOpenParamPtr;
                hierarchy_id_return: access Mrm.MrmPublic.MrmHierarchy)
               return Xt.Intrinsic.Cardinal;  -- /usr/include/Mrm/MrmDecls.h:43



    function MrmOpenHierarchyPerDisplay(
                display            : access X.Xlib.Display;
                num_files          : X.int;
                name_list          : access X.Strings.charp;
                os_ext_list        : access Mrm.MrmPublic.MrmOsOpenParamPtr;
                hierarchy_id_return: access Mrm.MrmPublic.MrmHierarchy)
               return Xt.Intrinsic.Cardinal;  -- /usr/include/Mrm/MrmDecls.h:44



    function MrmRegisterNames(
                reglist: Mrm.MrmPublic.MrmRegisterArglist;
                num_reg: X.int)
               return Xt.Intrinsic.Cardinal;  -- /usr/include/Mrm/MrmDecls.h:45



    function MrmRegisterNamesInHierarchy(
                hierarchy_id: Mrm.MrmPublic.MrmHierarchy;
                reglist     : Mrm.MrmPublic.MrmRegisterArglist;
                num_reg     : X.int)
               return Xt.Intrinsic.Cardinal;  -- /usr/include/Mrm/MrmDecls.h:46



    type creator_func_access is access function return Xt.Intrinsic.Widget;
                                              -- /usr/include/Mrm/MrmDecls.h:47

    function MrmRegisterClass(
                class_code  : X.int;
                class_name  : X.Strings.charp;
                create_name : X.Strings.charp;
                creator     : creator_func_access;
                class_record: Xt.Intrinsic.WidgetClass)
               return Xt.Intrinsic.Cardinal;  -- /usr/include/Mrm/MrmDecls.h:47



    function MrmCloseHierarchy(
                hierarchy_id: Mrm.MrmPublic.MrmHierarchy)
               return Xt.Intrinsic.Cardinal;  -- /usr/include/Mrm/MrmDecls.h:59



    function MrmFetchInterfaceModule(
                hierarchy_id: Mrm.MrmPublic.MrmHierarchy;
                module_name : X.Strings.charp;
                parent      : Xt.Intrinsic.Widget;
                w_return    : access Xt.Intrinsic.Widget)
               return Xt.Intrinsic.Cardinal;  -- /usr/include/Mrm/MrmDecls.h:60

    pragma Import(C, MrmFetchInterfaceModule, "MrmFetchInterfaceModule");
                                              -- /usr/include/Mrm/MrmDecls.h:60

    procedure MrmFetchInterfaceModule(
                hierarchy_id: Mrm.MrmPublic.MrmHierarchy;
                module_name : in out Interfaces.C.Char_Array;
                parent      : Xt.Intrinsic.Widget;
                w_return    : access Xt.Intrinsic.Widget;
                result      : out Xt.Intrinsic.Cardinal);
                                              -- /usr/include/Mrm/MrmDecls.h:60

    pragma Inline(MrmFetchInterfaceModule);   -- /usr/include/Mrm/MrmDecls.h:60


    function MrmFetchWidget(
                hierarchy_id: Mrm.MrmPublic.MrmHierarchy;
                index       : X.Strings.charp;
                parent      : Xt.Intrinsic.Widget;
                w_return    : access Xt.Intrinsic.Widget;
                class_return: access Mrm.MrmPublic.MrmType)
               return Xt.Intrinsic.Cardinal;  -- /usr/include/Mrm/MrmDecls.h:61



    function MrmFetchWidgetOverride(
                hierarchy_id: Mrm.MrmPublic.MrmHierarchy;
                index       : X.Strings.charp;
                parent      : Xt.Intrinsic.Widget;
                ov_name     : X.Strings.charp;
                ov_args     : Xt.Intrinsic.ArgList;
                ov_num_args : Xt.Intrinsic.Cardinal;
                w_return    : access Xt.Intrinsic.Widget;
                class_return: access Mrm.MrmPublic.MrmType)
               return Xt.Intrinsic.Cardinal;  -- /usr/include/Mrm/MrmDecls.h:62



    function MrmFetchSetValues(
                hierarchy_id: Mrm.MrmPublic.MrmHierarchy;
                w           : Xt.Intrinsic.Widget;
                args        : Xt.Intrinsic.ArgList;
                num_args    : Xt.Intrinsic.Cardinal)
               return Xt.Intrinsic.Cardinal;  -- /usr/include/Mrm/MrmDecls.h:63



private
    pragma Import(C, MrmInitialize, "MrmInitialize");
                                              -- /usr/include/Mrm/MrmDecls.h:31
    pragma Import(C, MrmFetchLiteral, "MrmFetchLiteral");
                                              -- /usr/include/Mrm/MrmDecls.h:34
    pragma Import(C, MrmFetchIconLiteral, "MrmFetchIconLiteral");
                                              -- /usr/include/Mrm/MrmDecls.h:35
    pragma Import(C, MrmFetchBitmapLiteral, "MrmFetchBitmapLiteral");
                                              -- /usr/include/Mrm/MrmDecls.h:36
    pragma Import(C, MrmFetchColorLiteral, "MrmFetchColorLiteral");
                                              -- /usr/include/Mrm/MrmDecls.h:37
    pragma Import(C, MrmOpenHierarchy, "MrmOpenHierarchy");
                                              -- /usr/include/Mrm/MrmDecls.h:43
    pragma Import(C, MrmOpenHierarchyPerDisplay, "MrmOpenHierarchyPerDisplay");
                                              -- /usr/include/Mrm/MrmDecls.h:44
    pragma Import(C, MrmRegisterNames, "MrmRegisterNames");
                                              -- /usr/include/Mrm/MrmDecls.h:45
    pragma Import(C, MrmRegisterNamesInHierarchy, "MrmRegisterNamesInHierarchy");
                                              -- /usr/include/Mrm/MrmDecls.h:46
    pragma Import(C, MrmRegisterClass, "MrmRegisterClass");
                                              -- /usr/include/Mrm/MrmDecls.h:47
    pragma Import(C, MrmCloseHierarchy, "MrmCloseHierarchy");
                                              -- /usr/include/Mrm/MrmDecls.h:59
    pragma Import(C, MrmFetchWidget, "MrmFetchWidget");
                                              -- /usr/include/Mrm/MrmDecls.h:61
    pragma Import(C, MrmFetchWidgetOverride, "MrmFetchWidgetOverride");
                                              -- /usr/include/Mrm/MrmDecls.h:62
    pragma Import(C, MrmFetchSetValues, "MrmFetchSetValues");
                                              -- /usr/include/Mrm/MrmDecls.h:63

    pragma Convention(C, creator_func_access);

end Mrm.MrmDecls;
--  
--  * (c) Copyright 1989, 1990, 1991, 1992 OPEN SOFTWARE FOUNDATION, INC. 
--  * ALL RIGHTS RESERVED 
--  
--  * Motif Release 1.2
--    $RCSfile: MrmDecls.h,v $ $Revision: 1.6 $ $Date: 92/03/13 16:19:50 $ 
-- *  (c) Copyright 1989, 1990, DIGITAL EQUIPMENT CORPORATION, MAYNARD, MASS. 
--  DON'T ADD STUFF AFTER THIS #endif 
