-- $Source: /home/harp/1/proto/monoBANK/xbind/mrm-mrmpublic.ads,v $ 
-- $Revision: 1.3 $ $Date: 95/12/08 15:39:01 $ $Author: mg $ 


-- --------------------------------------------------------------------------
-- THIS FILE AND ANY ASSOCIATED DOCUMENTATION IS PROVIDED "AS IS" WITHOUT 
-- WARRANTY OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
-- TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A 
-- PARTICULAR PURPOSE.  The user assumes the entire risk as to the accuracy 
-- and the use of this file.  
--  
-- Ada version Copyright (c) Intermetrics, Inc. 1994 
-- Royalty-free, unlimited, worldwide, non-exclusive use, modification, 
-- reproduction and further distribution of this Ada file is permitted. 
--
-- C version contains additional copyrights, 
-- see the accompanying file MrmPublic.h.
-- --------------------------------------------------------------------------

--  * MRM typedefs
--  
--  * MRM primitive types
--  
with Interfaces.C;
with X;
with X.Strings;
with X.Xlib;
with Xt.Intrinsic;

package Mrm.MrmPublic is

    function "&"(S: Interfaces.C.Char_Array; C: Interfaces.C.Char)
	return Interfaces.C.Char_Array renames Interfaces.C."&";
    --  
    --  * (c) Copyright 1989, 1990, 1991, 1992 OPEN SOFTWARE FOUNDATION, INC. 
    --  * ALL RIGHTS RESERVED 
    --  
    --  * Motif Release 1.2
    --    $RCSfile: MrmPublic.h,v $ $Revision: 1.5.2.2 $ $Date: 1992/04/06 20:17:41 $ 
    -- *  (c) Copyright 1989, 1990, DIGITAL EQUIPMENT CORPORATION, MAYNARD, MASS. 
    MrmPublic                           : constant Boolean := True;
                                             -- /usr/include/Mrm/MrmPublic.h:14
    --  * Success or other non-error return codes
    --  
    MrmSUCCESS                          : constant  := 1;
                                             -- /usr/include/Mrm/MrmPublic.h:21
    MrmCREATE_NEW                       : constant  := 3;
                                             -- /usr/include/Mrm/MrmPublic.h:22
    MrmINDEX_RETRY                      : constant  := 5;       -- Retry on entering index required 
    MrmINDEX_GT                         : constant  := 7;       -- Index orders greater-than entry 
    MrmINDEX_LT                         : constant  := 9;       -- Index orders less-than entry 
    MrmPARTIAL_SUCCESS                  : constant  := 11;      -- operation partly succeeded 
    --  * Failure return codes
    --  
    MrmFAILURE                          : constant  := 0;
                                             -- /usr/include/Mrm/MrmPublic.h:31
    MrmNOT_FOUND                        : constant  := 2;
                                             -- /usr/include/Mrm/MrmPublic.h:32
    MrmEXISTS                           : constant  := 4;
                                             -- /usr/include/Mrm/MrmPublic.h:33
    MrmNUL_GROUP                        : constant  := 6;
                                             -- /usr/include/Mrm/MrmPublic.h:34
    MrmNUL_TYPE                         : constant  := 8;
                                             -- /usr/include/Mrm/MrmPublic.h:35
    MrmWRONG_GROUP                      : constant  := 10;
                                             -- /usr/include/Mrm/MrmPublic.h:36
    MrmWRONG_TYPE                       : constant  := 12;
                                             -- /usr/include/Mrm/MrmPublic.h:37
    MrmOUT_OF_RANGE                     : constant  := 14;      -- Record number too big 
    MrmBAD_RECORD                       : constant  := 16;      -- Record number wrong type 
    MrmNULL_DATA                        : constant  := 18;      -- No data for entry 
    MrmBAD_DATA_INDEX                   : constant  := 20;      -- Data index in RID out of range 
    MrmBAD_ORDER                        : constant  := 22;      -- Bad ordering specifier 
    MrmBAD_CONTEXT                      : constant  := 24;      -- Invalid Mrm context 
    MrmNOT_VALID                        : constant  := 26;      -- Validation failure 
    MrmBAD_BTREE                        : constant  := 28;      -- GT/LT pointer error in BTree 
    MrmBAD_WIDGET_REC                   : constant  := 30;      -- Validation failure on widget record 
--
    MrmBAD_CLASS_TYPE                   : constant  := 32;      -- Class type not a valid Mrmwc... value 
--
    MrmNO_CLASS_NAME                    : constant  := 34;      -- User class name is null 
    MrmTOO_MANY                         : constant  := 36;      -- Too many entries requested in some 
--list 
    MrmBAD_IF_MODULE                    : constant  := 38;      -- invalid interface module 
    MrmNULL_DESC                        : constant  := 40;      -- Arglist or children descriptor null 
--
    MrmOUT_OF_BOUNDS                    : constant  := 42;      -- Argument index out of arglist bounds 
--
    MrmBAD_COMPRESS                     : constant  := 44;      -- Invalid compression code 
    MrmBAD_ARG_TYPE                     : constant  := 46;      -- Invalid type, not in RGMrType... 
    MrmNOT_IMP                          : constant  := 48;      -- Not yet implemented 
    MrmNULL_INDEX                       : constant  := 50;      -- empty index string 
    MrmBAD_KEY_TYPE                     : constant  := 52;      -- key must be MrmrIndex or MrmrRID 
    MrmBAD_CALLBACK                     : constant  := 54;      -- Invalid callback descriptor 
    MrmNULL_ROUTINE                     : constant  := 56;      -- Empty callback routine name string 
--
    MrmVEC_TOO_BIG                      : constant  := 58;      -- too many elements in vector 
    MrmBAD_HIERARCHY                    : constant  := 60;      -- invalid Mrm file hierarchy 
    MrmBAD_CLASS_CODE                   : constant  := 62;      -- Class code not found in Mrmwc... 
    MrmDISPLAY_NOT_OPENED               : constant  := 63;      -- Display not yet created 
    MrmEOF                              : constant  := 64;      -- End of file 
    MrmUNRESOLVED_REFS                  : constant  := 65;      -- Unresolved widget refs in callback
    --  * Definitions associated with widget representations
    --  
    --  * Define the creation callback
    --  
    subtype Char_Array is Interfaces.C.Char_Array;
    Nul : X.Char renames Interfaces.C.Nul;

    MrmNcreateCallback                  : constant Interfaces.C.Char_Array := 
					  "createCallback" & Nul;
                                             -- /usr/include/Mrm/MrmPublic.h:75
    --  BEGIN OSF Fix pir 2813 
    --  END OSF Fix pir 2813 
    --  * Code for unknown (user-defined) classes.
    --  
    MrmwcUnknown                        : constant  := 1;
                                             -- /usr/include/Mrm/MrmPublic.h:83
    --  * The data types of values stored in uid files.
    --  
    MrmRtypeMin                         : constant  := 1;
                                             -- /usr/include/Mrm/MrmPublic.h:89
    MrmRtypeInteger                     : constant  := 1;       -- int 
    MrmRtypeBoolean                     : constant  := 2;
                                             -- /usr/include/Mrm/MrmPublic.h:91
    MrmRtypeChar8                       : constant  := 3;       -- a nul-terminated string 
    MrmRtypeChar8Vector                 : constant  := 4;       -- a vector of char_8 strings 
    MrmRtypeCString                     : constant  := 5;       -- a compound string (DDIS) 
    MrmRtypeCStringVector               : constant  := 6;       -- a vector of compound strings 
    MrmRtypeFloat                       : constant  := 7;
                                             -- /usr/include/Mrm/MrmPublic.h:96
    --  8 = TypeCompressed now unused 
    MrmRtypeCallback                    : constant  := 9;       -- code for a callback descriptor 
    MrmRtypePixmapImage                 : constant  := 10;      -- Pixmap in image form 
    MrmRtypePixmapDDIF                  : constant  := 11;      -- Pixmap in DDIF form 
    MrmRtypeResource                    : constant  := 12;      -- Mrm resource descriptor 
    MrmRtypeNull                        : constant  := 13;      -- no value given 
    MrmRtypeAddrName                    : constant  := 14;      -- nul-terminated string to be
                                                                -- interpreted as runtime address 
    MrmRtypeIconImage                   : constant  := 15;      -- icon image 
    MrmRtypeFont                        : constant  := 16;      -- Mrm font structure 
    MrmRtypeFontList                    : constant  := 17;      -- Mrm font list 
    MrmRtypeColor                       : constant  := 18;      -- Mrm color descriptor 
    MrmRtypeColorTable                  : constant  := 19;      -- Mrm color table 
    MrmRtypeAny                         : constant  := 20;      -- Any is allowed in UID file 
    MrmRtypeTransTable                  : constant  := 21;      -- Translation table (ASCIZ string) 
    MrmRtypeClassRecName                : constant  := 22;      -- class record name (ASCIZ string) 
    MrmRtypeIntegerVector               : constant  := 23;      -- a vector of integers 
    MrmRtypeXBitmapFile                 : constant  := 24;      -- X bitmap file to make pixmap with 
--
    MrmRtypeCountedVector               : constant  := 25;      -- vector with associated count 
    MrmRtypeKeysym                      : constant  := 26;      -- X keysym data type 
    MrmRtypeSingleFloat                 : constant  := 27;      -- single float data type 
    MrmRtypeWideCharacter               : constant  := 28;      -- wide_character string type 
    MrmRtypeFontSet                     : constant  := 29;
                                            -- /usr/include/Mrm/MrmPublic.h:119
    MrmRtypeMax                         : constant  := 30;
                                            -- /usr/include/Mrm/MrmPublic.h:120
    MrmMaxResourceSize                  : constant  := 65535;   -- (2)16 - 1 
    --  * Operating System specific parameter struct.  Passed to low level
    --  * file OPEN.
    --  
    MrmOsOpenParamVersion               : constant  := 1;
                                            -- /usr/include/Mrm/MrmPublic.h:148
    --  * Code for unknown (user-defined) classes. 
    --  
    URMwcUnknown                        : constant  := 1;
                                            -- /usr/include/Mrm/MrmPublic.h:193

    type MrmCode is new X.short;                             -- Used for codes, e.g. Mrmcr... 
                                            -- /usr/include/Mrm/MrmPublic.h:131
    type MrmSCode is new X.unsigned_char;                    -- Short code for small ranges 
                                            -- /usr/include/Mrm/MrmPublic.h:132
    type MrmOffset is new X.unsigned_short;                  -- Used for offsets in records 
                                            -- /usr/include/Mrm/MrmPublic.h:133
    type MrmType is new X.short;                             -- Used for types, e.g. MrmrType... 
                                            -- /usr/include/Mrm/MrmPublic.h:134
    type MrmSize is new X.unsigned_short;                    -- For size fields 
                                            -- /usr/include/Mrm/MrmPublic.h:135
    type MrmCount is new X.short;                            -- For counter fields 
                                            -- /usr/include/Mrm/MrmPublic.h:136
    type MrmFlag is new X.unsigned_char;                     -- flag fields 
                                            -- /usr/include/Mrm/MrmPublic.h:137
    type MrmResource_id is new X.long;                       -- Resource id in IDB files 
                                            -- /usr/include/Mrm/MrmPublic.h:138
    type MrmGroup is new X.short;                            -- For Mrm resource groups 
                                            -- /usr/include/Mrm/MrmPublic.h:139

    type union_anonymous0_t;                -- /usr/include/Mrm/MrmPublic.h:165
    type MrmOsOpenParam;                    -- /usr/include/Mrm/MrmPublic.h:173
    type MRMRegisterArg;                    -- /usr/include/Mrm/MrmPublic.h:188

    type MrmOsOpenParam_access is access all MrmOsOpenParam;
                                            -- /usr/include/Mrm/MrmPublic.h:173
    type MrmOsOpenParamPtr is access all MrmOsOpenParam;
                                            -- /usr/include/Mrm/MrmPublic.h:173
                                            -- /usr/include/Mrm/MrmPublic.h:178
    -- type MrmHierarchy is access all struct_MrmHierarchyDescStruct;
    type MrmHierarchy is private;
                                            -- /usr/include/Mrm/MrmPublic.h:178
                                            -- /usr/include/Mrm/MrmPublic.h:188
    type MrmRegisterArglist is access all MRMRegisterArg;
                                            -- /usr/include/Mrm/MrmPublic.h:188

    type union_anonymous0_t_kind is (       -- /usr/include/Mrm/MrmPublic.h:165
        related_nam_kind,
        clobber_flg_kind
    );

    type union_anonymous0_t (Which: union_anonymous0_t_kind := related_nam_kind) is
                                            -- /usr/include/Mrm/MrmPublic.h:165
        record
            case Which is
                when related_nam_kind =>
                    related_nam
                       : aliased X.unsigned_long;
                                            -- /usr/include/Mrm/MrmPublic.h:163
                when clobber_flg_kind =>
                    clobber_flg
                       : aliased Xt.Intrinsic.Boolean;
                                            -- /usr/include/Mrm/MrmPublic.h:164
            end case;
        end record;

    pragma Convention(C, union_anonymous0_t);
--     pragma Unchecked_Union(union_anonymous0_t);

    type MrmOsOpenParam is                  -- /usr/include/Mrm/MrmPublic.h:173
        record
            version      : aliased Xt.Intrinsic.Cardinal;
                                            -- /usr/include/Mrm/MrmPublic.h:153
            default_fname: aliased X.Strings.charp;
                                            -- /usr/include/Mrm/MrmPublic.h:157
            nam_flg      : union_anonymous0_t;
                                            -- /usr/include/Mrm/MrmPublic.h:165
            display      : aliased X.Xlib.XDisplay_access;
                                            -- /usr/include/Mrm/MrmPublic.h:171
        end record;


    type MRMRegisterArg is                  -- /usr/include/Mrm/MrmPublic.h:188
        record
            name : aliased X.Strings.charp;                 -- case-sensitive name 
            value: aliased Xt.Intrinsic.XtPointer;              -- value/address associated with name 
--
        end record;


    subtype MrmRegisterArg_c0 is MRMRegisterArg;
                                            -- /usr/include/Mrm/MrmPublic.h:188

private
    type MrmHierarchy is access all Integer;
end Mrm.MrmPublic;
--  
--  * (c) Copyright 1989, 1990, 1991, 1992 OPEN SOFTWARE FOUNDATION, INC. 
--  * ALL RIGHTS RESERVED 
--  
--  * Motif Release 1.2
--    $RCSfile: MrmPublic.h,v $ $Revision: 1.5.2.2 $ $Date: 1992/04/06 20:17:41 $ 
-- *  (c) Copyright 1989, 1990, DIGITAL EQUIPMENT CORPORATION, MAYNARD, MASS. 
--  DON'T ADD STUFF AFTER THIS #endif 
